package Core.CubeConfiguration;

import java.text.DecimalFormat;

public class MeasureType
{

    public MeasureType()
    {
        completed = false;
        format = "";
        srcField = "";
        summarizeBy = "";
        dataFieldName = "";
        tableName = "";
    }

    public MeasureType(String string, String typeName, String tblName, String priKeyColName)
    {
        completed = false;
        format = "";
        srcField = "";
        summarizeBy = "";
        dataFieldName = "";
        tableName = "";
        setSourceField(string);
        dataTypeName = typeName;
        tableName = tblName;
        this.priKeyColName = priKeyColName;
    }

    public MeasureType(String string, int sqlDataType, String tblName)
    {
        completed = false;
        format = "";
        srcField = "";
        summarizeBy = "";
        dataFieldName = "";
        tableName = "";
        setSourceField(string);
        switch(sqlDataType)
        {
        case 12: // '\f'
            dataTypeName = DATATYPE_VALUES[0];
            break;

        case -5: 
        case 2: // '\002'
        case 4: // '\004'
            dataTypeName = DATATYPE_VALUES[2];
            break;

        case 3: // '\003'
        case 6: // '\006'
        case 8: // '\b'
            dataTypeName = DATATYPE_VALUES[1];
            break;

        case 91: // '['
        case 92: // '\\'
        case 93: // ']'
            dataTypeName = DATATYPE_VALUES[0];
            break;

        default:
            dataTypeName = DATATYPE_VALUES[0];
            break;
        }
        tableName = tblName;
        
    }

    public boolean isCompleted()
    {
        return completed;
    }

    public String getSourceField()
    {
        return srcField;
    }

    public String getSummarizeBy()
    {
        return summarizeBy;
    }

    public String getDataFieldName()
    {
        return dataFieldName;
    }

    public void setCompleted(boolean b)
    {
        completed = b;
    }

    public void setSourceField(String string)
    {
        srcField = string;
    }

    public void setSummarizeBy(String string)
    {
        summarizeBy = string;
    }

    public void setDataFieldName(String dataFldNm)
    {
        dataFieldName = dataFldNm;
    }

    public String getFormat()
    {
        return format;
    }

    public void setFormat(String format)
    {
        this.format = format;
    }

    public String getTypeName()
    {
        return dataTypeName;
    }

    public void setTypeName(String typeName)
    {
        dataTypeName = typeName;
    }

    public String getTableName()
    {
        return tableName;
    }

    public void setTableName(String tableName)
    {
        this.tableName = tableName;
    }

    @Override
    public String toString()
    {
        return getSourceField();
    }

    public String getPriKeyColName()
    {
        return priKeyColName;
    }

    public void setPriKeyColName(String priKeyColName)
    {
        this.priKeyColName = priKeyColName;
    }

    public static String getFormat(int dataType)
    {
        String format = FORMAT_ARRAY[0];
        switch(dataType)
        {
        case 12: // '\f'
            format = FORMAT_ARRAY[1];
            break;

        case -5: 
        case 2: // '\002'
        case 4: // '\004'
            format = FORMAT_ARRAY[1];
            break;

        case 3: // '\003'
        case 6: // '\006'
        case 8: // '\b'
            format = FORMAT_ARRAY[2];
            break;

        case 91: // '['
        case 92: // '\\'
        case 93: // ']'
            format = FORMAT_ARRAY[1];
            break;

        default:
            format = FORMAT_ARRAY[0];
            break;
        }
        return format;
    }

    static final String AGG_FUNCS_ARRAY[] = {
        "SUM", "AVG", "COUNT", "MIN", "MAX"
    };
    static final String DATATYPE_VALUES[] = {
        "String", "Numeric", "Integer"
    };
    static String FORMAT_ARRAY[];
    private boolean completed;
    private String format;
    private String srcField;
    private String summarizeBy;
    private String dataFieldName;
    private String dataTypeName;
    private String tableName;
    private String priKeyColName;

    static 
    {
        FORMAT_ARRAY = null;
        DecimalFormat decimalFmt = new DecimalFormat();
        DecimalFormat intFmt = new DecimalFormat();
        intFmt.setMaximumFractionDigits(0);
        FORMAT_ARRAY = new String[3];
        FORMAT_ARRAY[0] = "Standard";
        FORMAT_ARRAY[1] = intFmt.toLocalizedPattern();
        FORMAT_ARRAY[2] = decimalFmt.toLocalizedPattern();
    }
}