package Core.operations;

import Core.member.InterfaceMember;
import Core.member.MyNodeMember;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member;

/**
 *
 * @author Ricardo
 */
public class DrillDown {
    //Clase encargada de realizar el Drill Down
    //Recibe como parametro el constructor el vector de Miembros
    Vector vectorMain;
    boolean bandera=true;
    InterfaceMember interfaceMember;
    public DrillDown(Vector vectorMain, int dimension, int member) {
        this.vectorMain=vectorMain;
        this.interfaceMember=new InterfaceMember(vectorMain);
        if((interfaceMember.getMyNodeMember(dimension, member).getMember().getChildMemberCount())>0)
            this.vectorMain=operations2(dimension,member);
        else
            this.bandera=false;
    }
    public boolean getBandera(){
        return this.bandera;
    }
    public Vector getVectorMain() {
        return this.vectorMain;
    }

    private Vector operations(int dimension, int member) {
        Vector vector=null;//este sera el vector final a retornar por esta funcion
        try {
            vector = new Vector();
            //primero copiamos las dimensiones que no tocaremos
            for (int i = 0; i < dimension; i++) {                
                vector.add((Vector) vectorMain.get(i));
            }
            //segundo llenamos el Vector correspondiente a la dimension con los miembros de la izquierda
            Vector vectorAuxiliar2 = new Vector();
            for (int i = 0; i < member; i++) {                
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            //tercero llenamos la dimension en cuestion con el father y los children del mismo
            vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, member));
            List<? extends Member> memberList = interfaceMember.getMyNodeMember(dimension, member).getMember().getChildMembers();            
            for(int i=0;i<memberList.size();i++){//obtenemos los children de member, les colocamos el father de member
                //y los llenamos en el vector de la dimension correspondiente
                MyNodeMember myNodeMember=new MyNodeMember(memberList.get(i));
                myNodeMember.setFather(interfaceMember.getMyNodeMember(dimension, member).getFather());
                vectorAuxiliar2.add(myNodeMember);               
            }
            //cuarto terminamos llenando la dimension en cuestion con los miembros de la derecha del miembro en cuestion
            for(int i=member+1;i<interfaceMember.getNumMember(dimension);i++){
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            vector.add(vectorAuxiliar2);//anexamos al vector Principal la dimension en cuestion
            //por ultimo completamos el vector con las dimensiones restantes
            int childrenNumber=memberList.size()+1;
            int fatherNumberAux=1;
            int fatherNumber;
            int fatherPosicionAux=member;
            int fatherPosicion;
            for(int i=dimension+1;i<interfaceMember.getNumDimension();i++){
                fatherPosicion=fatherPosicionAux;                
                fatherNumber=fatherNumberAux;
                fatherNumberAux=0;
                //primero encontramos cual va a ser el primer padre para el siguiente nivel si lo hay
                for(int var=0;var<interfaceMember.getNumMember(i);var++){
                     if(interfaceMember.getMyNodeMember(i, var).getFather()==fatherPosicion){
                        fatherPosicionAux=var;
                        break;
                        //var=interfaceMember.getNumMember(i);//esto es hacer un break pero a pata
                     }//asi garantizamo que se coja al primer padre
                }
                Vector vectorAuxiliar3=new Vector();              
                //segundo llenamos el nuevo vector de dimension con los elementos a la izquierda de los hijos 
                //del elemento en cuestion (el elemento a expandirse)
                for (int vA3 = 0; vA3 < fatherPosicionAux; vA3++) {
                    //llenamos el Vector correspondiente a la dimension con los miembros de la izquierda
                    vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, vA3));
                }                                
                //tercero llenamos un Vector vectorAux con los elementos que son hijos de el miembro en cuestion
                //despues del primer ciclo se llenara dicho vector con los nietos, bisnietos...
                Vector vectorAux=new Vector();
                for(int j=0;j<fatherNumber;j++){
                    for(int k=0;k<interfaceMember.getNumMember(i);k++){
                        if(interfaceMember.getMyNodeMember(i, k).getFather()==fatherPosicion){
                            fatherNumberAux++;
                            vectorAux.add(interfaceMember.getMyNodeMember(i, k));
                        }
                    }
                    fatherPosicion++;
                }
                //cuarto llenamos el vetor de dimension con los miembros de el Vector vectorAux tantas veces
                //como lo indique childrenNumber que es el numero de hijos de el miembro expandido
                for(int h=0;h<childrenNumber;h++){
                    for(int r=0;r<vectorAux.size();r++){
                        MyNodeMember myNodeMember=new MyNodeMember(((MyNodeMember)vectorAux.get(r)).getMember());
                        myNodeMember.setFather(myNodeMember.getFather()+h+fatherPosicionAux);
                        vectorAuxiliar3.add(myNodeMember);
                    }
                }
                //quinto llenamos los miembros que estan a la derecha de dicho conjunto de miembros
                fatherNumberAux=fatherNumberAux*childrenNumber;

                for (int vA2 = fatherPosicionAux+1; vA2 < interfaceMember.getNumMember(i); vA2++) {
                    MyNodeMember myNodeMember=interfaceMember.getMyNodeMember(i, vA2);
                    int padre=myNodeMember.getFather()+fatherNumberAux-1;
                    myNodeMember.setFather(padre);
                    vectorAuxiliar3.add(myNodeMember);
                }
                //finalmente (casi que no), adicionamos la dimension al vector de dimensiones
                vector.add(vectorAuxiliar3);
            }
        } catch (OlapException ex) {
            Logger.getLogger(RollUp.class.getName()).log(Level.SEVERE, null, ex);
        }
        //imprimirVector(vector);
        return vector;
    }
    
    private Vector operations2(int dimension, int member) {
        Vector vector=null;//este sera el vector final a retornar por esta funcion
        try {
            vector = new Vector();
            //primero copiamos las dimensiones que no tocaremos
            for (int i = 0; i < dimension; i++) {                
                vector.add((Vector) vectorMain.get(i));
            }
            //segundo llenamos el Vector correspondiente a la dimension con los miembros de la izquierda
            Vector vectorAuxiliar2 = new Vector();
            for (int i = 0; i < member; i++) {                
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            //tercero llenamos la dimension en cuestion con el father y los children del mismo
            vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, member));
            List<? extends Member> memberList = interfaceMember.getMyNodeMember(dimension, member).getMember().getChildMembers();            
            for(int i=0;i<memberList.size();i++){//obtenemos los children de member, les colocamos el father de member
                //y los llenamos en el vector de la dimension correspondiente
                MyNodeMember myNodeMember=new MyNodeMember(memberList.get(i));
                myNodeMember.setFather(interfaceMember.getMyNodeMember(dimension, member).getFather());
                vectorAuxiliar2.add(myNodeMember);               
            }
            //cuarto terminamos llenando la dimension en cuestion con los miembros de la derecha del miembro en cuestion
            for(int i=member+1;i<interfaceMember.getNumMember(dimension);i++){
                vectorAuxiliar2.add(interfaceMember.getMyNodeMember(dimension, i));
            }
            vector.add(vectorAuxiliar2);//anexamos al vector Principal la dimension en cuestion
            //por ultimo completamos el vector con las dimensiones restantes
            int childrenNumber=memberList.size();            
            int numeroElementos=1;int numeroElementosNuevo;
            int numeroPosicionPrimerPadre=member;
            int primerElemento=0;//igual a cero solo para inicializarlo
            for(int i=dimension+1;i<interfaceMember.getNumDimension();i++){
                 numeroElementosNuevo=0;
                //primero encontramos cual va a ser el primer padre para el siguiente nivel si lo hay
                for(int var=0;var<interfaceMember.getNumMember(i);var++){
                     if(interfaceMember.getMyNodeMember(i, var).getFather()==numeroPosicionPrimerPadre){
                        primerElemento=var;
                        break;
                        //var=interfaceMember.getNumMember(i);//esto es hacer un break pero a pata
                     }//asi garantizamo que se coja al primer padre
                }
                Vector vectorAuxiliar3=new Vector();              
                //segundo llenamos el nuevo vector de dimension con los elementos a la izquierda de los hijos 
                //del elemento en cuestion (el elemento a expandirse)
                for (int vA3 = 0; vA3 < primerElemento; vA3++) {
                    //llenamos el Vector correspondiente a la dimension con los miembros de la izquierda
                    vectorAuxiliar3.add(interfaceMember.getMyNodeMember(i, vA3));
                }                                
                //tercero llenamos un Vector vectorAux con los elementos que son hijos de el miembro en cuestion
                //despues del primer ciclo se llenara dicho vector con los nietos, bisnietos...                
                for(int j=0;j<numeroElementos;j++){
                    for(int k=0;k<interfaceMember.getNumMember(i);k++){
                        if(interfaceMember.getMyNodeMember(i, k).getFather()==numeroPosicionPrimerPadre){
                            numeroElementosNuevo++;
                        }
                    }
                    numeroPosicionPrimerPadre++;
                }
                MyNodeMember myNodeMemberVector[]=new MyNodeMember[numeroElementosNuevo];

                int rr=0;
                for(int h=primerElemento;h<numeroElementosNuevo+primerElemento;h++)
                {
                    myNodeMemberVector[rr]=interfaceMember.getMyNodeMember(i, h);
                    rr++;
                }
                
                //cuarto llenamos el vetor de dimension con los miembros de el Vector vectorAux tantas veces
                //como lo indique childrenNumber que es el numero de hijos de el miembro expandido                
                int padreASumar=numeroElementos;
                for(int h=0;h<childrenNumber+1;h++){
                    for(int r=0;r<numeroElementosNuevo;r++){                        
                        MyNodeMember myNodeMember=(MyNodeMember) myNodeMemberVector[r].clone();
                        int padre=myNodeMember.getFather();
                        myNodeMember.setFather(padre+(padreASumar*h)); 
                        vectorAuxiliar3.add(myNodeMember);
                    }
                }
                //quinto llenamos los miembros que estan a la derecha de dicho conjunto de miembros
                int multiplicador=numeroElementos*childrenNumber;

                for (int vA3 = primerElemento+numeroElementosNuevo; vA3 < interfaceMember.getNumMember(i); vA3++) {
                    MyNodeMember myNodeMember=interfaceMember.getMyNodeMember(i, vA3);
                    int padre=myNodeMember.getFather()+multiplicador;
                    myNodeMember.setFather(padre);
                    vectorAuxiliar3.add(myNodeMember);
                }
                //finalmente (casi que no), adicionamos la dimension al vector de dimensiones
                vector.add(vectorAuxiliar3);                
                numeroPosicionPrimerPadre=primerElemento;
                numeroElementos=numeroElementosNuevo;
            }
        } catch (OlapException ex) {
            Logger.getLogger(RollUp.class.getName()).log(Level.SEVERE, null, ex);
        }
        //imprimirVector(vector);
        return vector;
    }
    public void imprimirVector(Vector vector){
        for(int i=0;i<vector.size();i++){
            for(int j=0;j<((Vector)vector.get(i)).size();j++){
                System.out.println("nivel: "+i+" miembro:"+j+" "+((MyNodeMember)((Vector)vector.get(i)).get(j)).getMember().getUniqueName());
                System.out.println(((MyNodeMember)((Vector)vector.get(i)).get(j)).getFather());
            }        
        }
            
            
    }


}
