package Core.queryMDX;
import java.util.ArrayList;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import org.olap4j.*;

import org.olap4j.metadata.Member;
/**
 *
 * @author Ricardo
 */
public class ExecuteQuery {
    OlapConnection connection;
    String query;
    CellSet cellSet;
    boolean exito=true;
    public ExecuteQuery(String query,OlapConnection connection){
        this.query=query;
        this.connection=connection;
        executeQuery();
    }

    public void executeQuery() {
        try {            
            OlapStatement olapStatement = connection.createStatement();            
//            MdxParserFactory parserFactory = connection.getParserFactory();            
//            MdxParser parser = parserFactory.createMdxParser(connection);            
//            SelectNode select = parser.parseSelect(query);            
//            ParseTreeNode parseTN=select.getFrom();

            //MdxValidator validator = parserFactory.createMdxValidator(connection);
            //select = validator.validateSelect(select);
            this.cellSet = olapStatement.executeOlapQuery(query);
            //imprimirQuery(cellSet);
           
        } catch (OlapException ex) {            
            System.out.println("Execution failed: ");
            JOptionPane.showMessageDialog(new JFrame(),ex.toString(),"Query error",
               JOptionPane.ERROR_MESSAGE);
            exito=false;
        }        
    }
    
    public CellSet getCellSet(){
            return this.cellSet;
    }
    public boolean getExito(){
            return this.exito;
    }

    private void imprimirQuery(CellSet cellSet) {

        // Fifth, display the Axes
        for (CellSetAxis axis : cellSet.getAxes()) {
            System.out.print(axis.getAxisOrdinal() + ": ");        
            boolean firstPos = true;
            for (Position position : axis.getPositions()) {
                if (!firstPos) {
                    System.out.print(", ");
                }
                System.out.print("{");
                boolean first = true;
                for (Member member : position.getMembers()) {
                    if (!first) {
                        System.out.print(", ");
                    }
                    System.out.print(member.getUniqueName());
                    first = false;
                }
                System.out.print("}");
                firstPos = false;
            }
            System.out.println("");
        }     

        // Finally, display the Cells
        CellSetAxis cols = cellSet.getAxes().get(0);
        CellSetAxis rows = cellSet.getAxes().get(1);
        for (int row = 0; row < rows.getPositions().size(); row++) {
            System.out.println("Row #" + (row + 1) + ":");
            for (int col = 0; col < cols.getPositions().size(); col++) {
                List positions = new ArrayList(2);
                positions.add(col);
                positions.add(row);
                Cell cell = cellSet.getCell(positions);
                System.out.println(cell.getFormattedValue());
            }
        }            
    }

}
