package Core.tree;
import Core.hierarchy.ManagementHierarchy;
import java.util.Vector;
import Core.member.ManagementMembers;
import Core.member.MyNodeMember;
import Core.operations.AddMeasureTable;
import Core.operations.DeleteMeasureTable;
import Core.operations.DeleteMember;
import Core.operations.DrillDown_RollUp;
import javax.swing.tree.DefaultTreeModel;
import org.olap4j.metadata.Member;
/**
 *
 * @author Ricardo
 */

public class TreeMain {
/**
 * En esta clase se maneja el arbol de miembros del cual se obtiene la consulta por eje
 * es decir cda eje tiene un arbol de esta clase
 */ 
    DefaultTreeModel modelo;// se almacena el modelo de este arbol
    ManagementMembers managementMember;
    ManagementHierarchy managementHierarchy;
    boolean bandera=true;
    Vector createMembers,createDimensions;
    public TreeMain(Vector createMembers, Vector createDimensions) {
        this.createDimensions=createDimensions;
        this.createMembers=createMembers;
        //se crea el arbol principal  de el eje correspondiente
        //createMembers es un Vector, que en cada indice tiene un subvector de Members[]
        //createDimensions es un Vector, que en cada indice tiene un subvector de Dimensions[]
        this.managementMember=new ManagementMembers(createMembers);//el Vector de Members[] se lo convierte en                   
        this.modelo=createTree(managementMember.getVectorMain());        
        this.managementHierarchy=new ManagementHierarchy(createDimensions);     
    }

    public void deleteMember(int dimension, int member) {
        DeleteMember deleteMember=new DeleteMember(this.managementMember.getVectorMain(),dimension,member);
        this.bandera=deleteMember.getBandera();
        if(this.bandera){
            this.managementMember.setVectorMain(deleteMember.getVectorMain());
            this.modelo=createTree(managementMember.getVectorMain());                     
        }        
    }

    public Vector getVectorMain() {
        return this.managementMember.getVectorMain();
    }
    
    private DefaultTreeModel createTree(Vector vectorMain) {
        //crea el modelo del tree a partir de el vectorMain (proporcionado por ManagementMember)
        //que luego se lo transforma en un vector similar a vectorMain pero con subsubnodos(MyDefaultMutableTreeNode)
        Vector vector=createMyDefaultTreeNodes(vectorMain);
        MyDefaultMutableTreeNode raiz=((MyDefaultMutableTreeNode[])vector.get(0))[0];//creamos como raiz el primer elemento del primer vector
        DefaultTreeModel modelo1=new DefaultTreeModel(raiz);
        for(int i=1;i<vector.size();i++){
//                for(int j=0;j<((MyDefaultMutableTreeNode[]) vector.get(i)).length;j++){
//                    int indexFather=((MyDefaultMutableTreeNode[]) vector.get(i))[j].getFather();
//                    MyDefaultMutableTreeNode father=((MyDefaultMutableTreeNode[]) vector.get(i-1))[indexFather];//me esta devolviendo la raíz
//                    MyDefaultMutableTreeNode child=((MyDefaultMutableTreeNode[]) vector.get(i))[j];
//                    modelo1.insertNodeInto(child,father, j);
//                }
                for(int j=0;j<((MyDefaultMutableTreeNode[]) vector.get(i-1)).length;j++){
                    MyDefaultMutableTreeNode father=((MyDefaultMutableTreeNode[]) vector.get(i-1))[j];
                    Vector vectorSalvacion=new Vector();
                    for(int k=0;k<((MyDefaultMutableTreeNode[]) vector.get(i)).length;k++){
                        MyDefaultMutableTreeNode child=((MyDefaultMutableTreeNode[]) vector.get(i))[k];
                        if(child.getFather()==j){
                            vectorSalvacion.add(child);
                        }                        
                    }
                    for(int k=0;k<vectorSalvacion.size();k++){
                        modelo1.insertNodeInto((MyDefaultMutableTreeNode)vectorSalvacion.get(k), father, k);
                    }                    
                }
        }
        return modelo1;
    }    
    
    private Vector createMyDefaultTreeNodes(Vector vectorMain){
        // Metodo encargado de crear el vector de MyDefaultTreeNode con el cual se crea el arbol
        //cada nodo con el indice de su padre
        Vector nodeTree=new Vector();
                
        MyNodeMember myNodeMember=(MyNodeMember)((Vector) vectorMain.get(0)).get(0);
        MyDefaultMutableTreeNode[] myDefaultMutableTreeNodeVectorPrimero= new MyDefaultMutableTreeNode[1];
        myDefaultMutableTreeNodeVectorPrimero[0]=new MyDefaultMutableTreeNode(myNodeMember.getMember());
        myDefaultMutableTreeNodeVectorPrimero[0].setFather(myNodeMember.getFather());
        nodeTree.add(myDefaultMutableTreeNodeVectorPrimero);
        
        for(int i=0;i<vectorMain.size();i++){
            MyNodeMember[] myNodeMemberVector=new MyNodeMember[((Vector) vectorMain.get(i)).size()];
            for(int j=0;j<myNodeMemberVector.length;j++){//creamos el vector de MyNodeMember a partir de vectorMain(i)
                myNodeMemberVector[j]=(MyNodeMember)((Vector)vectorMain.get(i)).get(j);                                    
            }
            MyDefaultMutableTreeNode[] myDefaultMutableTreeNodeVector= new MyDefaultMutableTreeNode[myNodeMemberVector.length];
            for(int j=0;j<myDefaultMutableTreeNodeVector.length;j++){
                myDefaultMutableTreeNodeVector[j]=new MyDefaultMutableTreeNode(myNodeMemberVector[j].getMember());
                myDefaultMutableTreeNodeVector[j].setFather(myNodeMemberVector[j].getFather());
            }
            nodeTree.add(myDefaultMutableTreeNodeVector);
        }        
        imprimirVectorMyDefaultMutableTreeNode(nodeTree);
        return nodeTree;                
    }      
    
    public DefaultTreeModel getModelo(){
        return this.modelo;
    }
    
    public void imprimirArbol(MyDefaultMutableTreeNode nodo){
        System.out.println(nodo.father+": "+nodo.getUniqueName());
        if(nodo.getChildCount()>0){
            for(int i=0;i<nodo.getChildCount();i++){
                imprimirArbol((MyDefaultMutableTreeNode) nodo.getChildAt(i));
            }
        }
    }       

    public void imprimirVectorMyDefaultMutableTreeNode(Vector vector){
        for(int i=0;i<vector.size();i++){
            for(int j=0;j<((MyDefaultMutableTreeNode[])vector.get(i)).length;j++){
                System.out.println("nivel: "+i+" miembro:"+j+" "+((MyDefaultMutableTreeNode)((MyDefaultMutableTreeNode[])vector.get(i))[j]).getMiembro().getUniqueName());
                System.out.println(((MyDefaultMutableTreeNode)((MyDefaultMutableTreeNode[])vector.get(i))[j]).getFather());
            }        
        }    
    }
          
    //operaciones que se pueden realizar en cada eje, osea en el arbol de cada eje
    public void drillDown_RollUp(int dimension, int member){
        //se necesita mandar el vector de Miembros asociado al tree, y los indices de la dimension y el miembro
        //a realizar esta operacion
        //y recibe de vuelta un vector de miembros ya con la operacion realizada, inmediatamente pasa esto
        //se actualiza el arbol
        DrillDown_RollUp drillDown_RollUp=new DrillDown_RollUp(managementMember.getVectorMain(),dimension,member);
        this.bandera=drillDown_RollUp.getBandera();
        if(this.bandera){
            this.managementMember.setVectorMain(drillDown_RollUp.getVectorMain());
            this.modelo=createTree(managementMember.getVectorMain());                     
        }
//        managementMember.setVectorMain(drillDown_RollUp.getVectorMain());
//        this.modelo=createTree(managementMember.getVectorMain()); 
    }
    
    public void addMeasure(Member measure) {
        AddMeasureTable addMeasureTable=new AddMeasureTable(managementMember.getVectorMain(),measure);
        this.managementMember.setVectorMain(addMeasureTable.getVectorMain());
        this.modelo=createTree(managementMember.getVectorMain());        
    }

    public void deleteMeasure(Member measure) {
        DeleteMeasureTable deleteMeasureTable=new DeleteMeasureTable(managementMember.getVectorMain(),measure);
        this.managementMember.setVectorMain(deleteMeasureTable.getVectorMain());
        this.modelo=createTree(managementMember.getVectorMain());        
    }    
    
    public boolean getBandera(){
        return this.bandera;
    }    
    
    //metodo para la operacion slice
    public Vector getVectorHierarchy(){
        return this.managementHierarchy.getVectorHierarchy();
    }    
    public void setVectorMain(Vector vectorMain){
        this.managementMember.setVectorMain(vectorMain);
        this.modelo=createTree(managementMember.getVectorMain());                     
    }
}
