
package WorkSpace.Dice;

import WorkSpace.MainApp;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.plaf.ColorUIResource;

public class CheckRenderer extends JPanel implements TreeCellRenderer {
  protected JRadioButton check;
  TreeLabel label;
   ImageIcon cube =createImageIcon("resources/rubik.jpg"); 
     ImageIcon dimension =createImageIcon("resources/dimension.jpg"); 
     ImageIcon jerarquia =createImageIcon("resources/hierarchy.png"); 
     ImageIcon all =createImageIcon("resources/nivel.gif"); 
     ImageIcon member =createImageIcon("resources/Member.png");
  public CheckRenderer() {     
     setLayout(null);
     add(check = new JRadioButton());   
     add(label = new TreeLabel());      
  }

  public Component getTreeCellRendererComponent(JTree tree, Object value,
               boolean isSelected, boolean expanded,
               boolean leaf, int row, boolean hasFocus) {     
    
    check.setBackground(UIManager.getColor("Tree.textBackground"));
    String  stringValue = tree.convertValueToText(value, isSelected,
			expanded, leaf, row, hasFocus);
    setEnabled(tree.isEnabled());
    check.setSelected(((CheckNode)value).isSelected());
    label.setFont(tree.getFont());
    label.setText(stringValue);
    label.setSelected(isSelected);
    label.setFocus(hasFocus);
    if (leaf) {
      label.setIcon(UIManager.getIcon("Tree.leafIcon"));
    } else if (expanded) {
      label.setIcon(UIManager.getIcon("Tree.openIcon"));
    } else {
      label.setIcon(UIManager.getIcon("Tree.closedIcon"));
    }	    
          if (!tree.isEnabled()) {
            setEnabled(false);
        }
        else {
            setEnabled(true);
        }

         switch(((DefaultMutableTreeNode)value).getLevel()){                 
        case 0:
            label.setIcon(cube);
            check.setVisible(false);
            check.setEnabled(false);
            break;
        case 1:
           label.setIcon(dimension);
            check.setVisible(false);
            check.setEnabled(false);
            break;
        case 2:
            label.setIcon(jerarquia);
            check.setVisible(false);
            check.setEnabled(false); 
                break;
        case 3:
            label.setIcon(all);
            check.setVisible(false);
            check.setEnabled(false); 
                break;
         default: label.setIcon(member);
                check.setVisible(true); 
                check.setEnabled(true);
                break;

        }
      setComponentOrientation(tree.getComponentOrientation());                	
return this;
  }
  
    @Override
  public Dimension getPreferredSize() {
    Dimension d_check = check.getPreferredSize();
    Dimension d_label = label.getPreferredSize();
    return new Dimension(d_check.width  + d_label.width,
      (d_check.height < d_label.height ?
       d_label.height : d_check.height));
  }
  
    @Override
  public void doLayout() {
    Dimension d_check = check.getPreferredSize();
    Dimension d_label = label.getPreferredSize();
    int y_check = 0;
    int y_label = 0;
    if (d_check.height < d_label.height) {
      y_check = (d_label.height - d_check.height)/2;
    } else {
      y_label = (d_check.height - d_label.height)/2;
    }
    check.setLocation(0,y_check);
    check.setBounds(0,y_check,d_check.width,d_check.height);
    label.setLocation(d_check.width,y_label);    
    label.setBounds(d_check.width,y_label,d_label.width,d_label.height);    
  }
   
  
    @Override
  public void setBackground(Color color) {
    if (color instanceof ColorUIResource)
      color = null;
    super.setBackground(color);
  }
  
    
  class TreeLabel extends JLabel {
    boolean isSelected;
    boolean hasFocus;
    
    TreeLabel() {
    }
        
        @Override
    public void setBackground(Color color) {
	if(color instanceof ColorUIResource)
	    color = null;
	super.setBackground(color);
    } 
         
        @Override
    public void paint(Graphics g) {
      String str;
      if ((str = getText()) != null) {
        if (0 < str.length()) {
          if (isSelected) {
            g.setColor(UIManager.getColor("Tree.selectionBackground"));
          } else {
            g.setColor(UIManager.getColor("Tree.textBackground"));
          }
          Dimension d = getPreferredSize();
          int imageOffset = 0;
          Icon currentI = getIcon();
          if (currentI != null) {
            imageOffset = currentI.getIconWidth() + Math.max(0, getIconTextGap() - 1);
          }
          g.fillRect(imageOffset, 0, d.width -1 - imageOffset, d.height);
          if (hasFocus) {
            g.setColor(UIManager.getColor("Tree.selectionBorderColor"));
            g.drawRect(imageOffset, 0, d.width -1 - imageOffset, d.height -1);     
         }
        }
      }
      super.paint(g);
    }
  
    public Dimension getPreferredSize() {
      Dimension retDimension = super.getPreferredSize();
      if (retDimension != null) {
        retDimension = new Dimension(retDimension.width + 3,
				 retDimension.height);
      }
      return retDimension;
    }
    
    void setSelected(boolean isSelected) {
      this.isSelected = isSelected;
    }
    
    void setFocus(boolean hasFocus) {
      this.hasFocus = hasFocus;
    }
  }
     private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
}    
