/*
 * Navigator.java
 *
 * Created on 11 de diciembre de 2008, 16:28
 */

package WorkSpace.Navigator;

import Core.ManagerCube.Manager;
import Core.main.Core;
import WorkSpace.Navigator.CubeCellRenderer;
import WorkSpace.Dice.DiceCube;
import WorkSpace.MainApp;
import WorkSpace.Measures.Measures;
import java.util.Enumeration;
import javax.swing.*;
import javax.swing.tree.*;
import org.olap4j.OlapConnection;
/**
 *
 * @author  Alexander
 */
public class Navigator extends javax.swing.JPanel {
     Object[] hierarchy2,arbolDice;
    JTree tree;
    TreeListTransferHandler transferHandler = new TreeListTransferHandler();     
     Core core;
    OlapConnection connection=null;
    Manager manager;
    private DefaultListModel listModelr,listModelc;
    
    /** Creates new form Navigator */
    public Navigator(Object[] hierarchy,Object[] arbolDice, OlapConnection connection,Manager manager) {
        initComponents();
        this.connection=connection;        
        this.manager=manager;  
        this.arbolDice=arbolDice;  
        listModelr = new DefaultListModel();
        listModelc = new DefaultListModel();        
        row.setCellRenderer(new MyCellRenderer());
        column.setCellRenderer(new MyCellRenderer());
        row.setModel(listModelr); 
        column.setModel(listModelc);
        row.addListSelectionListener(new MyListSelectionListener(column));
        column.addListSelectionListener(new MyListSelectionListener(row));
        row.setDragEnabled(true);
        column.setDragEnabled(true);     
        row.setName("row");     
        column.setName("column");
        crearVector(hierarchy); 
        tree.setDragEnabled(true);     
        tree.setCellRenderer(new CubeCellRenderer());
        TreeNode root = (TreeNode)tree.getModel().getRoot();
        expandAll(tree, new TreePath(root),true); 
        tree.setTransferHandler(transferHandler); 
        row.setTransferHandler(transferHandler);
        column.setTransferHandler(transferHandler);
        transferHandler.setColumn(column);
        transferHandler.setRow(row);      
        this.setVisible(true); 
    }

    public Navigator(){
         initComponents();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        btn_analisis = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        row = new javax.swing.JList();
        jScrollPane3 = new javax.swing.JScrollPane();
        column = new javax.swing.JList();
        btn_up = new javax.swing.JButton();
        btn_down = new javax.swing.JButton();
        btn_del = new javax.swing.JButton();
        btn_clear = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        lbl_message = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();

        btn_analisis.setText("Start Analysis");
        btn_analisis.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_analisisActionPerformed(evt);
            }
        });

        row.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Rows", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(102, 102, 102)));
        jScrollPane2.setViewportView(row);

        column.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Columns", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 0, 11), new java.awt.Color(102, 102, 102)));
        jScrollPane3.setViewportView(column);

        btn_up.setIcon(new javax.swing.ImageIcon(getClass().getResource("/WorkSpace/resources/up.png"))); // NOI18N
        btn_up.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_upActionPerformed(evt);
            }
        });

        btn_down.setIcon(new javax.swing.ImageIcon(getClass().getResource("/WorkSpace/resources/down.png"))); // NOI18N
        btn_down.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_downActionPerformed(evt);
            }
        });

        btn_del.setIcon(new javax.swing.ImageIcon(getClass().getResource("/WorkSpace/resources/del.png"))); // NOI18N
        btn_del.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_delActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 122, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(btn_del, 0, 0, Short.MAX_VALUE)
                    .addComponent(btn_down, 0, 0, Short.MAX_VALUE)
                    .addComponent(btn_up, javax.swing.GroupLayout.PREFERRED_SIZE, 40, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 192, Short.MAX_VALUE)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 192, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel2Layout.createSequentialGroup()
                        .addGap(82, 82, 82)
                        .addComponent(btn_up)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_down)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_del, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        btn_clear.setText("Clean");
        btn_clear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_clearActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel1.setIcon(new javax.swing.ImageIcon(getClass().getResource("/WorkSpace/resources/Member.png"))); // NOI18N
        jLabel1.setText("ON ROWS");
        jLabel1.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/WorkSpace/resources/Member.png"))); // NOI18N
        jLabel2.setText("ON COLUMNS");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        lbl_message.setFont(new java.awt.Font("Tahoma", 1, 10));
        lbl_message.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);

        jLabel3.setText("    Before you start an analysis drag at least one hierarchy ");

        jLabel4.setText("                and drop it into any list (rows and columns)");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(25, 25, 25)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btn_analisis, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 65, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(btn_clear, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(38, 38, 38))
            .addComponent(lbl_message, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)
            .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)
            .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 320, Short.MAX_VALUE)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 309, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btn_clear)
                    .addComponent(btn_analisis))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lbl_message, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel3)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel4)
                .addContainerGap(102, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btn_analisisActionPerformed(java.awt.event.ActionEvent evt) {                                             
        // TODO add your handling code here:
        manager.getStatusB().setText("To delete a single member select it doing right click, press the Mouse Wheel button");
        if(transferHandler.getRows().size()<=0||transferHandler.getColumns().size()<=0)
        {
           ImageIcon icono= createImageIcon("resources/alert.png");
           this.lbl_message.setIcon(icono);
           if(transferHandler.getRows().size()<=0)
           {    if(transferHandler.getColumns().size()<=0)
                     this.lbl_message.setText("Drag & Drop atless 1 Hierarchy on Rows & Columns");
                    else
                        this.lbl_message.setText("Drag and Drop at less one Hierarchy on Rows");
           
           }           
           else
                this.lbl_message.setText("Drag and Drop at less one Hierarchy on Columns");
        }
        else{
            this.core=new Core(transferHandler.getRows(),transferHandler.getColumns(),connection,manager.getCubeName());          
            this.manager.setCore(core);
            this.lbl_message.setIcon(null);
            this.lbl_message.setText("");
            this.manager.getPanelDice().setEnabled(true);
            this.manager.getPanelG().setEnabled(true);
            this.manager.getPanel().setEnabled(true);
            this.manager.getPanelDice().removeAll();
            if(core.getExito())   
            {
                DiceCube dice= new DiceCube(manager,arbolDice);
                this.manager.getPanelDice().add(dice);
                this.manager.getPanelMeasures().removeAll();                                            
                this.manager.getPanelMeasures().add(new Measures(manager));
                this.manager.getPanelMeasures().updateUI();
                this.manager.getPanelDice().updateUI();
            }
        } 
    }                                            

    private void btn_clearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_clearActionPerformed
        // TODO add your handling code here:
        this.transferHandler.setClean();
        listModelr = new DefaultListModel();
        listModelc = new DefaultListModel();
        row.setModel(listModelr);
        column.setModel(listModelc);
        this.lbl_message.setIcon(null);
        this.lbl_message.setText("");//GEN-LAST:event_btn_clearActionPerformed
        this.manager.getPanelDice().setEnabled(false);
        this.manager.getPanelG().setEnabled(false);
        this.manager.getPanel().setEnabled(false);
        
    }                                         

    private void btn_upActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_upActionPerformed
        // TODO add your handling code here:
           if(this.row.getSelectedIndex()!=-1)
        {
            int index = row.getSelectedIndex();
            if(index>0){                
                Object item=listModelr.getElementAt(index-1);
                listModelr.setElementAt(listModelr.getElementAt(index), index-1);
                listModelr.setElementAt(item, index);
                
            }
           index--;
            row.setSelectedIndex(index);            
            row.ensureIndexIsVisible(index);
           this.transferHandler.ordenaVectorR(listModelr); 
            
        }
    if(this.column.getSelectedIndex()!=-1)
        {
            int index = column.getSelectedIndex();
            if(index>0){
                Object item=listModelc.getElementAt(index-1);
                listModelc.setElementAt(listModelc.getElementAt(index), index-1);
                listModelc.setElementAt(item, index);
                
            }
           index--;
            column.setSelectedIndex(index);            
            column.ensureIndexIsVisible(index);
            this.transferHandler.ordenaVectorC(listModelc);
        }
    }//GEN-LAST:event_btn_upActionPerformed

    private void btn_downActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_downActionPerformed
        // TODO add your handling code here:
        if(this.row.getSelectedIndex()!=-1)
        {
            int index = row.getSelectedIndex();
            if(index<listModelr.getSize()-1){
                Object item=listModelr.getElementAt(index+1);
                listModelr.setElementAt(listModelr.getElementAt(index), index+1);
                listModelr.setElementAt(item, index);
                
            }
           index++;
            row.setSelectedIndex(index);            
            row.ensureIndexIsVisible(index);
            this.transferHandler.ordenaVectorR(listModelr);
        }
    if(this.column.getSelectedIndex()!=-1)
        {
            int index = column.getSelectedIndex();
            if(index<listModelc.getSize()-1){
                Object item=listModelc.getElementAt(index+1);
                listModelc.setElementAt(listModelc.getElementAt(index), index+1);
                listModelc.setElementAt(item, index);
                
            }
           index++;
            column.setSelectedIndex(index);            
            column.ensureIndexIsVisible(index);
            this.transferHandler.ordenaVectorC(listModelc);
        }
    }//GEN-LAST:event_btn_downActionPerformed

    private void btn_delActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_delActionPerformed
        // TODO add your handling code here:
        if(this.row.getSelectedIndex()!=-1)
        {
            int index = row.getSelectedIndex();
            this.transferHandler.DelRowItem(row.getSelectedValue().toString());
            listModelr.remove(index);            
            if (index == listModelr.getSize()) 
                 //removed item in last position
                  index--;
            row.setSelectedIndex(index);            
            row.ensureIndexIsVisible(index);
            
        }
        if (this.column.getSelectedIndex()!=-1)
        {int index = column.getSelectedIndex();
         this.transferHandler.DelColumnItem(column.getSelectedValue().toString());
            listModelc.remove(index);
            if (index == listModelc.getSize()) 
                 //removed item in last position
                  index--;
            column.setSelectedIndex(index);
            column.ensureIndexIsVisible(index);
        
        }
        row.updateUI();
        column.updateUI();  
    
        System.out.println(row.getSelectedIndex()+"value: "+row.getSelectedValue());//GEN-LAST:event_btn_delActionPerformed
}
    public void crearVector(Object[] hierarchy){     
            this.funcionCreadora(hierarchy);
        }       
    public void funcionCreadora(Object[] hierarchy){
        hierarchy2=hierarchy;
        DefaultMutableTreeNode root = processHierarchy(hierarchy2);
        tree = new JTree(root); 
        tree.setDragEnabled(true);
        this.jScrollPane1.setViewportView(tree); 
    }       
    private MyDefaultMutableTreenodo processHierarchy(Object[] hierarchy) {
        MyDefaultMutableTreenodo node = new MyDefaultMutableTreenodo(hierarchy[0]);
        MyDefaultMutableTreenodo child;
        for(int i=1; i<hierarchy.length; i++) {
            Object nodeSpecifier = hierarchy[i];
            if (nodeSpecifier instanceof Object[])  // Ie node with children
                child = processHierarchy((Object[])nodeSpecifier);
            else
                child = new MyDefaultMutableTreenodo(nodeSpecifier); // Ie Leaf
            node.add(child);
        // child.
        }
        return(node);
    }    
   private void expandAll(JTree tree, TreePath parent, boolean expand) {
        TreeNode node = (TreeNode)parent.getLastPathComponent();
        if (node.getChildCount() >= 0) {
            for (Enumeration e=node.children(); e.hasMoreElements(); ) {
                TreeNode n = (TreeNode)e.nextElement();
                TreePath path = parent.pathByAddingChild(n);
                expandAll(tree, path, expand);
              }
        }
        if (expand) {
            tree.expandPath(parent);
        } else {
            tree.collapsePath(parent);
        }
}
   private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_analisis;
    private javax.swing.JButton btn_clear;
    private javax.swing.JButton btn_del;
    private javax.swing.JButton btn_down;
    private javax.swing.JButton btn_up;
    private javax.swing.JList column;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel lbl_message;
    private javax.swing.JList row;
    // End of variables declaration//GEN-END:variables
    
}
