package WorkSpace.Navigator;
import Core.ManagerCube.Manager;
import WorkSpace.CubeConfiguration.ExitAlert;
import WorkSpace.MainApp;
import java.util.*;
import java.sql.*;
import org.olap4j.*;
import org.olap4j.metadata.*;
import javax.swing.*;

public class NavigatorArbol {
    //Clase que genera el arbol jerarquico que contienme cubos, dimensiones, jerarquias, niveles, miembros, childmiembros
    //para crear un vector de objetos y entregarlo a un objeto de tipo PruebaGrafica4 la cual convierte el vector en un 
    //JTree y lo grafica.
    public  Object[] arbol,arbolDice;
    Navigator navigatorTree;
    String xmlpath, user, password,url;
     JPanel pane1;
     JPanel paneG;
    OlapConnection connection=null;
    Manager manager;
    boolean flag=true;
    public NavigatorArbol(String xmlpath,String user,String password,String url, Manager manager) {        
        this.manager=manager;
        this.url=url;
        this.user=user;
        this.xmlpath=xmlpath;
        this.password=password;       
        OlapConnection conexion=conectar();        
        if(conexion!=null){            
            arbol=obtenerCubos(conexion);
            navigatorTree=new Navigator(arbol,arbolDice,connection,manager);
        }
        else{
            flag=false;
             JFrame mainFrame = MainApp.getApplication().getMainFrame();
           ExitAlert demoDialogo4 = new ExitAlert(mainFrame,true,2,"");
           demoDialogo4.setLocationRelativeTo(mainFrame);
           MainApp.getApplication().show(demoDialogo4); 
            System.out.println("Ocurrio un problema en la conexion");          
        }
    }

    public JPanel getPanel(){
    return navigatorTree;
    }
   
    public  OlapConnection conectar(){
      
        String connStr = "jdbc:mondrian:Catalog="+xmlpath+";" +
                         "JdbcDrivers=org.postgresql.Driver;JdbcPassword="+password+";JdbcUser="+user+";"+                         
                         "Jdbc="+url;        
           try{ 
                Class.forName("mondrian.olap4j.MondrianOlap4jDriver");
                Connection jdbcConn = DriverManager.getConnection(connStr);
                connection =((OlapWrapper)jdbcConn).unwrap(OlapConnection.class);    
                
           }
           catch(Exception ex){ 
             ex.printStackTrace();
       }
        
        return connection;
    }
    public  Object[] obtenerCubos(OlapConnection conexion){
        //metodo encargado de retornar un vector Object que contiene el arbol completo de Cubos, Jerarquias, Dimensiones...
        Object[] cubosObject=null;
        Cube cuboElemento;
        try{
            Schema esquema=conexion.getSchema();
            NamedList<Cube> cubosLista=esquema.getCubes();
            if(!cubosLista.isEmpty()){
                cubosObject=new Object[2];
                //arbolDice=new Object[1];
                cubosObject[0]="Cube";
                    cuboElemento=cubosLista.get(0);
                    cubosObject[1]=obtenerDimensiones(cuboElemento);
                    arbolDice=obtenerDimensiones1(cuboElemento);
            }                
        }catch(OlapException ex){}
        
        return cubosObject;
    }
    public  Object[] obtenerDimensiones(Cube cuboElemento){
    //metodo encargado de retornar la lista de Dimensiones de el cubo deseado
        Object[] dimensionesObject=null;
        Dimension dimensionElemento;
        NamedList<Dimension> dimensionesLista=cuboElemento.getDimensions();
        if(!dimensionesLista.isEmpty()){
            dimensionesObject=new Object[dimensionesLista.size()+1];
                dimensionesObject[0]=cuboElemento;
                for(int i=0;i<dimensionesLista.size();i++){
                    dimensionElemento=dimensionesLista.get(i);
                    dimensionesObject[i+1]=obtenerJerarquias(dimensionElemento);
                    if(dimensionesObject[i+1]==null)
                        dimensionesObject[i+1]=dimensionElemento;
                }            
        }            
        return dimensionesObject;
    }
    public  Object[] obtenerJerarquias(Dimension dimensionElemento){
    //metodo encargado de retornar la lista de Jerarquias de la dimension deseada
        Object[] jerarquiasObject=null;
        Hierarchy jerarquiaElemento;
        NamedList<Hierarchy> jerarquiasLista=dimensionElemento.getHierarchies();
        if(!jerarquiasLista.isEmpty()){
            jerarquiasObject=new Object[jerarquiasLista.size()+1];
                jerarquiasObject[0]=dimensionElemento;
                for(int i=0;i<jerarquiasLista.size();i++){
                    jerarquiaElemento=jerarquiasLista.get(i);
                  //  jerarquiasObject[i+1]=obtenerNiveles(jerarquiaElemento);
                    if(jerarquiasObject[i+1]==null)
                        jerarquiasObject[i+1]=jerarquiaElemento;
                    
                }            
        }            
        return jerarquiasObject;
        
    }
    public  Object[] obtenerDimensiones1(Cube cuboElemento){
    //metodo encargado de retornar la lista de Dimensiones de el cubo deseado
        Object[] dimensionesObject=null;
        Dimension dimensionElemento;
        NamedList<Dimension> dimensionesLista=cuboElemento.getDimensions();
        if(!dimensionesLista.isEmpty()){
            dimensionesObject=new Object[dimensionesLista.size()+1];            
                dimensionesObject[0]=cuboElemento;
                for(int i=0;i<dimensionesLista.size();i++){
                    dimensionElemento=dimensionesLista.get(i);
                    dimensionesObject[i+1]=obtenerJerarquias1(dimensionElemento);                    
                    if(dimensionesObject[i+1]==null)
                        dimensionesObject[i+1]=dimensionElemento;
                }            
        }               
        return dimensionesObject;
    }
    
    public  Object[] obtenerJerarquias1(Dimension dimensionElemento){
    //metodo encargado de retornar la lista de Jerarquias de la dimension deseada
        Object[] jerarquiasObject=null;
        Hierarchy jerarquiaElemento;
        NamedList<Hierarchy> jerarquiasLista=dimensionElemento.getHierarchies();
        if(!jerarquiasLista.isEmpty()){
            jerarquiasObject=new Object[jerarquiasLista.size()+1];
                jerarquiasObject[0]=dimensionElemento;
                for(int i=0;i<jerarquiasLista.size();i++){
                    jerarquiaElemento=jerarquiasLista.get(i);
                    jerarquiasObject[i+1]=obtenerNiveles(jerarquiaElemento);
                    if(jerarquiasObject[i+1]==null)
                        jerarquiasObject[i+1]=jerarquiaElemento;
                    
                }            
        }            
        return jerarquiasObject;
        
    }
    public  Object[] obtenerNiveles(Hierarchy jerarquiaElemento){
    //metodo encargado de retornar la lista de niveles de la Jerarquia deseada
        Object[] nivelesObject=null;
        Level nivelElemento;
        NamedList<Level> nivelesLista=jerarquiaElemento.getLevels();
        if(!nivelesLista.isEmpty()){
            nivelesObject=new Object[2];
                nivelesObject[0]=jerarquiaElemento;
//                for(int i=0;i<nivelesLista.size();i++){
                    nivelElemento=nivelesLista.get(0);
//                    if(i==0)
                        nivelesObject[1]=obtenerMiembros2(nivelElemento);
//                    else
//                        nivelesObject[i+1]=obtenerMiembros(nivelElemento);
//                    if(nivelesObject[i+1]==null)
//                        nivelesObject[i+1]=nivelElemento;                    
//                }            
        }            
        return nivelesObject;
        
    }   
    public  Object[] obtenerMiembros(Level nivelElemento){
    //metodo encargado de retornar la lista de miembros de el nivel deseado
        Object[] miembrosObject=null;
        Member miembroElemento;
        try{
            List<Member> miembrosLista=nivelElemento.getMembers();
            if(!miembrosLista.isEmpty()){
                miembrosObject=new Object[miembrosLista.size()+1];
                    miembrosObject[0]=nivelElemento;
                    for(int i=0;i<miembrosLista.size();i++){
                        miembroElemento=miembrosLista.get(i);                                                
                        miembrosObject[i+1]=obtenerChildMiembros(miembroElemento);                        
                        if(miembrosObject[i+1]==null)
                                miembrosObject[i+1]=miembroElemento;
                    }            
            }
        }catch(OlapException ex){}    
        return miembrosObject;        
    }
    public  Object[] obtenerMiembros2(Level nivelElemento){
    //metodo encargado de retornar la lista de miembros de el nivel deseado
        Object[] miembrosObject=null;
        Member miembroElemento;
        try{
            List<Member> miembrosLista=nivelElemento.getMembers();
            if(!miembrosLista.isEmpty()){
                miembrosObject=new Object[miembrosLista.size()+1];
                    miembrosObject[0]=nivelElemento;
                    for(int i=0;i<miembrosLista.size();i++){
                        miembroElemento=miembrosLista.get(i);
                        if(i==0)
                        miembrosObject[i+1]=obtenerChildMiembros(miembroElemento);
                        if(miembrosObject[i+1]==null)
                             miembrosObject[i+1]=miembroElemento;
                    }            
            }
        }catch(OlapException ex){}    
        return miembrosObject;
        
    }   
    public  Object[] obtenerChildMiembros(Member miembroElemento){
    //metodo encargado de retornar la lista de childMiembros de el miembro deseado
        Object[] childMiembrosObject=null;
        Member childMiembroElemento;         
        try{
            List<? extends Member> childMiembrosLista=miembroElemento.getChildMembers();
            if(!childMiembrosLista.isEmpty()){
                childMiembrosObject=new Object[childMiembrosLista.size()+1];
                    childMiembrosObject[0]=miembroElemento;
                    for(int i=0;i<childMiembrosLista.size();i++){
                        childMiembroElemento=childMiembrosLista.get(i);
                        //childMiembrosObject[i+1]=childMiembroElemento.getName();
                        childMiembrosObject[i+1]=obtenerChildMiembros(childMiembroElemento);
                        if(childMiembrosObject[i+1]==null)
                                childMiembrosObject[i+1]=childMiembroElemento;                                                
                    }            
            }            
        }catch(OlapException ex){}    
        return childMiembrosObject;
        
    }
}
