/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.Reports;

/**
 *
 * @author Alexander
 */

import WorkSpace.MainApp;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.JScrollPane;
import jxl.*;
import jxl.write.Label;
import jxl.write.WritableImage;
import jxl.write.WritableSheet;
import jxl.write.WriteException;
import misc.swing.table.SpanTable;
import net.sf.jasperreports.engine.JREmptyDataSource;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.design.JasperDesign;
import net.sf.jasperreports.engine.xml.JRXmlLoader;
import net.sf.jasperreports.view.JasperViewer;
import org.jfree.chart.JFreeChart;

public class StarcCubeReport 
{   
    int i; JFreeChart chart; JScrollPane table;File file;
    private final short ROW_INI=2;
    private final short COL_INI=2;
    private SpanTable tabled=null;
    private SpanTable tablef=null;
   
    public StarcCubeReport(int i, JFreeChart chart, JScrollPane table,File file) {
        this.i=i; 
        this.chart=chart; 
        this.table=table; 
        this.file=file;  
        tablef=(SpanTable) table.getRowHeader().getComponent(0);
        tabled=(SpanTable) table.getViewport().getComponent(0);
        runReporte();
    }
    public void runReporte()
    {
        try {
                JasperDesign jasperDesign =JRXmlLoader.load(MainApp.class.getResourceAsStream("Reports/Report.jrxml"));                JasperReport jasperReport = JasperCompileManager.compileReport(jasperDesign);
                Map parametro = new HashMap();                
                parametro.put("chart",TableImage());
                parametro.put("Table",ChartImage());        
                JasperPrint jasperPrint = JasperFillManager.fillReport(jasperReport, parametro,new JREmptyDataSource());
                switch (i){
                    case 0:JasperExportManager.exportReportToPdfFile(jasperPrint, file.getAbsolutePath()+".pdf");                        
                        JasperViewer jviewer = new JasperViewer(jasperPrint, false);
                        jviewer.setTitle("StarCube Project");
                        jviewer.setVisible(true);
                        break;
                    case 1:JasperExportManager.exportReportToHtmlFile(jasperPrint,  file.getAbsolutePath()+".html");
                     jviewer = new JasperViewer(jasperPrint, false);
                            jviewer.setTitle("StarCube Project");
                            jviewer.setVisible(true);    
                    break;
                    case 2: 
                        file=new File(file.getAbsolutePath()+".xls");
                          if (file.exists()) {
                              file.delete();
                              file=new File(file.getAbsolutePath()+".xls");
                            }
                            exportReport();
                         break;
                    case 3:JasperExportManager.exportReportToXmlFile(jasperPrint, file.getAbsolutePath()+".xml",true); 
                            jviewer = new JasperViewer(jasperPrint, false);
                            jviewer.setTitle("StarCube Project");
                            jviewer.setVisible(true);
                        break;
                }
                
        } catch (JRException ex) {
            System.out.println("Export EROOR");
        }
         
    }
    private  java.awt.Image ChartImage()
    {     return   chart.createBufferedImage(550,250);
    }
    private  java.awt.Image TableImage()
    {               int w = table.getWidth(), h = table.getHeight();
                    BufferedImage image = new BufferedImage(w,h,
                        BufferedImage.SCALE_SMOOTH);
                    Graphics2D g2 = image.createGraphics();
                    table.paint(g2);
                    g2.dispose();
                    return image;
    }
    private  ByteArrayOutputStream ExcelImage()
    {   ByteArrayOutputStream baos = new ByteArrayOutputStream();
        try {
            int w = table.getWidth();
            int h = table.getHeight();
            BufferedImage image = new BufferedImage(w, h, BufferedImage.SCALE_FAST);
            Graphics2D g2 = image.createGraphics();
            table.paint(g2);
            g2.dispose();           
            ImageIO.write(image, "PNG", baos);            
            return baos;
        } catch (IOException ex) {
            Logger.getLogger(StarcCubeReport.class.getName()).log(Level.SEVERE, null, ex);
        }
         return baos;
    }
    private  ByteArrayOutputStream ExcelImageG()
    {   ByteArrayOutputStream baos = new ByteArrayOutputStream();
        try {
                      
            ImageIO.write(chart.createBufferedImage(800,700), "PNG", baos);            
            return baos;
        } catch (IOException ex) {
            Logger.getLogger(StarcCubeReport.class.getName()).log(Level.SEVERE, null, ex);
        }
         return baos;
    }

    private void exportReport() {
        try {
            jxl.write.WritableWorkbook wb = Workbook.createWorkbook(file);
            WritableSheet wsh=wb.createSheet("StarCube Olap Table",0);
            WritableSheet ws=wb.createSheet("StarCube Olap Table (Image)",1);
            WritableSheet ws1=wb.createSheet("Olap Graphic",2);
            	short nRows=(short) (tabled.getRowCount());
		short nRcols =(short) (tabled.getColumnCount());
            	short nRows1=(short) (tablef.getRowCount());
		short nRcols1 =(short) (tablef.getColumnCount());                                
		Label cell;		                
		for(int h=0; h<tablef.getTableHeader().getColumnModel().getColumnCount(); h++){		   
                        cell=new Label(h,0,tablef.getTableHeader().getColumnModel().getColumn(h).getHeaderValue().toString());                          
		        wsh.addCell(cell);
		   
		}
		for(int h=nRcols1; h<tabled.getTableHeader().getColumnModel().getColumnCount()+nRcols1; h++){		   
                        cell=new Label(h,0,tabled.getTableHeader().getColumnModel().getColumn(h-nRcols1).getHeaderValue().toString());                          
		        wsh.addCell(cell);
		   
		}
		for(int h=1; h<nRows1+1; h++){
		    for(int j=0; j<nRcols1; j++){
                        cell=new Label(j,h, tablef.getModel().getValueAt(h-1, j).toString());                          
		        wsh.addCell(cell);
		    }
		}
		for(int h=1; h<nRows+1; h++){
		    for(int j=nRcols1;j<nRcols+nRcols1; j++){
                        cell=new Label(j,h, tabled.getModel().getValueAt(h-1,j-nRcols1).toString());
		        wsh.addCell(cell);
		    }
		}               
                ws.addImage(new WritableImage(0,0,12,20, ExcelImage().toByteArray()));                
                ws1.addImage(new WritableImage(0,0,12,20, ExcelImageG().toByteArray()));                
                wb.write();
                wb.close();
            
        } catch (WriteException ex) {
            Logger.getLogger(StarcCubeReport.class.getName()).log(Level.SEVERE, null, ex);
        }  catch (IOException ex) {
            Logger.getLogger(StarcCubeReport.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}

   


