/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.Table;


import Core.member.InterfaceMember;
import Core.member.MyNodeMember;
import Core.tree.TreeMain;
import WorkSpace.MainApp;
import java.awt.Component;
import java.util.Vector;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;

import javax.swing.UIManager;
import javax.swing.table.TableCellRenderer;
import misc.swing.table.Span;
import misc.swing.table.SpanException;
import misc.swing.table.SpanTableHeader;
import misc.swing.table.settings.Style;
import misc.swing.table.settings.Styles;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member;
import org.olap4j.metadata.NamedList;

/**
 *
 * @author CAMILO
 */
public class RenderTablaCols extends JLabel implements TableCellRenderer
{
    private Icon[] iconos = null;
    private Vector vectorMain;
    private Span span =null;
    public RenderTablaCols(TreeMain treeMain)
    {
        super();
        setOpaque(true);
        setBorder(UIManager.getBorder("TableHeader.cellBorder"));

        this.vectorMain=treeMain.getVectorMain();            
    }    
    @Override
    @SuppressWarnings("static-access")
    public Component getTableCellRendererComponent(JTable table, Object value, 
            boolean isSelected, boolean hasFocus, int row, int col) {       
        iconos = new Icon[3];
        iconos[0] = createImageIcon("Table/resources/Mas.gif");
        iconos[1] = createImageIcon("Table/resources/Menos.gif");
        iconos[2] = createImageIcon("Table/resources/Circulo.gif");                  
        Object obj1 = null;
        Object obj2 = null;
        Object obj3 = null;

        SpanTableHeader spantableheader = (SpanTableHeader)table.getTableHeader();
        Style style = getStyle(spantableheader, row, col);

        if(style != null)
        {
            setForeground(obj1 == null ? style.getForeground() : ((java.awt.Color) (obj1)));
            setBackground(obj2 == null ? style.getBackground() : ((java.awt.Color) (obj2)));
            setFont(obj3 == null ? style.getFont() : ((java.awt.Font) (obj3)));
            setHorizontalAlignment(style.getHorizontalAlignment());
        } else
        {
            setForeground(obj1 == null ? spantableheader.getForeground() : ((java.awt.Color) (obj1)));
            setBackground(obj2 == null ? spantableheader.getBackground() : ((java.awt.Color) (obj2)));
            setFont(obj3 == null ? spantableheader.getFont() : ((java.awt.Font) (obj3)));
            setHorizontalAlignment(spantableheader.getHorizontalTextAlignment());
        }        
        
        InterfaceMember interfaceMember = new InterfaceMember(vectorMain);
        if(row%2==1)
        {
            int colReal=obtengaIndiceReal2((row-1)/2,col,vectorMain);
            MyNodeMember nodo1 = interfaceMember.getMyNodeMember((row-1)/2,colReal);
            MyNodeMember nodo2 = interfaceMember.getMyNodeMember((row-1)/2,colReal+1);
            
            Member miembro1 = nodo1.getMember();
            Member miembro2 = null;
            if(nodo2!=null)
                miembro2 = nodo2.getMember();
            if (value instanceof Object)
            {
                if(miembro2!=null)
                {                    
                    if(validatorChildAncestor(miembro1, miembro2))
                    {
                        this.setIcon (iconos[1]);
                    }
                    else{
                        if(miembro1.getChildMemberCount()==0){
                            this.setIcon (iconos[2]);
                        }
                        else{
                            if(miembro1.getChildMemberCount()>0)
                                this.setIcon (iconos[0]);
                            else
                                this.setIcon(null);
                        }
                    } 
                        
                }
                else{
                    //revisar si miembro1 es hoja
                    if(miembro1.getChildMemberCount()==0){
                        this.setIcon (iconos[2]);
                    }
                    else{                     
                        if(miembro1.getChildMemberCount()>0)
                                this.setIcon (iconos[0]);
                            else
                                this.setIcon(null);
                    }
                }           
            }
            this.setHorizontalTextPosition(this.TRAILING);
            this.setText(value);
            hasFocus=false;
            return this;
        }        
        else{
            this.setIcon(null);
            this.setHorizontalTextPosition(this.TRAILING);
            this.setText(value);
            hasFocus=false;
            //this.setFont(new Font("Times-Roman", Font.BOLD,12));
            return this;
        }
    }
        
    
    public boolean validatorChildAncestor(Member member,Member member0){
        boolean retorno = false;
        try {
            NamedList<? extends Member> memberList = member.getChildMembers();
            if(memberList.contains(member0))
                retorno=true;                
            else{
                for(int i=0;i<memberList.size();i++){
                    retorno=validatorChildAncestor(memberList.get(i), member0);
                    if(retorno==true)
                        break;                }
            }
        } catch (OlapException ex) {
            Logger.getLogger(RenderTablaCols.class.getName()).log(Level.SEVERE, null, ex);
        }
        return retorno;        
    }
    private int obtengaIndiceReal2(int row, int col, Vector vectorMainCol) {
        int retorno=col;
        InterfaceMember interfaceMember=new InterfaceMember(vectorMainCol);
            for(int j=interfaceMember.getNumDimension()-1;j>row;j--){
                retorno=interfaceMember.getMyNodeMember(j,retorno).getFather();
            }
        return retorno;         
    }
    
    //-------------------------------------------------------------------------------------------
    protected void setText(Object value)
    {
        setText(value != null ? value.toString() : "");
    }
    protected Style getStyle(SpanTableHeader spantableheader, int i, int j)
    {
        Style style = null;
        try
        {
            Span span = spantableheader.getSpanModel().getSpanAt(i, j);
            Styles styles = spantableheader.getStyles();
            if(styles != null)
                if(span.getSpanC() > 1 && span.getSpanR() > 1)
                    style = styles.get("span");
                else
                if(i % 2 == 0)
                    style = styles.get("even");
                else
                    style = styles.get("odd");
        }
        catch(SpanException spanexception) {
        }
        if(style != null && style.getHorizontalAlignment() != 0)
            System.out.println((new StringBuilder()).append("style: ").append(style.getName()).append(" :").append(style.getHorizontalAlignment()).toString());
        return style;
    }    
    private static final long serialVersionUID = 1L;
       private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
}

