/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package WorkSpace.Table;


import Core.member.InterfaceMember;
import Core.member.MyNodeMember;
import Core.tree.TreeMain;
import WorkSpace.MainApp;
import java.awt.Component;
import java.util.Vector;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JTable;

import javax.swing.UIManager;
import javax.swing.table.TableCellRenderer;
import misc.swing.table.Span;
import misc.swing.table.SpanException;
import misc.swing.table.SpanTable;
import misc.swing.table.SpanTableHeader;

import misc.swing.table.settings.Style;
import misc.swing.table.settings.Styles;
import org.olap4j.OlapException;
import org.olap4j.metadata.Member;
import org.olap4j.metadata.NamedList;

/**
 *
 * @author CAMILO
 */
public class RenderTablaRows extends JLabel implements TableCellRenderer
{
    private Icon[] iconos = null;
    private TreeMain treeMain=null;
    private Vector vectorMain;
    public RenderTablaRows(TreeMain treeMain)
    {
        super();
        setOpaque(true);
        setBorder(UIManager.getBorder("TableHeader.cellBorder"));
        this.vectorMain=treeMain.getVectorMain();            
    }    
    @Override
    @SuppressWarnings("static-access")
    public Component getTableCellRendererComponent(JTable table, Object value, 
            boolean isSelected, boolean hasFocus, int row, int col) {                
        iconos = new Icon[3];
        iconos[0] = createImageIcon("Table/resources/Mas.gif");
        iconos[1] = createImageIcon("Table/resources/Menos.gif");
        iconos[2] = createImageIcon("Table/resources/Circulo.gif");  
                
        InterfaceMember interfaceMember = new InterfaceMember(vectorMain);        
        int rowReal=obtengaIndiceReal(row,col,vectorMain);
             
        MyNodeMember nodo1 = interfaceMember.getMyNodeMember(col,rowReal);
        MyNodeMember nodo2 = interfaceMember.getMyNodeMember(col,rowReal+1);
        Member miembro1 = nodo1.getMember();
        Member miembro2=null;
        if(nodo2!=null)
            miembro2 = nodo2.getMember();
        
        Object obj1 = null;
        Object obj2 = null;
        Object obj3 = null;
        SpanTableHeader spantableheader = (SpanTableHeader)table.getTableHeader();
        Style style = getStyle((SpanTable)table, row, col);

        //JLabel etiqueta = new JLabel();
        
        if(style != null)
        {
            if(isSelected)
            {
                setForeground(obj1 == null ? table.getSelectionForeground() : ((java.awt.Color) (obj1)));
                setBackground(table.getSelectionBackground());
            } else
            {
                setForeground(obj1 == null ? style.getForeground() : ((java.awt.Color) (obj1)));
                setBackground(obj2 == null ? style.getBackground() : ((java.awt.Color) (obj2)));
            }
            setFont(obj3 == null ? style.getFont() : ((java.awt.Font) (obj3)));
            setHorizontalTextPosition(style.getHorizontalAlignment());
        }
        else
        {
            if(isSelected)
            {
                setForeground(obj1 == null ? table.getSelectionForeground() : ((java.awt.Color) (obj1)));
                setBackground(table.getSelectionBackground());
            } else
            {
                setForeground(obj1 == null ? spantableheader.getForeground() : ((java.awt.Color) (obj1)));
                setBackground(obj2 == null ? spantableheader.getBackground() : ((java.awt.Color) (obj2)));
            }
            setFont(obj3 == null ? spantableheader.getFont() : ((java.awt.Font) (obj3)));
            setHorizontalTextPosition(((SpanTable)table).getHorizontalTextAlignment());
        }
//        if(hasFocus)
//        {
//            setBorder(UIManager.getBorder("Table.focusCellHighlightBorder"));
//            if(table.isCellEditable(row, col))
//            {
//                setForeground(obj1 == null ? UIManager.getColor("Table.focusCellForeground") : ((java.awt.Color) (obj1)));
//                setBackground(UIManager.getColor("Table.focusCellBackground"));
//            }
//        } else
//        {
//            setBorder(UIManager.getBorder("TableHeader.cellBorder"));
//        }

        if (value instanceof Object)
        {
            if(miembro2!=null)
            {    
                if(validatorChildAncestor(miembro1, miembro2))
                    this.setIcon (iconos[1]);
                else 
                    if(miembro1.getChildMemberCount()==0)
                        this.setIcon (iconos[2]);
                    else
                        this.setIcon (iconos[0]);
            }
            else{
                //revisar si miembro1 es hoja
                if(miembro1.getChildMemberCount()==0)
                    this.setIcon (iconos[2]);
                else
                    this.setIcon (iconos[0]);
            }
        }
        this.setHorizontalTextPosition(this.TRAILING);
        this.setText(value);
        hasFocus=false;
        return this;
    }    
    
    
    public boolean validatorChildAncestor(Member member,Member member0){
        boolean retorno = false;
        try {
            NamedList<? extends Member> memberList = member.getChildMembers();
            if(memberList.contains(member0))
                retorno=true;                
            else{
                for(int i=0;i<memberList.size();i++){
                    retorno=validatorChildAncestor(memberList.get(i), member0);
                    if(retorno==true)
                        break;                }
            }
        } catch (OlapException ex) {
            Logger.getLogger(RenderTablaRows.class.getName()).log(Level.SEVERE, null, ex);
        }
        return retorno;        
    }

    private int obtengaIndiceReal(int row, int col,Vector vectorMainRow) {
        int retorno=row;
        InterfaceMember interfaceMember=new InterfaceMember(vectorMainRow);
            for(int j=interfaceMember.getNumDimension()-1;j>col;j--){
                retorno=interfaceMember.getMyNodeMember(j,retorno).getFather();
            }
        return retorno;
    }
    
    protected void setText(Object value)
    {
        setText(value != null ? value.toString() : "");
    }
    protected Style getStyle(SpanTable spantable, int i, int j)
    {
        Style style = null;
        try
        {
            Span span = spantable.getSpanModel().getSpanAt(i, j);
            Styles styles = spantable.getStyles();
            if(styles != null)
                if(span.getSpanC() > 1 && span.getSpanR() > 1)
                    style = styles.get("span");
                else
                if(i % 2 == 0)
                    style = styles.get("even");
                else
                    style = styles.get("odd");
        }
        catch(SpanException spanexception) { }
        return style;
    }
    private static final long serialVersionUID = 1L;    
      private static ImageIcon createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
}

