package WorkSpace.Table;

import Core.member.InterfaceMember;
import Core.main.Core;
import Core.tree.MyDefaultMutableTreeNode;
import Core.tree.TreeMain;
import WorkSpace.Graphic.GOlap;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.*;
import java.util.Vector;
import org.olap4j.*;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.TableColumn;
import misc.swing.table.DefaultSpanCellRenderer;
import misc.swing.table.DefaultSpanHeaderCellRenderer;
import misc.swing.table.SpanException;
import misc.swing.table.SpanModel;
import misc.swing.table.SpanTable;
import misc.swing.table.SpanTableHeader;
import misc.swing.table.settings.Setting;
import misc.swing.table.settings.TableSetting;
import misc.swing.table.settings.TableStyles;
import org.olap4j.CellSet;
import org.olap4j.CellSetAxis;
import org.olap4j.Position;
import org.olap4j.metadata.Member;
public class TableOlap{
    boolean flagt=false;
    Vector selecion;
    private static final long serialVersionUID = 1L;
    private int N_ROWS=0;private int N_COLS=0;
    private int N_HEADER_ROWS=0;//numero de filas de la cabecera de la tabla (Header)
    private int N_FIXED_COLS=0;//numero de columnas de la tabla de la izquierda (FixedTable)
    private SpanTable dataTable;private SpanTable fixedTable; 
    private TableSetting tableSetting;
    TableSelectionModel tsm;
    Object [] etiquetasFixed;
    Object [] etiquetasData;
    String[][] MatrizFixed;
    String[][] MatrizFixed1;    
    String[][] matrizdataT;
    String[][] matrizdataT1;
    CellSet cellSet;
    Core core;
    JScrollPane pane1;
    GOlap grafico;
    JScrollPane paneG;
    
    TreeMain tRows;
    TreeMain tCols;
    
    MyDefaultMutableTreeNode Rroot;
    MyDefaultMutableTreeNode Croot;
    
    private int vecTams[] =null; //vector de tamaÃ±os mÃ¡ximos para las columnas
    private int vecTamsH[] =null;
    int scv=0;
    int sch=0;
            
    
    public TableOlap(CellSet cellSet, TreeMain tRows, TreeMain tCols,Core core, JScrollPane pane1,JScrollPane paneG) {         
        sch=pane1.getHorizontalScrollBar().getValue();
        scv=pane1.getVerticalScrollBar().getValue();        
        this.tRows=tRows;        
        this.tCols=tCols;
        this.core=core;
        this.pane1=pane1;
        this.paneG=paneG;
        this.Rroot=(MyDefaultMutableTreeNode) tRows.getModelo().getRoot();
        this.Croot=(MyDefaultMutableTreeNode) tCols.getModelo().getRoot();
        N_ROWS=Rroot.getLeafCount();//filas de la fixed
        N_FIXED_COLS=Rroot.getDepth();//columnas de la fixed
        N_HEADER_ROWS=Croot.getDepth();//filas de la header
        N_COLS=Croot.getLeafCount(); //columnas de la headr 
        vecTams = new int[N_FIXED_COLS];
        vecTamsH = new int[N_COLS];
        for(int i=0;i<N_FIXED_COLS;i++)
            vecTams[i]=0;
        for(int i=0;i<N_COLS;i++)
            vecTamsH[i]=0;
        construirMatrizFixed(cellSet);
        construirMatrizFixed1(cellSet);
        construirMatrizFixed2();
        construirMatrizdataT(cellSet);
        initComponents();
        grafico=new GOlap(matrizdataT,MatrizFixed,MatrizFixed1,paneG);                      
    }    
    public void TableOlapNew(CellSet cellSet, TreeMain tRows, TreeMain tCols,Core core, JScrollPane pane1,JScrollPane paneG) {         
        sch=pane1.getHorizontalScrollBar().getValue();
        scv=pane1.getVerticalScrollBar().getValue();        
        this.tRows=tRows;        
        this.tCols=tCols;
        this.core=core;
        this.pane1=pane1;
        this.paneG=paneG;
        this.Rroot=(MyDefaultMutableTreeNode) tRows.getModelo().getRoot();
        this.Croot=(MyDefaultMutableTreeNode) tCols.getModelo().getRoot();
        N_ROWS=Rroot.getLeafCount();//filas de la fixed
        N_FIXED_COLS=Rroot.getDepth();//columnas de la fixed
        N_HEADER_ROWS=Croot.getDepth();//filas de la header
        N_COLS=Croot.getLeafCount(); //columnas de la headr 
        vecTams = new int[N_FIXED_COLS];
        vecTamsH = new int[N_COLS];
        for(int i=0;i<N_FIXED_COLS;i++)
            vecTams[i]=0;
        for(int i=0;i<N_COLS;i++)
            vecTamsH[i]=0;
        construirMatrizFixed(cellSet);
        construirMatrizFixed1(cellSet);
        construirMatrizFixed2();
        construirMatrizdataT(cellSet);
        initComponents();
        grafico.setData(matrizdataT,MatrizFixed,MatrizFixed1,paneG);                      
    }    
    private void initComponents(){    
        Object[][] dataT=matrizdataT;
        Object[][] fixedT=MatrizFixed; 
        Object[][] fixedT1=MatrizFixed1;
        Object[][] fixedT2=matrizdataT1; 
        tableSetting=new TableSetting();
        tableSetting.setTableStyles(new TableStyles());        
        dataTable=createDataTable(N_HEADER_ROWS*2,dataT,fixedT1);
        fixedTable=createFixedTable(N_HEADER_ROWS*2,fixedT,fixedT2);
        fixedTable.getTableSelectionModel().addTableSelectionListener(new MyTableSelectionListener());          
        this.pane1.setRowHeaderView(fixedTable);
	this.pane1.setCorner(JScrollPane.UPPER_LEFT_CORNER, fixedTable.getTableHeader());
		// Ajustando el tamanio de viewport(RowHeader) al de fixedTable
        fixedTable.addComponentListener( new ComponentAdapter(){
            @Override
                        public void componentResized(ComponentEvent e) {  
                            pane1.getRowHeader()
					.setPreferredSize(fixedTable.getPreferredSize()); 
                        }            
                });
        TableColumn tCol = null;
        Integer t;
        for(int numCol=0; numCol<vecTams.length;numCol++){
            if(this.getFixedTable()!=null){
                tCol = this.getFixedTable().getColumnModel().getColumn(numCol);  
                t=((Integer)((vecTams[numCol])*7))+5;
                if(t>40)
                tCol.setPreferredWidth(t);
                else
                    tCol.setPreferredWidth(120);
                tCol=null;
            }
        }
        tCol=null;
        for(int numCol=0; numCol<vecTamsH.length;numCol++){
            if(this.getTable()!=null){
                tCol = this.getTable().getTableHeader().getColumnModel().getColumn(numCol); 
                t=((Integer)((vecTamsH[numCol])*7))+13;                
                 if(t>40)
                tCol.setPreferredWidth(t);
                else
                    tCol.setPreferredWidth(120);
                tCol=null;
            }
        } 
        this.pane1.setViewportView(dataTable);
        this.pane1.getHorizontalScrollBar().setValue(sch);
        this.pane1.getVerticalScrollBar().setValue(scv);
        this.pane1.updateUI();
        this.pane1.setVisible(true);        
    }             
    public SpanTable getFixedTable(){
            return fixedTable;    
        }
    public SpanTable getTable(){
            return dataTable;
        }
    private SpanTable createDataTable(int headerRow,Object[][] dataT,Object[][] fixedT1) {                
            SpanTable table=new SpanTable(dataT,etiquetasData){                
			private static final long serialVersionUID = 1L;                       
            @Override
			public Setting getSetting() {
				if(setting==null){setting= new Setting(false, true);
				}
				setting.setShowHorizontalLines(showHorizontalLines);
				setting.setShowVerticalLines(showVerticalLines);
				setting.setRowMargin(rowMargin);
				setting.setColumnMargin(getColumnModel().getColumnMargin());
				setting.setHorizontalLinesColor(horizontalLinesColor);
				setting.setVerticalLinesColor(verticalLinesColor);
				setting.setBackground(getBackground());
				setting.setForeground(getForeground());
				setting.setFont(getFont());
				setting.setHorizontalTextAlignment(horizontalTextAlignment);                                
				return setting;
			}			
		};
              
		final SpanTableHeader header=(SpanTableHeader) table.getTableHeader();
                
		header.setDataModel(new HeaderTableModel1(headerRow, table.getColumnModel(),fixedT1));	
                header.addMouseListener(new MouseAdapter(){
                        @Override
                        public void mouseClicked(MouseEvent e) {
				if(e.getButton()==1){
					int row=header.rowAtPoint(e.getPoint());
					int col=header.columnAtPoint(e.getPoint());                                       
                                        if(row%2==1){                                                                                        
                                            int colReal=obtengaIndiceReal2((row-1)/2,col,core.getTreeCol().getVectorMain());
                                            core.drillDown_RollUp(1, (row-1)/2, colReal);
                                            if(core.getBandera()&&core.getExito())                                                          
                                             TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG); 
                                        }
				}
				if(e.getButton()==3){
					int row=header.rowAtPoint(e.getPoint());
					int col=header.columnAtPoint(e.getPoint());                                       
                                        if(row%2==1){                                                                                        
                                            int colReal=obtengaIndiceReal2((row-1)/2,col,core.getTreeCol().getVectorMain());
                                            core.deleteMember(1, (row-1)/2, colReal);
                                            if(core.getBandera()&&core.getExito())                                                          
                                               TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG); 
                                        }
				}                                
                                
			}
                });
	       SpanModel spanModel=header.getSpanModel();                
               int retorno2=0;int retorno3=0;               
               for(int j=0;j<Croot.getChildCount();j++){                   
                    retorno3=spanH((MyDefaultMutableTreeNode)Croot.getChildAt(j),spanModel,retorno2)+retorno2;  
                    retorno2=retorno3;
               }                
	  //Example of SpanModel Setting    
	    table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
	    table.setDefaultRenderer(Object.class ,new DefaultSpanCellRenderer());
	    //table.getTableHeader().setDefaultRenderer(new DefaultSpanHeaderCellRenderer());
            table.getTableHeader().setDefaultRenderer(new RenderTablaCols(tCols));
	    table.setSetting(tableSetting.getDataSetting());
	    header.setSetting(tableSetting.getHeaderSetting());
            return table;
	}
    private SpanTable createFixedTable(int headerRow,Object[][] fixedT,Object[][] fixedT2) {  
        final SpanTable table=new SpanTable(fixedT,etiquetasFixed);                                  
        table.addMouseListener(new MouseAdapter() {                              
            @Override            
            public void mouseClicked(MouseEvent e) {
               
                if(e.getButton()==1){
                    int row=table.rowAtPoint(e.getPoint());
                    int col=table.columnAtPoint(e.getPoint());                                               
                    int rowReal=obtengaIndiceReal(row,col,core.getTreeRow().getVectorMain());
                    core.drillDown_RollUp(0, col, rowReal);                       
                    if(core.getBandera()&&core.getExito())                    
                        TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG); 
                }
                if(e.getButton()==2&&flagt){                           
                    final int row=table.rowAtPoint(e.getPoint());
                    final int col=table.columnAtPoint(e.getPoint());                                               
                    final int rowReal=obtengaIndiceReal(row,col,core.getTreeRow().getVectorMain());
                    final int mins=tsm.getListSelectionModelAt(col).getMinSelectionIndex();
                    final int maxs=tsm.getListSelectionModelAt(col).getMaxSelectionIndex();
                    if(mins==maxs){
                    JPopupMenu popup = new JPopupMenu();
                    popup.addSeparator();
                    popup.add("Delete Member").addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            String actCom = e.getActionCommand();
                            if(actCom.equals("Delete Member")){
                                core.deleteMember(0, col, rowReal);
                               if(core.getBandera()&&core.getExito())                    
                                    TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG);
                            }
                        }                        
                    });
                    popup.addSeparator();                    
                    popup.show(table, e.getX(), e.getY());                    
                    }else{                    
                    JPopupMenu popup = new JPopupMenu();
                    popup.addSeparator();
                    popup.add("Hold Members Selection").addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                                 String actCom = e.getActionCommand();
                                 System.out.println(table.getModel().getRowCount()); 
                                 if(actCom.equals("Hold Members Selection")){
                                     int d=((Vector)core.getTreeRow().getVectorMain().get(col)).size();
                                     int nr=table.getModel().getRowCount(); 
                                     selecion=new Vector();
                                 for (int r=nr-1;r>0;r--) {
                                    if (tsm.getListSelectionModelAt(col).isSelectedIndex(r))
                                    {   
                                      selecion.add(obtengaIndiceReal(r,col,core.getTreeRow().getVectorMain()));
                                    }
                                  }  
                                   boolean flag2=false;
                                  for(int p=d-1;p>0;p--) {  
                                      for (int r=0;r<selecion.size();r++) {                                      
                                        if(p==(Integer)selecion.get(r))
                                        {   flag2=true;
                                            break;
                                        }
                                      }
                                      if(!flag2){
                                          core.deleteMember(0, col,p);
                                      }
                                      flag2=false;
                                  }
                                  if(core.getExito())                    
                                     TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG);
                            }
                           
                        }                        
                    });;
                    popup.addSeparator();
                    popup.add("Delete Members Selection").addActionListener(new ActionListener() {
                        public void actionPerformed(ActionEvent e) {
                            String actCom = e.getActionCommand();                             
                            if(actCom.equals("Delete Members Selection")){
                                 for (int r=maxs;r>=mins;r--) {
                                    if (tsm.getListSelectionModelAt(col).isSelectedIndex(r))
                                    {  int rowReal=obtengaIndiceReal(r,col,core.getTreeRow().getVectorMain());
                                        core.deleteMember(0, col, rowReal);                                       
                                    }
                                  }                               
                               if(core.getExito())                    
                                    TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG);
                            }
                        }                        
                    });
                    popup.addSeparator();                    
                    popup.show(table, e.getX(), e.getY());   
                    }
                    flagt=false;
                }          
            }
        });
	SpanModel spanModel=table.getSpanModel();
        int retorno2=0;int retorno3=0;               
        for(int j=0;j<Rroot.getChildCount();j++){                   
              retorno3=span((MyDefaultMutableTreeNode)Rroot.getChildAt(j),spanModel,retorno2)+retorno2;  
              retorno2=retorno3;
        }                	
	final SpanTableHeader header=(SpanTableHeader) table.getTableHeader();
        header.setDataModel(new HeaderTableModel1(headerRow, table.getColumnModel(),fixedT2));		
	spanModel=header.getSpanModel();
        header.addMouseListener(new MouseAdapter(){
            @Override
            public void mouseClicked(MouseEvent e) {  
                final int row=header.rowAtPoint(e.getPoint());
              if(e.getClickCount()==1&&e.getButton()==1&&row<header.getRowCount()-1){
                    core.pivot();                     
                    TableOlapNew(core.getCellSet(),core.getTreeRow(),core.getTreeCol(),core,pane1,paneG);                                       
                }				
            }
        });
	try {            
            spanModel.combine(0,0,N_HEADER_ROWS*2-1,N_FIXED_COLS);			
        }catch (SpanException e) {
            e.printStackTrace();
        }

        table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);        
        table.setDefaultRenderer(Object.class , new RenderTablaRows(tRows));
	table.getTableHeader().setDefaultRenderer(new DefaultSpanHeaderCellRenderer());        
	table.setSetting(tableSetting.getRowHeaderSetting());
	header.setSetting(tableSetting.getHeaderSetting());
        return table;
    }
    private void construirMatrizFixed(CellSet cellSet){
        List<CellSetAxis> cellSetAxisList=cellSet.getAxes();// obtiene el numero de los ejes que por supuesto es 2
        CellSetAxis cellSetAxisElemento= cellSetAxisList.get(1);//Obtenemos el eje numero 1 que es el de 
        //Axis axisElemento=cellSetAxisElemento.getAxisOrdinal();
        List<Position> positionList=cellSetAxisElemento.getPositions();//obtiene la lista de nombres de las filas   
        MatrizFixed=new String[N_ROWS][N_FIXED_COLS];//3 por que corresponde al numero de dimeniones
        etiquetasFixed=new Object[N_FIXED_COLS];
        for(int i=0;i<N_ROWS;i++){
            Position positionElemento=positionList.get(i);
            List<Member> memberList= positionElemento.getMembers();
            for(int j=0;j<N_FIXED_COLS;j++){
                Member memberElemento=memberList.get(j);        
                if(memberElemento.getName().length()>=memberElemento.getDimension().getName().length())
                    if(memberElemento.getName().length()>=vecTams[j])                        
                        vecTams[j]=memberElemento.getName().length();
                else
                    if(memberElemento.getDimension().getName().length()>=vecTams[j])                        
                        vecTams[j]=memberElemento.getDimension().getName().length();
                MatrizFixed[i][j]=memberElemento.getName(); 
                etiquetasFixed[j]=memberElemento.getDimension().getName();
            }
        }
               
    }
    private void construirMatrizdataT(CellSet cellSet){
        matrizdataT=new String[N_ROWS][N_COLS];//1 por que corresponde al numero de medidas
        for (int row = 0; row < N_ROWS; row++) {
            for (int col = 0; col < N_COLS; col++) {
                List positions = new ArrayList(2);
                positions.add(col);
                positions.add(row);
                Cell cell = cellSet.getCell(positions);
                matrizdataT[row][col]=cell.getFormattedValue();                
            }
        }       
                     
    }    
    private void construirMatrizFixed1(CellSet cellSet){
        List<CellSetAxis> cellSetAxisList=cellSet.getAxes();// obtiene el numero de los ejes que por supuesto es 2
        CellSetAxis cellSetAxisElemento= cellSetAxisList.get(0);//Obtenemos el eje numero 1 que es el de 
        //Axis axisElemento=cellSetAxisElemento.getAxisOrdinal();
        List<Position> positionList=cellSetAxisElemento.getPositions();//obtiene la lista de nombres de las filas   
        MatrizFixed1=new String[N_COLS][N_HEADER_ROWS*2];//3 por que corresponde al numero de dimeniones
        etiquetasData=new Object[N_COLS];        
        int l=0;
        for(int i=0;i<N_COLS;i++){
            Position positionElemento=positionList.get(i);
            List<Member> memberList= positionElemento.getMembers();            
            for(int j=0;j< N_HEADER_ROWS;j++){
                Member memberElemento=memberList.get(j);
                if(memberElemento.getName().length()>=memberElemento.getDimension().getName().length())
                {     if(memberElemento.getName().length()>vecTamsH[i])
                        vecTamsH[i]=memberElemento.getName().length();
                }       
                else{
                    if(memberElemento.getDimension().getName().length()>vecTamsH[i])
                        vecTamsH[i]=memberElemento.getDimension().getName().length();
                }
                MatrizFixed1[i][(j*2)]=memberElemento.getDimension().getName();   
                MatrizFixed1[i][j*2+1]=memberElemento.getName();                    
                etiquetasData[i]=memberElemento.getName();
                
              
            }             
        }            
    }
    private void construirMatrizFixed2() {
        matrizdataT1=new String[N_HEADER_ROWS*2][N_FIXED_COLS];
        for (int row = 0; row < N_HEADER_ROWS*2; row++) 
            for (int col = 0; col < N_FIXED_COLS; col++)              
                matrizdataT1[row][col]=""; 
    }      
    
    private int span(MyDefaultMutableTreeNode child, SpanModel spanModel, int filaInicial) {
        int retorno=0;
         try {
                if(child.getChildCount()>0){
                   spanModel.combine(filaInicial,child.getLevel()-1,child.getLeafCount(),1);
                    //System.out.println(child.getChildCount()+"    naviad"+(child.getLevel()-1));
                   retorno=child.getLeafCount();//solo que retorno mi hojas
                   int retorno2=filaInicial;int retorno3=0;               
                   for(int j=0;j<child.getChildCount();j++){                   
                        retorno3=span((MyDefaultMutableTreeNode)child.getChildAt(j),spanModel,retorno2)+retorno2;  
                        retorno2=retorno3;
                   }                
                }                                       
            } catch (SpanException e) {
                    e.printStackTrace();
                    System.out.println("Hubo in problemma span");
           }
          
           return retorno;

    }    
    private int spanH(MyDefaultMutableTreeNode child, SpanModel spanModel, int columnaInicial) {
        int retorno=0;
         try {
               if(child.getChildCount()>0){
                   int columnasSpaneadas=child.getLeafCount();                  
                   spanModel.combine((child.getLevel()-1)*2,columnaInicial,1,columnasSpaneadas);
                   spanModel.combine((child.getLevel()-1)*2+1,columnaInicial,1,columnasSpaneadas);
                   
                   retorno=child.getLeafCount();//solo que retorno mi hojas
                   int retorno2=columnaInicial;int retorno3=0;               
                   for(int j=0;j<child.getChildCount();j++){                   
                        retorno3=spanH((MyDefaultMutableTreeNode)child.getChildAt(j),spanModel,retorno2)+retorno2;  
                        retorno2=retorno3;
                   }
               }   
            } catch (SpanException e) {
                    e.printStackTrace();
                    System.out.println("Hubo in problemma span");
           }
          
           return retorno;
    }      
    private int obtengaIndiceReal(int row, int col,Vector vectorMainRow) {

                int retorno=row;
                InterfaceMember interfaceMember=new InterfaceMember(vectorMainRow);
                    for(int j=interfaceMember.getNumDimension()-1;j>col;j--){
                        retorno=interfaceMember.getMyNodeMember(j,retorno).getFather();
                    }
                return retorno;
            }
         private int obtengaIndiceReal2(int row, int col, Vector vectorMainCol) {
                int retorno=col;
                InterfaceMember interfaceMember=new InterfaceMember(vectorMainCol);
                    for(int j=interfaceMember.getNumDimension()-1;j>row;j--){
                        retorno=interfaceMember.getMyNodeMember(j,retorno).getFather();
                    }
                return retorno;         
     }
         public GOlap getGrafico()
         {
             return this.grafico;
         }
public class MyTableSelectionListener implements TableSelectionListener {
    public void valueChanged(TableSelectionEvent e) {
       flagt=true;
      tsm = (TableSelectionModel)(e.getSource());      
      int column = e.getColumnIndex();
      int firstIndex = e.getFirstIndex();
      int lastIndex = e.getLastIndex();
      boolean isAdjusting = e.getValueIsAdjusting();
      System.out.println("tsm="+tsm);
      System.out.println("column="+column);
      System.out.println("firstIndex="+firstIndex);
      System.out.println("lastIndex="+lastIndex);
      System.out.println("isAdjusting="+isAdjusting);
    }
  }
}

