package WorkSpace.main;

import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import com.nilo.plaf.nimrod.NimRODTheme;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;
import javax.swing.plaf.ColorUIResource;

// Referenced classes of package com.nilo.plaf.nimrod:
//            NimRODLookAndFeel, NimRODTheme

class NimRODUtils
{

    NimRODUtils()
    {
    }

    static Color getSombra()
    {
        return getColorAlfa(getColorTercio(NimRODLookAndFeel.getControlDarkShadow(), Color.black), 64);
    }

    static Color getBrillo()
    {
        return getColorAlfa(getColorTercio(NimRODLookAndFeel.getControlHighlight(), Color.white), 64);
    }

    static Color getSombraMenu()
    {
        return new Color(20, 20, 20, 50);
    }

    static Color getBrilloMenu()
    {
        return new Color(255, 255, 255, 64);
    }

    static NimRODTheme iniCustomColors(NimRODTheme nimrodtheme, String s, String s1, String s2, String s3, String s4, String s5, String s6, 
            String s7, String s8, String s9, String s10, String s11)
    {
        if(s != null)
            nimrodtheme.setPrimary(Color.decode(s));
        if(s1 != null)
            nimrodtheme.setSecondary(Color.decode(s1));
        if(s2 != null)
           nimrodtheme.setPrimary1(Color.decode(s2));
        if(s3 != null)
            nimrodtheme.setPrimary2(Color.decode(s3));
        if(s4 != null)
            nimrodtheme.setPrimary3(Color.decode(s4));
        if(s5 != null)
            nimrodtheme.setSecondary1(Color.decode(s5));
        if(s6 != null)
            nimrodtheme.setSecondary2(Color.decode(s6));
        if(s7 != null)
            nimrodtheme.setSecondary3(Color.decode(s7));
        if(s8 != null)
            nimrodtheme.setWhite(Color.decode(s8));
        if(s9 != null)
            nimrodtheme.setBlack(Color.decode(s9));
        if(s10 != null)
            nimrodtheme.setMenuOpacity(Integer.parseInt(s10));
        if(s11 != null)
            nimrodtheme.setFrameOpacity(Integer.parseInt(s11));
        return nimrodtheme;
    }

 
    static byte[] readStream(InputStream inputstream)
        throws IOException
    {
        ByteArrayOutputStream bytearrayoutputstream = new ByteArrayOutputStream();
        byte abyte0[] = new byte[256];
        int i;
        while((i = inputstream.read(abyte0, 0, 256)) != -1) 
            bytearrayoutputstream.write(abyte0, 0, i);
        return bytearrayoutputstream.toByteArray();
    }

    static void pintaBarraMenu(Graphics g, JMenuItem jmenuitem, Color color)
    {
        ButtonModel buttonmodel = jmenuitem.getModel();
        Color color1 = g.getColor();
        int i = jmenuitem.getWidth();
        int j = jmenuitem.getHeight();
        if(jmenuitem.isOpaque())
        {
            g.setColor(jmenuitem.getBackground());
            g.fillRect(0, 0, i, j);
        }
        if((jmenuitem instanceof JMenu) && !((JMenu)jmenuitem).isTopLevelMenu() && buttonmodel.isSelected() || buttonmodel.isArmed())
        {
            java.awt.geom.RoundRectangle2D.Float float1 = new java.awt.geom.RoundRectangle2D.Float();
            float1.x = 1.0F;
            float1.y = 0.0F;
            float1.width = i - 3;
            float1.height = j - 1;
            float1.arcwidth = 8F;
            float1.archeight = 8F;
            GradientPaint gradientpaint = new GradientPaint(1.0F, 1.0F, getBrilloMenu(), 0.0F, j, getSombraMenu());
            Graphics2D graphics2d = (Graphics2D)g;
            graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            g.setColor(color);
            graphics2d.fill(float1);
            g.setColor(color.darker());
            graphics2d.draw(float1);
            graphics2d.setPaint(gradientpaint);
            graphics2d.fill(float1);
            graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_DEFAULT);
        }
        g.setColor(color1);
    }

    static void paintFocus(Graphics g, int i, int j, int k, int l, int i1, int j1, Color color)
    {
        paintFocus(g, i, j, k, l, i1, j1, 2.0F, color);
    }

    static void paintFocus(Graphics g, int i, int j, int k, int l, int i1, int j1, float f, 
            Color color)
    {
        Graphics2D graphics2d = (Graphics2D)g;
        graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        java.awt.Stroke stroke = graphics2d.getStroke();
        graphics2d.setColor(color);
        graphics2d.setStroke(new BasicStroke(f));
        if(i1 == 0 && j1 == 0)
            g.drawRect(i, j, k, l);
        else
            g.drawRoundRect(i, j, k - 1, l - 1, i1, j1);
        graphics2d.setStroke(stroke);
        graphics2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_DEFAULT);
    }

    static Color getRolloverColor()
    {
        if(rollColor == null)
            rollColor = getColorAlfa(UIManager.getColor("Button.focus"), 40);
        return rollColor;
    }

    static Color getColorAlfa(Color color, int i)
    {
        return new Color(color.getRed(), color.getGreen(), color.getBlue(), i);
    }

    static Color getColorMedio(Color color, Color color1)
    {
        return new Color(propInt(color.getRed(), color1.getRed(), 2), propInt(color.getGreen(), color1.getGreen(), 2), propInt(color.getBlue(), color1.getBlue(), 2));
    }

    static ColorUIResource getColorTercio(Color color, Color color1)
    {
        return new ColorUIResource(propInt(color.getRed(), color1.getRed(), 3), propInt(color.getGreen(), color1.getGreen(), 3), propInt(color.getBlue(), color1.getBlue(), 3));
    }

    private static int propInt(int i, int j, int k)
    {
        return j + (i - j) / k;
    }

    static void paintShadowTitleFat(Graphics g, String s, int i, int j, Color color)
    {
        paintShadowTitle(g, s, i, j, color, Color.black, 1, 1, 0);
    }

    static void paintShadowTitleFat(Graphics g, String s, int i, int j, Color color, Color color1)
    {
        paintShadowTitle(g, s, i, j, color, color1, 1, 1, 0);
    }

    static void paintShadowTitleFat(Graphics g, String s, int i, int j, Color color, Color color1, int k)
    {
        paintShadowTitle(g, s, i, j, color, color1, k, 1, 0);
    }

    static void paintShadowTitleThin(Graphics g, String s, int i, int j, Color color)
    {
        paintShadowTitle(g, s, i, j, color, Color.black, 1, 0, 0);
    }

    static void paintShadowTitleThin(Graphics g, String s, int i, int j, Color color, Color color1)
    {
        paintShadowTitle(g, s, i, j, color, color1, 1, 0, 0);
    }

    static void paintShadowTitleThin(Graphics g, String s, int i, int j, Color color, Color color1, int k)
    {
        paintShadowTitle(g, s, i, j, color, color1, k, 0, 0);
    }

    static void paintShadowTitleFatV(Graphics g, String s, int i, int j, Color color)
    {
        paintShadowTitle(g, s, i, j, color, Color.black, 1, 1, 1);
    }

    static void paintShadowTitleFatV(Graphics g, String s, int i, int j, Color color, Color color1)
    {
        paintShadowTitle(g, s, i, j, color, color1, 1, 1, 1);
    }

    static void paintShadowTitleFatV(Graphics g, String s, int i, int j, Color color, Color color1, int k)
    {
        paintShadowTitle(g, s, i, j, color, color1, k, 1, 1);
    }

    static void paintShadowTitleThinV(Graphics g, String s, int i, int j, Color color)
    {
        paintShadowTitle(g, s, i, j, color, Color.black, 1, 0, 1);
    }

    static void paintShadowTitleThinV(Graphics g, String s, int i, int j, Color color, Color color1)
    {
        paintShadowTitle(g, s, i, j, color, color1, 1, 0, 1);
    }

    static void paintShadowTitleThinV(Graphics g, String s, int i, int j, Color color, Color color1, int k)
    {
        paintShadowTitle(g, s, i, j, color, color1, k, 0, 1);
    }

    static void paintShadowTitle(Graphics g, String s, int i, int j, Color color, Color color1, int k, int l, 
            int i1)
    {
        Font font = g.getFont();
        if(i1 == 1)
        {
            AffineTransform affinetransform = AffineTransform.getRotateInstance(1.5707963267948966D);
            font = font.deriveFont(affinetransform);
        }
        if(color1 != null)
        {
            byte byte0 = ((byte)(l != 0 ? 5 : 3));
            Rectangle2D rectangle2d = g.getFontMetrics().getStringBounds(s, g);
            int j1;
            int k1;
            if(i1 == 0)
            {
                j1 = (int)rectangle2d.getWidth() + 6 * byte0;
                k1 = (int)rectangle2d.getHeight() + 6 * byte0;
            } else
            {
                k1 = (int)rectangle2d.getWidth() + 6 * byte0;
                j1 = (int)rectangle2d.getHeight() + 6 * byte0;
            }
            BufferedImage bufferedimage = new BufferedImage(j1, k1, 2);
            BufferedImage bufferedimage1 = new BufferedImage(j1, k1, 2);
            Graphics2D graphics2d = bufferedimage.createGraphics();
            graphics2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
            graphics2d.setFont(font);
            graphics2d.setColor(color1);
            graphics2d.drawString(s, 3 * byte0, 3 * byte0);
            ConvolveOp convolveop = new ConvolveOp(l != 0 ? kernelFat : kernelThin, 1, null);
            convolveop.filter(bufferedimage, bufferedimage1);
            g.drawImage(bufferedimage1, (i - 3 * byte0) + k, (j - 3 * byte0) + k, null);
        }
        if(color != null)
        {
            g.setFont(font);
            g.setColor(color);
            g.drawString(s, i, j);
        }
    }

    static Icon reescala(Icon icon, int i, int j)
    {
        if(icon == null)
            return null;
        if(icon.getIconHeight() == j && icon.getIconWidth() == i)
        {
            return icon;
        } else
        {
            BufferedImage bufferedimage = new BufferedImage(icon.getIconHeight(), icon.getIconWidth(), 2);
            Graphics2D graphics2d = bufferedimage.createGraphics();
            icon.paintIcon(null, graphics2d, 0, 0);
            graphics2d.dispose();
            java.awt.Image image = bufferedimage.getScaledInstance(i, j, 4);
            return new ImageIcon(image);
        }
    }

    static int getOpacity()
    {
        return getMenuOpacity();
    }

    static int getMenuOpacity()
    {
        try
        {
            NimRODTheme nimrodtheme = (NimRODTheme)NimRODLookAndFeel.getCurrentTheme();
            return nimrodtheme.getMenuOpacity();
        }
        catch(Throwable throwable)
        {
            return 195;
        }
    }

    static float getMenuOpacityFloat()
    {
        return (float)getMenuOpacity() / 255F;
    }

    static int getFrameOpacity()
    {
        try
        {
         NimRODTheme nimrodtheme = (NimRODTheme)NimRODLookAndFeel.getCurrentTheme();
            return nimrodtheme.getFrameOpacity();
        }
        catch(Throwable throwable)
        {
            return 180;
        }
    }

    static float getFrameOpacityFloat()
    {
        return (float)getFrameOpacity() / 255F;
    }

    public static Color rollColor;
    static final int THIN = 0;
    static final int FAT = 1;
    static final int MATRIX_FAT = 5;
    static Kernel kernelFat;
    static final int MATRIX_THIN = 3;
    static Kernel kernelThin;
}