package WorkSpace.main;
import WorkSpace.MainApp;
import javax.help.*;
import Core.ManagerCube.Manager;
import WorkSpace.Account.Account;
import WorkSpace.Account.NewAccount;
import WorkSpace.Cube.MyCubes;
import WorkSpace.CubeConfiguration.Wizard_ConfCube;
import WorkSpace.ToolBar.About;
import WorkSpace.ToolBar.ToolBar;
import com.nilo.plaf.nimrod.NimRODLookAndFeel;
import info.clearthought.layout.TableLayout;
import org.jdesktop.swingx.JXMonthView;
import org.noos.common.Question;
import org.noos.common.context.Context;
import org.noos.common.object.ObjectCreator;
import org.noos.xing.mydoggy.*;
import static org.noos.xing.mydoggy.ToolWindowManagerDescriptor.Corner.*;
import org.noos.xing.mydoggy.event.ContentManagerEvent;
import org.noos.xing.mydoggy.event.ContentManagerUIEvent;
import org.noos.xing.mydoggy.mydoggyset.action.*;
import org.noos.xing.mydoggy.mydoggyset.context.MyDoggySetContext;
import org.noos.xing.mydoggy.mydoggyset.ui.MonitorPanel;
import org.noos.xing.mydoggy.mydoggyset.ui.RuntimeMemoryMonitorSource;
import org.noos.xing.mydoggy.plaf.MyDoggyToolWindowManager;
import org.noos.xing.mydoggy.plaf.ui.CustomDockableDescriptor;
import org.noos.xing.mydoggy.plaf.ui.DockableDescriptor;
import org.noos.xing.mydoggy.plaf.ui.ResourceManager;
import org.noos.xing.mydoggy.plaf.ui.cmp.ExtendedTableLayout;
import org.noos.xing.mydoggy.plaf.ui.content.MyDoggyMultiSplitContentManagerUI;
import org.noos.xing.mydoggy.plaf.ui.look.MyDoggyResourceManager;
import org.noos.xing.mydoggy.plaf.ui.util.ParentOfQuestion;
import org.noos.xing.mydoggy.plaf.ui.util.StringUtil;
import org.noos.xing.mydoggy.plaf.ui.util.SwingUtil;
import org.noos.xing.yasaf.view.ViewContext;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Locale;
import java.util.Properties;
import org.jdesktop.swingx.JXLoginPane;
import org.jdesktop.swingx.JXLoginPane.Status;
import org.jdesktop.swingx.auth.JDBCLoginService;

public class StarCubeDoggySet {
    public JFrame frame;
    Manager manager;
    protected ToolWindowManager toolWindowManager;
    protected ViewContext myDoggySetContext;
    protected DockableDescriptor memoryMonitorDescriptor;
    JXLoginPane paneuser = null;
    JDBCLoginService svc;
    private Wizard_ConfCube demoDialogo;
    protected String username;
     Connection con = null;
     PreparedStatement ps = null;
     ResultSet rs = null;
     int lookandfeel=8;
     int superuser=1;
     JScrollPane pane1;
     JScrollPane paneG;
     JPanel pane,paneDice,mdx,paneMeasures;
     ToolBar tbstarcube;
    public StarCubeDoggySet(){   
       logeo();
    }

    public void setUp( String username) {
        this.username=username;
        initComponents();
        initToolWindowManager();
    }

    public void start(final Runnable runnable) {        
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                     
                    myDoggySetContext.put(StarCubeDoggySet.class, null);
                    SwingUtil.centrePositionOnScreen(frame); 
                    frame.setIconImage(createImageIcon("resources/iconw.GIF"));
                    frame.setTitle("STARCUBE 2.0 - Logged as "+username);            
                    frame.setVisible(true);
                    MyLookAndFeel nt= new MyLookAndFeel(lookandfeel,frame);
                    NimRODLookAndFeel NimRODLF = new NimRODLookAndFeel();
                    NimRODLookAndFeel.setCurrentTheme(nt.getTheme());
                    UIManager.setLookAndFeel(NimRODLF);         
                    memoryMonitorDescriptor.setAvailable(true);
                    if (runnable != null) {
                        Thread t = new Thread(runnable);
                        t.start();
                    }
                } catch (UnsupportedLookAndFeelException ex) {
                    
                }
            }
        });
    }

    public ToolWindowManager getToolWindowManager() {
        return toolWindowManager;
    }
    public ViewContext getMyDoggySetContext() {
        return myDoggySetContext;
    }
    protected void initComponents() {        
        // Init the frame        
        this.frame = new JFrame("STARCUBE ROLAP PROJECT");      
        this.frame.setSize(Toolkit.getDefaultToolkit().getScreenSize().width,Toolkit.getDefaultToolkit().getScreenSize().height);
        this.frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.frame.getContentPane().setLayout(new ExtendedTableLayout(new double[][]{{0,0,-1,0}, {35,0,-1,0,15}}));
         // Init ToolWindowManager
        MyDoggyToolWindowManager myDoggyToolWindowManager = new MyDoggyToolWindowManager(Locale.getDefault(), null);
        // Apply now all customization if necessary
        customizeToolWindowManager(myDoggyToolWindowManager);
        this.toolWindowManager = myDoggyToolWindowManager;
        this.myDoggySetContext = new MyDoggySetContext(toolWindowManager,frame);
        initMenuBar();  
    }

    protected void initMenuBar() {
        JMenuBar menuBar = new JMenuBar();
        JMenu fileMenu = new JMenu("File");
        fileMenu.addSeparator();
        JMenuItem menuIte=new JMenuItem("Log out");
        menuIte.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    dispose();
                    logeo();
                }
            });    
        fileMenu.add(menuIte);         
        fileMenu.add(new ExitAction(frame));        
        // View Menu
        JMenu viewMenu = new JMenu("View");
        viewMenu.add(new FrameshotAction(frame));
        viewMenu.add(new FramePieceshotAction(frame));
        viewMenu.add(new MagnifierAction(frame));
        // Content Menu
       
         JMenu contentMenu1 = new JMenu("Help");
                JMenuItem menuIte1=new JMenuItem("Help Contents");
                menuIte1.addActionListener(new ActionListener() {
                    @SuppressWarnings("static-access")
                    public void actionPerformed(ActionEvent e) {
                try {
                    HelpSet hs;
                    HelpBroker hb;
                    URL hsURL = this.getClass().getResource("Help/starcube_helpset.hs");
                    hs = new HelpSet(getClass().getClassLoader(),hsURL);                    
                    HelpSet.Presentation hsp = hs.getPresentation("MainWin");                    
                    hb = hs.createHelpBroker();                    
                    hb.setHelpSetPresentation(hsp);
                    hb.setSize(new Dimension(800,600));
                    hb.setDisplayed(true);                    
                } catch (HelpSetException ex) { 
                    System.out.println(""+ex);
                }
                        }
        });   
                JMenuItem menuI=new JMenuItem("About");
                menuI.addActionListener(new ActionListener() {
                    @SuppressWarnings("static-access")
                    public void actionPerformed(ActionEvent e) {
                         About about = new About(frame,true);                  
                            about.setLocationRelativeTo(frame);                            
                            MainApp.getApplication().show(about);
                    }
               
        });   
       contentMenu1.add(menuIte1);
       contentMenu1.add(menuI);
        JMenu lafMenu = new JMenu("Looks");
        ButtonGroup group = new ButtonGroup( );
        JMenuItem menuItem  = new JRadioButtonMenuItem("Steel");                
        menuItem  = new JRadioButtonMenuItem("Chocolate");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);        
         menuItem  = new JRadioButtonMenuItem("Metalic");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);        
        menuItem  = new JRadioButtonMenuItem("Cake");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);
        menuItem  = new JRadioButtonMenuItem("Jungle");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);
        menuItem  = new JRadioButtonMenuItem("Spring");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);
        menuItem  = new JRadioButtonMenuItem("Ocean");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);
        menuItem  = new JRadioButtonMenuItem("Autumn");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem);
        menuItem  = new JRadioButtonMenuItem("Sun");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem); 
        menuItem  = new JRadioButtonMenuItem("Steel");        
        menuItem.setMnemonic(KeyEvent.VK_R);
        menuItem.addActionListener(new MyItemListenerLookAndFeel(frame,con,username,pane1));
        group.add(menuItem);
        lafMenu.add(menuItem); 
        menuBar.add(fileMenu);
        menuBar.add(viewMenu);
         JMenu contentMenu = new JMenu("Create Cube Shema");
         if (superuser==1)
         {   
                JMenuItem menuIte2=new JMenuItem("Configure Cube");
                menuIte2.addActionListener(new ActionListener() {
                    @SuppressWarnings("static-access")
                    public void actionPerformed(ActionEvent e) {        
                            demoDialogo = new Wizard_ConfCube(frame,true,con);                  
                            SwingUtil.centrePositionOnScreen(demoDialogo); 
                            demoDialogo.setUserName(username);
                            demoDialogo.setSize(Toolkit.getDefaultToolkit().getScreenSize());
                            MainApp.getApplication().show(demoDialogo);
                        }
                    });   
                contentMenu.add(menuIte2);
                menuBar.add(contentMenu);   
         }
       menuBar.add(contentMenu1);
        menuBar.setBorderPainted(true);
       pane1=new JScrollPane();
       pane=new JPanel();
       paneDice=new JPanel();
       mdx=new JPanel();
       paneMeasures=new JPanel();              
       paneG=new JScrollPane();  
       StatusBar statusb=new StatusBar();
       manager=new Manager(pane1,paneG,mdx,paneDice,paneMeasures,statusb);  
       tbstarcube=new ToolBar(manager,toolWindowManager,con,username,frame,superuser);        
       this.frame.setJMenuBar(menuBar);        
       this.frame.add((Component) tbstarcube.gettoolTb(), "2,0,");       
       this.frame.add((Component)statusb , "2,4,");       
              
        
    }

    protected void initToolWindowManager() {
        // Setup type descriptor templates...
        FloatingTypeDescriptor typeDescriptor = (FloatingTypeDescriptor) toolWindowManager.getTypeDescriptorTemplate(ToolWindowType.FLOATING);
        typeDescriptor.setTransparentDelay(0);  
       NewAccount account = new NewAccount(con); 
       Account daccount=new Account(con,username,account);      
       toolWindowManager.registerToolWindow("User Accounts", "User Accounts",
               createIcon("resources/usert.png"),daccount, ToolWindowAnchor.RIGHT);
       ToolWindow userTool = toolWindowManager.getToolWindow("User Accounts");
       daccount.setToolWindow(userTool);
       userTool.addToolWindowTab("Account", account);      
       toolWindowManager.registerToolWindow("Dice", "Dice",
                           createIcon("resources/dicet.gif"),paneDice, ToolWindowAnchor.RIGHT);
       toolWindowManager.registerToolWindow("Cube Navigator", "Cube Navigator",
                           createIcon("resources/navigatort.gif"),pane, ToolWindowAnchor.LEFT);     
       ToolWindow toolWindow;
       toolWindow = toolWindowManager.getToolWindow("Cube Navigator");
       toolWindow.setActive(false);
       MyCubes cubos=new MyCubes(con,toolWindow,pane,manager,username);
       toolWindowManager.registerToolWindow("Open Cube", "Open Cube",
                            createIcon("resources/icont.png"), cubos, ToolWindowAnchor.LEFT);
       toolWindowManager.registerToolWindow("Measures", "Measures",
                            createIcon("resources/medidast.png"), paneMeasures, ToolWindowAnchor.RIGHT);
        MonitorPanel monitorPanel = new MonitorPanel(new RuntimeMemoryMonitorSource());
        monitorPanel.start();     
       toolWindowManager.registerToolWindow("Memory Monitor", "Memory Monitor", null, monitorPanel, ToolWindowAnchor.BOTTOM);               
         
        for (ToolWindow window : toolWindowManager.getToolWindows()) {
            window.setAvailable(true);
        }
        DockedTypeDescriptor dockedTypeDescriptor;
        toolWindow = toolWindowManager.getToolWindow("User Accounts");
        if (superuser==1)
            toolWindow.setVisible(false);
        else
            toolWindow.setAvailable(false);        
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(100);
          toolWindow = toolWindowManager.getToolWindow("Cube Navigator");
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(320);
        toolWindow.setActive(false);
        //dockedTypeDescriptor.//;
         toolWindow = toolWindowManager.getToolWindow("Dice");
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(320);
         toolWindow = toolWindowManager.getToolWindow("Open Cube");
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(320);
         toolWindow = toolWindowManager.getToolWindow("User Accounts");                 
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(250);
        toolWindow = toolWindowManager.getToolWindow("Measures");
        dockedTypeDescriptor = toolWindow.getTypeDescriptor(DockedTypeDescriptor.class);
        dockedTypeDescriptor.setDockLength(320);
        toolWindow = toolWindowManager.getToolWindow("Memory Monitor");
        toolWindow.setType(ToolWindowType.DOCKED);
        FloatingTypeDescriptor floatingTypeDescriptor = toolWindow.getTypeDescriptor(FloatingTypeDescriptor.class);
        floatingTypeDescriptor.setModal(true);
        floatingTypeDescriptor.setAnimating(true);

        // Setup ContentManager
        toolWindowManager.getContentManager().addContentManagerListener(new ContentManagerListener() {
            public void contentAdded(ContentManagerEvent event) {
                event.getContent().addPropertyChangeListener(new PropertyChangeListener() {
                    public void propertyChange(PropertyChangeEvent evt) {

                        StringBuffer sb = new StringBuffer("Event : ");
                        sb.append(evt.getPropertyName())
                                .append(" ; ")
                                .append(evt.getOldValue())
                                .append(" -> ")
                                .append(evt.getNewValue())
                                .append(" ; ")
                                .append(evt.getSource());
                        System.out.println(sb);

                //new RuntimeException().printStackTrace();
                System.out.println("----------------------------------------------------------");
                    }
                });
            }

            public void contentRemoved(ContentManagerEvent event) {
//                System.out.println("Content removed " + event);
            }

            public void contentSelected(ContentManagerEvent event) {
            }
        });


        // Setup ContentManagerUI
        toolWindowManager.getContentManager().setContentManagerUI(new MyDoggyMultiSplitContentManagerUI());

        MultiSplitContentManagerUI contentManagerUI = (MultiSplitContentManagerUI) toolWindowManager.getContentManager().getContentManagerUI();
        contentManagerUI.setShowAlwaysTab(true);
        contentManagerUI.setTabPlacement(TabbedContentManagerUI.TabPlacement.BOTTOM);
        contentManagerUI.setTabLayout(TabbedContentManagerUI.TabLayout.SCROLL);
        contentManagerUI.addContentManagerUIListener(new ContentManagerUIListener() {
            public boolean contentUIRemoving(ContentManagerUIEvent event) {
                return JOptionPane.showConfirmDialog(frame, "Are you sure?") == JOptionPane.OK_OPTION;
            }

            public void contentUIDetached(ContentManagerUIEvent event) {
            }
        });

//        contentManagerUI.setMinimizable(false);

        // Setup Corner Components
        ToolWindowManagerDescriptor managerDescriptor = toolWindowManager.getToolWindowManagerDescriptor();

        JButton nwButton = new JButton(SwingUtil.loadIcon("org/noos/xing/mydoggy/mydoggyset/icons/plus.png"));
        nwButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int length = toolWindowManager.getToolWindowBar(ToolWindowAnchor.TOP).getLength() + 1;
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.BOTTOM).setLength(length);
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.TOP).setLength(length);
            }
        });

        JButton swButton = new JButton(SwingUtil.loadIcon("org/noos/xing/mydoggy/mydoggyset/icons/minus.png"));
        swButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int length = toolWindowManager.getToolWindowBar(ToolWindowAnchor.TOP).getLength() - 1;
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.BOTTOM).setLength(length);
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.TOP).setLength(length);
            }
        });

        JButton neButton = new JButton(SwingUtil.loadIcon("org/noos/xing/mydoggy/mydoggyset/icons/plus.png"));
        neButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int length = toolWindowManager.getToolWindowBar(ToolWindowAnchor.LEFT).getLength() + 1;
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.LEFT).setLength(length);
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.RIGHT).setLength(length);
            }
        });

        JButton seButton = new JButton(SwingUtil.loadIcon("org/noos/xing/mydoggy/mydoggyset/icons/minus.png"));
        seButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int length = toolWindowManager.getToolWindowBar(ToolWindowAnchor.LEFT).getLength() - 1;
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.LEFT).setLength(length);
                toolWindowManager.getToolWindowBar(ToolWindowAnchor.RIGHT).setLength(length);
            }
        });

        managerDescriptor.setCornerComponent(NORD_WEST, nwButton);
        managerDescriptor.setCornerComponent(SOUTH_WEST, swButton);
        managerDescriptor.setCornerComponent(NORD_EAST, neButton);
        managerDescriptor.setCornerComponent(SOUTH_EAST, seButton);
        initContentManager();
       this.frame.getContentPane().add((Component) toolWindowManager, "2,2,");       
    }

    protected void customizeToolWindowManager(MyDoggyToolWindowManager myDoggyToolWindowManager) {
        ResourceManager resourceManager = myDoggyToolWindowManager.getResourceManager();

        // Add customization here. See the page http://mydoggy.sourceforge.net/mydoggy-plaf/resourceManagerUsing.html
/*
        resourceManager.putProperty("dialog.owner.enabled", "false");
        resourceManager.putProperty("ContentManagerDropTarget.enabled", "true");
*/
       resourceManager.putProperty("ContentManagerUI.ContentManagerUiListener.import", "true");
       resourceManager.putProperty("drag.icon.transparency.enabled", "true");
       resourceManager.putProperty("drag.icon.useDefault", "false");
      resourceManager.putBoolean("drag.toolwindow.asTab", true);
        MyDoggyResourceManager myDoggyResourceManager = (MyDoggyResourceManager) myDoggyToolWindowManager.getResourceManager();
/*
        resourceManager.putColor(MyDoggyKeySpace.TWTB_BACKGROUND_ACTIVE_START, Color.BLUE);
        resourceManager.putColor(MyDoggyKeySpace.TWTB_BACKGROUND_ACTIVE_END, Color.GREEN);
        resourceManager.putColor(MyDoggyKeySpace.TWTB_BACKGROUND_INACTIVE_START, Color.BLACK);
        resourceManager.putColor(MyDoggyKeySpace.TWTB_BACKGROUND_INACTIVE_END, Color.GREEN.darker());
*/

/*
        resourceManager.putColor(MyDoggyKeySpace.TWTB_TAB_FOREGROUND_SELECTED, Color.GREEN);
        resourceManager.putColor(MyDoggyKeySpace.TWTB_TAB_FOREGROUND_UNSELECTED, Color.DARK_GRAY);
*/

/*
        resourceManager.putColor(MyDoggyKeySpace.RAB_BACKGROUND_ACTIVE_START, Color.RED);
        resourceManager.putColor(MyDoggyKeySpace.RAB_BACKGROUND_ACTIVE_END, Color.ORANGE);
*/

/*
        resourceManager.putColor(MyDoggyKeySpace.RAB_FOREGROUND, Color.BLUE);
*/

/*
        myDoggyResourceManager.putComponentUICreator(MyDoggyKeySpace.TOOL_WINDOW_TITLE_BAR_UI,
                                                     new ObjectCreator<ComponentUI>() {
                                                         public ComponentUI create(Context context) {
                                                             return new ToolWindowTitleBarUI(context.get(ToolWindowDescriptor.class) ,
                                                                                             context.get(ToolWindowContainer.class)) {
                                                                 protected void updateToolWindowTitleBar(Graphics g, JComponent c, Color backgroundStart, Color backgroundEnd, Color idBackgroundColor, Color idColor) {
                                                                     Rectangle r = c.getBounds();
                                                                     r.x = r.y = 0;

                                                                     GraphicsUtil.fillRect(g, r,
                                                                                           backgroundStart, backgroundEnd,
                                                                                           null,
                                                                                           GraphicsUtil.LEFT_TO_RIGHT_GRADIENT);

                                                                     if (descriptor.getDockedTypeDescriptor().isIdVisibleOnTitleBar() ||
                                                                         toolWindow.getType() == ToolWindowType.FLOATING ||
                                                                         toolWindow.getType() == ToolWindowType.FLOATING_FREE ||
                                                                         toolWindow.getType() == ToolWindowType.FLOATING_LIVE) {

                                                                         String id = resourceManager.getUserString(descriptor.getToolWindow().getId());
                                                                         r.width = g.getFontMetrics().stringWidth(id) + 8;

                                                                         int halfHeigh = (r.height / 2);
                                                                         GraphicsUtil.fillRect(g, r,
                                                                                               Color.WHITE,
                                                                                               idBackgroundColor,
                                                                                               new Polygon(new int[]{r.x, r.x + r.width - halfHeigh, r.x + r.width - halfHeigh, r.x},
                                                                                                           new int[]{r.y, r.y, r.y + r.height, r.y + r.height},
                                                                                                           4),
                                                                                               GraphicsUtil.LEFT_TO_RIGHT_GRADIENT);


                                                                         Polygon polygon = new Polygon();
                                                                         polygon.addPoint(r.x + r.width - halfHeigh, r.y);
                                                                         polygon.addPoint(r.x + r.width - halfHeigh + 8, r.y + (r.height / 2));
                                                                         polygon.addPoint(r.x + r.width - halfHeigh, r.y + r.height);

                                                                         GraphicsUtil.fillRect(g, r,
                                                                                               Color.WHITE,
                                                                                               idBackgroundColor,
                                                                                               polygon,
                                                                                               GraphicsUtil.LEFT_TO_RIGHT_GRADIENT);

                                                                         g.setColor(idColor);
                                                                         g.drawString(id, r.x + 2, r.y + g.getFontMetrics().getAscent());
                                                                     }
                                                                 }
                                                             };
                                                         }
                                                     });

        myDoggyResourceManager.putInstanceCreator(TitleBarButtons.class,
                                                  new ObjectCreator() {
                                                      public Object create(Context context) {
                                                          return new MenuTitleBarButtons(
                                                                  context.get(ToolWindowDescriptor.class),
                                                                  context.get(ToolWindowContainer.class)
                                                          );
                                                      }
                                                  });
*/

        myDoggyResourceManager.putInstanceCreator(ParentOfQuestion.class, new ObjectCreator() {
            public Object create(Context context) {
                return new CustomParentOfQuestion(context.get(Component.class),
                                                  context.get(ToolWindow.class));
            }
        });


        memoryMonitorDescriptor = new MemoryMonitorDockableDescriptor(myDoggyToolWindowManager, ToolWindowAnchor.TOP);
   
    }

    protected void dispose() {
        frame.setVisible(false);
        frame.dispose();
    }


    public static void main(String[] args) {
       new StarCubeDoggySet();     
    }
    public  void logeo(){            
       
        try {
            Properties prop = new Properties();
            InputStream is = null;
            try {
            is=new FileInputStream(System.getProperty("user.dir")+"\\server.properties");
            prop.load(is);
            } catch(IOException ioe) {
                ioe.printStackTrace();
            }
            String driver = "org.postgresql.Driver";
            String url = "jdbc:postgresql://"+prop.getProperty("server")+"/StarCube";
            System.out.println(url);
            svc = new JDBCLoginService(driver,url);             
            svc.addLoginListener(new MyLoginListener(paneuser));
            paneuser= new JXLoginPane(svc);  
            //paneuser.;
            paneuser.setBanner(createImageIcon("resources/login.jpg"));
            JXLoginPane.showLoginDialog(frame,paneuser);       
            Status status = paneuser.getStatus();
            if (status==Status.SUCCEEDED)
            {   
                try {
                    try{
                        Class.forName("org.postgresql.Driver");
                        con = DriverManager.getConnection(url, paneuser.getUserName(), new String(paneuser.getPassword()));               
                        ps = con.prepareStatement("select * from userolap where rolname=?");                        
                       ps.setString(1,paneuser.getUserName() );
                        rs = ps.executeQuery();
                        if (rs.next())
                        {
                              lookandfeel = rs.getInt("lookandfeel");
                              superuser=rs.getInt("superuser");
                        }    
                       
                        }
                        catch (ClassNotFoundException cnfex)
                        {
                                cnfex.printStackTrace();
                        }
                        catch (SQLException sqlException)
                        {
                                sqlException.printStackTrace();
                        }
                        catch (Exception exception)
                        {
                                exception.printStackTrace();
                        }
                    this.setUp(paneuser.getUserName());
                    this.start(null);
                      
                    } catch (Exception e) {
                    
                }
            }
            else{
                System.exit(0);
            }
        } catch (Exception e) {
            System.err.println("exception when executing interactive tests:");          
        }    
       
       
    }

    private void initContentManager() {
        ContentManager contentManager = toolWindowManager.getContentManager();
        Content content = contentManager.addContent("Table","Starcube Table",
                                                    createIcon("resources/tablet.png"),
                                                    pane1);
                 Content content1 = contentManager.addContent("Graphics","Starcube Graphics",
                                                     createIcon("resources/chartt.png"),                                          
                                                 paneG);
                 
        content.setToolTipText("Starcube Table");
        content1.setToolTipText("Starcube Graphics");        
        setupContentManagerUI();
    }
    
     protected void setupContentManagerUI() {
        ContentManager contentManager = toolWindowManager.getContentManager();      
        MultiSplitContentManagerUI contentManagerUI = new MyDoggyMultiSplitContentManagerUI();
        contentManager.setContentManagerUI(contentManagerUI);        
        contentManagerUI.setShowAlwaysTab(true);
        contentManagerUI.setTabPlacement(TabbedContentManagerUI.TabPlacement.TOP);
        contentManagerUI.addContentManagerUIListener(new ContentManagerUIListener() {
            public boolean contentUIRemoving(ContentManagerUIEvent event) {
                return JOptionPane.showConfirmDialog(frame, "Are you sure?") == JOptionPane.OK_OPTION;            
            }
            public void contentUIDetached(ContentManagerUIEvent event) {             
            }
        });

        TabbedContentUI contentUI = contentManagerUI.getContentUI(toolWindowManager.getContentManager().getContent(0));        
        contentUI.setCloseable(false);
        contentUI.setMinimizable(true);
        contentUI.setDetachable(true);
        contentUI.setTransparentMode(true);
        contentUI.setTransparentRatio(0.7f);
        contentUI.setTransparentDelay(1000);
        contentUI = contentManagerUI.getContentUI(toolWindowManager.getContentManager().getContent(1));
        contentUI.setCloseable(false);
        contentUI.setMinimizable(true);
        contentUI.setDetachable(true);
        contentUI.setTransparentMode(true);
        contentUI.setTransparentRatio(0.7f);
        contentUI.setTransparentDelay(1000);
    }
    

    public class CustomParentOfQuestion implements Question<Component, Boolean> {
        protected Component parent;
        protected ToolWindow toolWindow;

        public CustomParentOfQuestion(Component parent, ToolWindow toolWindow) {
            this.parent = parent;
            this.toolWindow = toolWindow;
        }

        public Boolean getAnswer(Component param) {
            if (param == null)
                return false;

            Component cursor = param;
            while (cursor != null) {
                if ((cursor instanceof JXMonthView && toolWindow.isActive()) || cursor == parent)
                    return true;
                cursor = cursor.getParent();
            }
            return false;
        }

    }

    public static class MemoryMonitorDockableDescriptor extends CustomDockableDescriptor {

        public MemoryMonitorDockableDescriptor(MyDoggyToolWindowManager manager, ToolWindowAnchor anchor) {
            super(manager, anchor);
        }

        public void updateRepresentativeAnchor() {
        }

        public JComponent getRepresentativeAnchor(Component parent) {
            if (representativeAnchor == null)
                representativeAnchor = new MemoryMonitorPanel(anchor);
            return representativeAnchor;
        }


        public class MemoryMonitorPanel extends JPanel {
            int sleepTime;

            public MemoryMonitorPanel(ToolWindowAnchor anchor) {
                sleepTime = 1000;

                final JProgressBar memoryUsage = new JProgressBar();
                memoryUsage.setStringPainted(true);

                JButton gc = new JButton(SwingUtil.loadIcon("org/noos/xing/mydoggy/mydoggyset/icons/gc.png"));
                gc.setBorderPainted(true);
                gc.setFocusable(false);
                gc.setBorder(BorderFactory.createLineBorder(Color.GRAY));
                gc.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        System.gc();
                    }
                });

                Thread memoryThread = new Thread(new Runnable() {
                    public void run() {
                        while (true) {
                            String grabbed = StringUtil.bytes2MBytes(Runtime.getRuntime().totalMemory() - Runtime.getRuntime().freeMemory());
                            String total = StringUtil.bytes2MBytes(Runtime.getRuntime().totalMemory());

                            memoryUsage.setMaximum(Integer.parseInt(total));
                            memoryUsage.setValue(Integer.parseInt(grabbed));

                            memoryUsage.setString(grabbed + " MB of " + total + " MB");
                            try {
                                Thread.sleep(sleepTime);
                            } catch (InterruptedException e) {
                            }
                        }
                    }
                });
                memoryThread.setDaemon(true);
                memoryThread.setPriority(Thread.MIN_PRIORITY);
                memoryThread.start();

                switch (anchor) {
                    case BOTTOM:
                    case TOP:
                        memoryUsage.setOrientation(SwingConstants.HORIZONTAL);
                        setLayout(new TableLayout(new double[][]{{120, 1, 17}, {-1}}));
                        add(memoryUsage, "0,0,FULL,FULL");
                        add(gc, "2,0,FULL,FULL");
                        break;
                    case LEFT:
                        memoryUsage.setOrientation(SwingConstants.VERTICAL);
                        setLayout(new TableLayout(new double[][]{{-1},{120, 1, 17}}));
                        add(memoryUsage, "0,0,FULL,FULL");
                        add(gc, "0,2,FULL,FULL");
                        break;
                    case RIGHT:
                        memoryUsage.setOrientation(SwingConstants.VERTICAL);
                        setLayout(new TableLayout(new double[][]{{-1},{17, 1, 120}}));
                        add(gc, "0,0,FULL,FULL");
                        add(memoryUsage, "0,2,FULL,FULL");
                        break;
                }

                registerDragGesture(memoryUsage);
                registerDragGesture(gc);
                registerDragGesture(this);
            }

            public void setSleepTime(int sleepTime) {
                this.sleepTime = sleepTime;
            }

        }

    }


 
private static Image createImageIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL).getImage();
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
private static ImageIcon createIcon(String path) {
        java.net.URL imgURL = MainApp.class.getResource(path);
        if (imgURL != null) {
            return new ImageIcon(imgURL);
        } else {
            System.err.println("Could not find file: " + path);
            return null;
        }
    }
    

}
