package misc.swing.abeille;

import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;

import javax.swing.ImageIcon;

import org.apache.log4j.Logger;

import com.jeta.open.resources.ResourceLoader;

public class AppResourceLoader implements ResourceLoader {
	private static final Logger logger=Logger.getLogger(AppResourceLoader.class);
	private ClassLoader	classloader;
	private File formFolder;
	private URL urlParent;

	public AppResourceLoader(URL urlParent) {
		this.urlParent=urlParent;		
	}
	public AppResourceLoader(File formFolder) {
		this.formFolder=formFolder;		
	}
	public AppResourceLoader() {
	}

	public ClassLoader getClassLoader() {
		if(classloader==null){
			return getClass().getClassLoader();
		}else{
			return classloader;
		}
	}

	public InputStream getResourceAsStream(String name) throws IOException {
		//InputStream is=getClassLoader().getResourceAsStream(name);
		InputStream is=null;
		if(name!=null){
			if(urlParent!=null && name.indexOf('/')==-1){
				URL url=new URL(urlParent, name);
				is = url.openStream();
			}else if(formFolder==null ){
				is=getClassLoader().getResourceAsStream(name);				
			}else if(formFolder!=null){
				int index=name.lastIndexOf('/');
				if(index>-1){
					name = name.substring(index);
				}
				File f=new File(formFolder, name);
				is= new FileInputStream(f);
			}
		}
		return is;
	}


	public ImageIcon loadImage(String name) {
		File f=null;
		URL url=null;
		try{
			if(urlParent!=null){
				url=new URL(urlParent, name);
			}else if(formFolder==null){
				url=getClassLoader().getResource(name);
			}else{
				f=new File(formFolder, name);
				url=f.toURI().toURL();
			}
			if ( url != null ){
				return new ImageIcon( url );
			}else{
				logger.info("Reader failed. bad file: "+((f!=null)?f.getAbsolutePath():name));
			}
		}catch( Exception e ){
			logger.info(e.getMessage());
		}
		return com.jeta.open.resources.AppResourceLoader.getEmptyIcon();
	}

	public void setClassLoader(ClassLoader classloader) {
		assert(classloader !=null);
		this.classloader=classloader;
	}

}
