package misc.swing.abeille;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import com.jeta.forms.components.panel.FormPanel;
import com.jeta.forms.gui.common.FormException;
import com.jeta.open.registry.JETARegistry;
import com.jeta.open.resources.ResourceLoader;

public class FormLoader {
	public static FormPanel load(File f) throws Exception{
		InputStream is=null;
		try {
			is=new FileInputStream(f);
			com.jeta.forms.defaults.DefaultInitializer.initialize();
			JETARegistry.rebind(ResourceLoader.COMPONENT_ID
					, new AppResourceLoader(f.getParentFile()));
			return new FormPanel(is);
		} catch (FileNotFoundException e) {
			throw e;
		} catch (FormException e) {
			throw e;
		}finally{
			if(is!=null){
				try {is.close();} catch (IOException e1) {}
			}
		}
	}
	public static FormPanel load(String name, ClassLoader classloader) throws Exception{
		ResourceLoader rLoader=new AppResourceLoader();
		ClassLoader classloaderOri=rLoader.getClassLoader();
		rLoader.setClassLoader(classloader);
		try{
			com.jeta.forms.defaults.DefaultInitializer.initialize();
			JETARegistry.rebind(ResourceLoader.COMPONENT_ID
					, rLoader);
			return new FormPanel(name);			
		}finally{
			if(classloaderOri!=null && rLoader!=null){
				rLoader.setClassLoader(classloaderOri);
			}
		}
	}
	public static FormPanel load(String name, URL urlParent, ClassLoader classloader) throws Exception{
		ResourceLoader rLoader=new AppResourceLoader(urlParent);
		ClassLoader classloaderOri=rLoader.getClassLoader();
		rLoader.setClassLoader(classloader);
		try{
			com.jeta.forms.defaults.DefaultInitializer.initialize();
			JETARegistry.rebind(ResourceLoader.COMPONENT_ID
					, rLoader);
			return new FormPanel(name);			
		}finally{
			if(classloaderOri!=null && rLoader!=null){
				rLoader.setClassLoader(classloaderOri);
			}
		}
	}
}
