package misc.swing.border;



import java.awt.BorderLayout;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.ListSelectionModel;
import javax.swing.border.Border;
import misc.swing.border.ui.ListCellRenderer;

/**
*
* @author  f00992x
*/
public class DesingPanel extends JPanel{
	private static final long serialVersionUID = 1L;
	private static final String PREVIEW = "Sample Preview";
	static final String CAPTION = "Border Desing";
	static final String DEFAULT = "DEFAULT";
	static final String CANCEL = "Cancelar";
	static final String ACCEPT = "Aceptar";
	static final String ACTION_EDIT="Edit"; 
	static final String ACTION_REMOVE="Remove"; 
	
	private DefaultListModel listModel=new DefaultListModel();
	private JList listBorder;
	private JLabel lPreview= new JLabel(PREVIEW);
	private DesingPanelUpdater updater;
	private List<JButton> listeners=new ArrayList<JButton>();
	private boolean canceled=false;

	DesingPanel() {
		super(new BorderLayout());
		//listModel.addElement(new BorderInfo(BorderInfo.EMPTY_BORDER));
		listBorder = new JList(listModel);
		listBorder.setCellRenderer(new ListCellRenderer());
		listBorder.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		updater=new DesingPanelUpdater(this);
	}

	/**
	 * @return Returns the listModel.
	 */
	DefaultListModel getListModel() {
		return listModel;
	}

	/**
	 * @return Returns the listBorder.
	 */
	JList getListBorder() {
		return listBorder;
	}

	/**
	 * @return Returns the lPreview.
	 */
	JLabel getLPreview() {
		return lPreview;
	}
	
	/**
	 * @return Returns the canceled.
	 */
	public boolean isCanceled() {
		return canceled;
	}

	/**
	 * @param canceled The canceled to set.
	 */
	void setCanceled(boolean canceled) {
		this.canceled = canceled;
	}

	void updatePreview() {
		Border border=BorderBuider.build(getBordersInfo());
		getLPreview().setBorder(border);
	}
	
	public void dispose(){
		for (Iterator<JButton> iter = listeners.iterator(); iter.hasNext();) {
			iter.next().removeActionListener(updater);
		}
		listeners.clear();
		updater.dispose();
		updater=null;
	}
	
	public void resgisterUpdater(JButton b){
		listeners.add(b);
		b.addActionListener(updater);
	}
	/**
	 * @return Returns the updater.
	 */
	public DesingPanelUpdater getUpdater() {
		return updater;
	}

	/**
	 * @return Returns the selectedBorder.
	 */
	public Border getSelectedBorder() {
		return BorderBuider.build(getBordersInfo());
	}
//
//	/**
//	 * @param selectedBorder The selectedBorder to set.
//	 */
//	public void setSelectedBorder(Border selectedBorder) {
//		this.selectedBorder = selectedBorder;
//	}

	/**
	 * @return Returns the bordersInfo.
	 */
	public BordersInfo getBordersInfo() {
		BordersInfo bordersInfo=new BordersInfo();
		int counter=listModel.getSize();
		for(int i=0; i<counter; i++){
			BorderInfo bInfo=(BorderInfo) listModel.get(i);
			bordersInfo.add(bInfo);
		}
		return bordersInfo;
	}

	/**
	 * @param bordersInfo The bordersInfo to set.
	 */
	public void setBordersInfo(BordersInfo bordersInfo) {
		if(bordersInfo!=null){
			listModel.removeAllElements();
			for(int i=0; i<bordersInfo.size(); i++){
				listModel.addElement(bordersInfo.get(i));
			}
		}
		updatePreview();
		if(listModel.getSize()>0){
			listBorder.setSelectedIndex(0);
		}
	}	
	
}
