package misc.swing.border;



import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.GridLayout;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

/**
*
* @author  f00992x
*/
public class DesingPanelBuild {
	//private static final String SPACE_STRING = " ";
	
	
	private DesingPanelBuild(){
	}
	public static DesingPanel build(){
		return new DesingPanelBuild().buid();
	}
	private DesingPanel buid() {
		DesingPanel desingPanel=new DesingPanel();
		desingPanel.add(createPaneNorth(desingPanel), BorderLayout.NORTH);
		desingPanel.add(createPaneCentre(desingPanel), BorderLayout.CENTER);
		desingPanel.add(createToolBarSouth(desingPanel), BorderLayout.SOUTH);
		
		return desingPanel;
	}
	private JToolBar createToolBarNorth(DesingPanel desingPanel){
		JToolBar bar=new JToolBar();
		bar.setFloatable(false);
		
		JButton b;
		String[] bNames=BorderInfo.getBORDER_NAMES();
		for(int i=0; i<bNames.length;i++){
			b=new JButton(bNames[i]);
			//b=new JButton("    ");
			b.setToolTipText(bNames[i]);
			b.setActionCommand(bNames[i]);
			desingPanel.resgisterUpdater(b);
			b.setFocusable(false);
			b.setRolloverEnabled(true);
			b.setBorder(BorderBuider.build(new BorderInfo(bNames[i])));
			bar.add(b);			
		}
		b=new JButton(DesingPanel.ACTION_EDIT);
		b.setToolTipText(DesingPanel.ACTION_EDIT);
		b.setActionCommand(DesingPanel.ACTION_EDIT);
		desingPanel.resgisterUpdater(b);
		b.setFocusable(false);
		b.setRolloverEnabled(true);
		bar.add(b);
		
		b=new JButton(DesingPanel.ACTION_REMOVE);
		b.setToolTipText(DesingPanel.ACTION_REMOVE);
		b.setActionCommand(DesingPanel.ACTION_REMOVE);
		desingPanel.resgisterUpdater(b);
		b.setFocusable(false);
		b.setRolloverEnabled(true);
		bar.add(b);
		
		return bar;
	}
	private JToolBar createToolBarSouth(DesingPanel desingPanel){
		JToolBar bar=new JToolBar();
		bar.setFloatable(false);
		bar.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
        
		JButton b=new JButton(DesingPanel.CANCEL);
		b.setActionCommand(DesingPanel.CANCEL);
		desingPanel.resgisterUpdater(b);
		b.setRolloverEnabled(true);
		bar.add(b);
        
		b=new JButton(DesingPanel.ACCEPT);
		b.setActionCommand(DesingPanel.ACCEPT);
		desingPanel.resgisterUpdater(b);
		b.setRolloverEnabled(true);
        bar.add(b);
		return bar;
	}
	private JPanel createPaneCentre(DesingPanel desingPanel){
        JPanel pCenter = new JPanel(new BorderLayout());
        JScrollPane scroll = new JScrollPane(desingPanel.getListBorder());
//        Dimension d=listBorder.getPreferredSize();
//        d.width *=2;
//        scroll.setMinimumSize(d);
        pCenter.add(scroll, BorderLayout.WEST);
        pCenter.add(createPreviewPanel(desingPanel.getLPreview()), BorderLayout.CENTER);
		return pCenter;
	}
	private JPanel createPaneNorth(DesingPanel desingPanel){
        JLabel lCaption = new JLabel(DesingPanel.CAPTION);		
		JPanel pNorth=new JPanel(new BorderLayout());
		pNorth.add(lCaption, BorderLayout.NORTH);
		pNorth.add(createToolBarNorth(desingPanel), BorderLayout.SOUTH);
		
		return pNorth;
	}
	
	private JPanel createPreviewPanel(JLabel lSample ){
		int rows=3;
		int cols=3;
		JPanel pSample = new JPanel(new GridLayout(rows, cols));
		for(int i=0; i<rows; i++){
			for(int j=0; j<cols; j++){
				if(i==1 && j==1){
					pSample.add(lSample);
				}else{
					pSample.add(new JLabel());
				}
			}
		}		
		return pSample;
	}
}
