package misc.swing.border;



import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.DefaultListModel;
import javax.swing.JDialog;
import javax.swing.SwingUtilities;
import misc.swing.border.ui.BorderUI;
import misc.swing.border.ui.BorderUIFactory;



/**
*
* @author  f00992x
*/
public class DesingPanelUpdater implements ActionListener{
	private DesingPanel desingPanel;

	DesingPanelUpdater(DesingPanel desingPanel) {
		this.desingPanel = desingPanel;
	}

	public void actionPerformed(ActionEvent e) {
		String ac=e.getActionCommand();
		
		if(isBorderAction(ac)){
			addNewBorder(ac);
		}else if(DesingPanel.ACTION_EDIT.equals(ac)){
			confiSelectedBorder();			
		}else if(DesingPanel.ACTION_REMOVE.equals(ac)){
			deleteBorder();			
		}else if(DesingPanel.CANCEL.equals(ac)){
			cancel();			
		}else if(DesingPanel.ACCEPT.equals(ac)){
			accept();			
		}
		
	}
	private void accept() {
		JDialog fRoot=(JDialog)SwingUtilities
			.getRootPane(desingPanel).getParent();
		desingPanel.dispose();
		//fRoot.hide();
		fRoot.dispose();
	}

	private void cancel() {
		desingPanel.setCanceled(true);
		JDialog fRoot=(JDialog)SwingUtilities
			.getRootPane(desingPanel).getParent();
		desingPanel.dispose();
		//fRoot.hide();
		fRoot.dispose();
	}

	private void deleteBorder() {
		int selected=desingPanel.getListBorder().getSelectedIndex();
		if(selected>-1){
			desingPanel.getListModel().remove(selected--);
			if(selected>0){
				desingPanel.getListBorder().setSelectedIndex(selected);
			}else if (desingPanel.getListModel().getSize()>-1){
				desingPanel.getListBorder().setSelectedIndex(0);
			}
		}		
		updatePreview();
	}
	private void updatePreview() {
		desingPanel.updatePreview();
	}

	private void confiSelectedBorder() {
		int selected=desingPanel.getListBorder().getSelectedIndex();
		if(selected>-1){
			BorderInfo borderInfo=(BorderInfo) desingPanel
				.getListModel().get(selected);
			showBourderUI(borderInfo);
		}		
	}
	private void addNewBorder(String ac) {
		showBourderUI(new BorderInfo(ac));
	}
	private void showBourderUI(final BorderInfo borderInfo){
		final BorderUI borderUI=BorderUIFactory.createBorderUI(borderInfo);
		JDialog fRoot=(JDialog)SwingUtilities
			.getRootPane(desingPanel).getParent();
		final JDialog dialog= new JDialog(fRoot
				,  borderInfo.getName(), true);
		dialog.addWindowListener(new WindowAdapter(){
			public void windowDeactivated(WindowEvent e) {
				if(borderUI.isAcceptDesign()){
					DefaultListModel listModel= desingPanel.getListModel();
					BorderInfo bInfo=borderUI.getBorderInfo();
					if(bInfo==null){
						System.out.println("sin implemnatar");
						bInfo=borderInfo;
					}
					int selected=0;
					if(listModel.contains(borderInfo)){
						selected=desingPanel.getListBorder().getSelectedIndex();
						listModel.remove(selected);
					}
					listModel.add(selected, bInfo);
					desingPanel.getListBorder().setSelectedIndex(selected);
					updatePreview();
					dialog.dispose();
				}
			}
		});				
		dialog.getContentPane().add(borderUI);
		dialog.pack();
		dialog.setLocationRelativeTo(desingPanel);
		dialog.setVisible(true);		
	}
	private boolean isBorderAction(String ac){
		return BorderInfo.isValidName(ac);
	}
	public void dispose(){
		desingPanel=null;
	}
	
}
