package misc.swing.border.ui;



import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import misc.swing.border.BorderInfo;


/**
*
* @author  f00992x
*/
public abstract class BorderUI extends JPanel {
	protected static final String ERR_NULL_BORDER_INFO="borderInfo is null";
	protected boolean acceptDesign=false;
	
	abstract public void setBorderInfo(BorderInfo borderInfo); 
	abstract public BorderInfo getBorderInfo();
	abstract public void hideAccepCancelButtons(boolean hide);
	
	/**
	 * @return Returns the b_Cancel.
	 */
	abstract protected JButton getB_Cancel();

	/**
	 * @return Returns the b_OK.
	 */
	abstract protected JButton getB_OK();
	
	protected void endInitComponents(){
		JButton b =getB_OK();
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				acceptDesign=true;
				hideJDialogParent();
			}
		});
		b =getB_Cancel();
		b.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				hideJDialogParent();
			}
		});		
	}
	protected void hideJDialogParent(){
		JDialog fRoot=(JDialog)SwingUtilities
			.getRootPane(BorderUI.this).getParent();
		//fRoot.hide();
		fRoot.dispose();
	}
	/**
	 * 
	 * @return true si el usuario acepto,
	 */
	public boolean isAcceptDesign(){
		return acceptDesign;
	}
	
	
	///////// Utility
    protected void initCheckBoxColor(final javax.swing.JCheckBox checkBox){
    	checkBox.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(checkBox.isSelected()){
					Color c=null;
					if(checkBox.isBackgroundSet()){
						c=checkBox.getBackground();
					}
					Color newColor=JColorChooser.showDialog(BorderUI.this
							,checkBox.getText(),c);
					if(newColor!=null){
						checkBox.setBackground(newColor);
					}else{
						checkBox.setSelected(false);
					}
				}else{
					checkBox.setBackground(null);
				}				
			}			
		});
    }
    protected void confiCheckBoxColor(javax.swing.JCheckBox checkBox
    		, BorderInfo borderInfo, String key){
        Color color =(Color) borderInfo.get(key);
        checkBox.setSelected(color!=null);
        checkBox.setBackground(color);
    }
    protected void loadBorderInfoColor(javax.swing.JCheckBox checkBox
    		, BorderInfo borderInfo, String key){
    	
		Color color=(checkBox.isBackgroundSet())?checkBox.getBackground():null;
		if(checkBox!=null){
			borderInfo.put(key, color);
		}else{
			borderInfo.remove(key);
		}				
    }
	
}

