package misc.swing.border.ui;

import misc.swing.border.BorderInfo;




/**
*
* @author  f00992x
*/
public class BorderUIFactory {
	private BorderInfo borderInfo;
	
	private BorderUIFactory(BorderInfo borderInfo) {
		super();
		this.borderInfo=borderInfo;
		if(borderInfo==null){
			throw new AssertionError("BorderInfo is null." );
		}
	}
	
	public static BorderUI createBorderUI(BorderInfo borderInfo){
		return new BorderUIFactory(borderInfo).createBorderUI();
	}

	private BorderUI createBorderUI() {
		BorderUI borderUI=null;
		if(BorderInfo.BEVEL_BORDER.equals(borderInfo.getName())){
			borderUI= new BevelBorderUI();
		}else if(BorderInfo.ETCHED_BORDER.equals(borderInfo.getName())){
			borderUI= new EtchedBorderUI();			
		}else if(BorderInfo.LINE_BORDER.equals(borderInfo.getName())){
			borderUI=new LineBorderUI();
		}else if(BorderInfo.EMPTY_BORDER.equals(borderInfo.getName())){
			borderUI=new EmptyBorderUI();
		}else if(BorderInfo.TITLED_BORDER.equals(borderInfo.getName())){
			//borderUI= new TitledBorderUI();
			borderUI=new FullTitledBorderUI();
		}else{
			throw new AssertionError("invalid BorderInfo." );
		}
		borderUI.setBorderInfo(borderInfo);
		return borderUI;
	}
	
}
