package misc.swing.border.ui;




import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.SwingUtilities;
import javax.swing.border.TitledBorder;
import misc.swing.border.BorderInfo;



/**
*
* @author  f00992x
*/
public class FullTitledBorderUI extends BorderUI {
	private static final long serialVersionUID = 1L;
	private BorderUI otherBorderUI;
	private TitledBorderUI titledBorderUI;
	private JComboBox comboBorders;
	
	public FullTitledBorderUI() {
		super();
        initComponents();
        endInitComponents();
	}

	private void initComponents() {
		setLayout(new BorderLayout());
		titledBorderUI=new TitledBorderUI();
		comboBorders=new JComboBox(new BordersComboBoxModel());
		comboBorders.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				JComboBox combo=(JComboBox) e.getSource();
				String value=(String) combo.getSelectedItem();
				if(BorderInfo.BEVEL_BORDER.equals(value)){
					setOtherBorderUI(new BevelBorderUI());
				}else if(BorderInfo.EMPTY_BORDER.equals(value)){
					setOtherBorderUI(new EmptyBorderUI());
				}else if(BorderInfo.ETCHED_BORDER.equals(value)){
					setOtherBorderUI(new EtchedBorderUI());
				}else if(BorderInfo.LINE_BORDER.equals(value)){
					setOtherBorderUI(new LineBorderUI());
				}else{
					setOtherBorderUI(null);
				}
			}			
		});
		comboBorders.setBorder(new TitledBorder("Border:"));
		add(comboBorders, BorderLayout.NORTH);
		add(titledBorderUI, BorderLayout.SOUTH);
	}
	private void setOtherBorderUI(BorderUI borderUI){
		if(otherBorderUI!=null){
			remove(otherBorderUI);
		}
		otherBorderUI= borderUI;
		if(otherBorderUI!=null){
			otherBorderUI.hideAccepCancelButtons(true);
			add(otherBorderUI, BorderLayout.CENTER);
		}
		if(isShowing()){
			Container c = SwingUtilities
				.getRootPane(this ).getParent();
			if(c instanceof JDialog){
				((JDialog)c).pack();
			}
			
		}
	}
	public void setBorderInfo(BorderInfo borderInfo) {
		if(borderInfo!=null){
			titledBorderUI.setBorderInfo(borderInfo);
			BorderInfo bInternal=borderInfo.getInternalBorderInfo();
			comboBorders.setSelectedIndex(0);
			if(bInternal!=null){
				comboBorders.setSelectedItem(bInternal.getName());
				if(otherBorderUI!=null){
					otherBorderUI.setBorderInfo(bInternal);
				}
			}
		}else{
			throw new AssertionError(ERR_NULL_BORDER_INFO);
		}		
	}

	public BorderInfo getBorderInfo() {
		BorderInfo borderInfo=titledBorderUI.getBorderInfo();
		if(otherBorderUI!=null){
			borderInfo.setInternalBorderInfo(otherBorderUI.getBorderInfo());
		}
		return borderInfo;
	}

	public void hideAccepCancelButtons(boolean hide) {
	}

	protected JButton getB_Cancel() {
		return titledBorderUI.getB_Cancel();
	}

	protected JButton getB_OK() {
		return titledBorderUI.getB_OK();
	}

}
class BordersComboBoxModel extends DefaultComboBoxModel{
	private static final long serialVersionUID = 1L;
	/**
	 * Sincronizados con BorderInfo.names
	 */
	private static final String[] sValues={
		"NONE"
		,BorderInfo.BEVEL_BORDER
		,BorderInfo.EMPTY_BORDER
		,BorderInfo.ETCHED_BORDER
		,BorderInfo.LINE_BORDER
		};
	BordersComboBoxModel(){
		super(sValues);
	}
}
