package misc.swing.comboColor;



import java.awt.Color;
import java.util.Collections;
import java.util.SortedMap;
import java.util.TreeMap;

public class ColorsMap {
	
	private ColorsMap() {
		super();
	}


	public static SortedMap<String, Color> build(){
		return new ColorsMap().buildMap();
	}


	private SortedMap<String, Color> buildMap() {
		SortedMap<String, Color> map=new TreeMap<String, Color>(new NamesComparator());
		
		String name=ColorNames.BLACK;
		map.put(name, Color.BLACK);
		
		name=ColorNames.BLUE;
		map.put(name, Color.BLUE);
		
		name=ColorNames.CYAN;
		map.put(name, Color.CYAN);
		
		name=ColorNames.DARK_GRAY;
		map.put(name, Color.DARK_GRAY);
		
		name=ColorNames.GRAY;
		map.put(name, Color.GRAY);
		
		name=ColorNames.GREEN;
		map.put(name, Color.GREEN);
		
		name=ColorNames.LIGHT_GRAY;
		map.put(name, Color.LIGHT_GRAY);
		
		name=ColorNames.MAGENTA;
		map.put(name, Color.MAGENTA);
		
		name=ColorNames.ORANGE;
		map.put(name, Color.ORANGE);
		
		name=ColorNames.PINK;
		map.put(name, Color.PINK);
		
		name=ColorNames.RED;
		map.put(name, Color.RED);
		
		name=ColorNames.WHITE;
		map.put(name, Color.WHITE);
		
		name=ColorNames.YELLOW;
		map.put(name, Color.YELLOW);
		
		name=ColorNames.OTHER;
		map.put(name, null);
		return Collections.unmodifiableSortedMap(map);
	}
}
