package misc.swing.comboColor;



import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.util.Map;

import javax.swing.DefaultListCellRenderer;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.SwingConstants;

public class Renderer extends DefaultListCellRenderer {
	private static final long serialVersionUID = 1L;
	private static final int ICON_SIZE=12;
	private Map<String, Color> map;
	private ComboHandle combohandle;
	private Icon icon;
	private Color iconColor;
	
	
	
	public Renderer() {
		super();
		setVerticalAlignment(SwingConstants.CENTER);
		setVerticalTextPosition(SwingConstants.TOP);
	}
	/**
	 * @param map
	 */
	Renderer(Map<String, Color> map, ComboHandle combohandle) {
		this.map = map;
		this.combohandle=combohandle;
	}
	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		JLabel render = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected,
				cellHasFocus); 
		Icon i=getColorIcon();
		iconColor=map.get(value);
		if(iconColor==null && ColorNames.OTHER.equals(value)
				&& list.getSelectedValue().equals(value)){
			iconColor=combohandle.getSelectedColor();
		}
		render.setIcon(i);
		return render;
	}
	private Icon getColorIcon(){
		if(icon==null){
			icon =new IconImp();
		}
		return icon;
	}
	private class IconImp implements Icon{
		private int width=ICON_SIZE;
		private int height=ICON_SIZE;
		
		public int getIconHeight() {
			return height;
		}

		public int getIconWidth() {
			return height;
		}

		public void paintIcon(Component c, Graphics g, int x, int y) {
			Color cBackUp=g.getColor();
			if(iconColor!=null){
				g.setColor(iconColor);
			}else{
				g.setColor(Color.white);
			}
	        g.fillRect(x + 1, y + 1, width - 2, height - 2);
	        g.setColor(Color.black);
	        g.drawRect(x + 1, y + 1, width - 2, height - 2);
	        g.setColor(cBackUp);
		}
		
	}
}
