package misc.swing.combofont;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.UIManager;

public class HorizontalAlignmentRender extends DefaultListCellRenderer{
	private static final long serialVersionUID = 1L;
	
	public HorizontalAlignmentRender() {
		super();
	}

	/* (non-Javadoc)
	 * @see javax.swing.DefaultListCellRenderer#getListCellRendererComponent
	 * 	(javax.swing.JList, java.lang.Object, int, boolean, boolean)
	 */
	public Component getListCellRendererComponent(JList list, Object value
			, int index, boolean isSelected, boolean cellHasFocus) {
        setComponentOrientation(list.getComponentOrientation());
    	if (isSelected) {
    	    setBackground(list.getSelectionBackground());
    	    setForeground(list.getSelectionForeground());
    	}
    	else {
    	    setBackground(list.getBackground());
    	    setForeground(list.getForeground());
    	}
    	if (value instanceof Integer) {
    		int intValue=((Integer)value).intValue();
    	    switch (intValue) {
			case JLabel.RIGHT:
				setText("Right");
				break;
			case JLabel.LEFT:
				setText("Left");
				break;
			case JLabel.LEADING:
				setText("Leading");
				break;
			case JLabel.TRAILING:
				setText("Trailing");
				break;
			case JLabel.CENTER:
				setText("Center");
				break;

			default:
				setText(value.toString());
			}
    	}
    	else {
    	    setIcon(null);
    	    setText((value == null) ? "" : value.toString());
    	}

    	setEnabled(list.isEnabled());
    	//setFont(list.getFont().deriveFont(index) );
    	setBorder((cellHasFocus) ? 
    			UIManager.getBorder(
    					"List.focusCellHighlightBorder") : noFocusBorder);

    	return this;
	}
}//End class ComboOrientationRender
