package misc.swing.combofont;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.Icon;
import javax.swing.JList;
import javax.swing.UIManager;

public class StyleCellRender extends DefaultListCellRenderer{
	private static final long serialVersionUID = 1L;
	
	public StyleCellRender() {
		super();
	}

	/* (non-Javadoc)
	 * @see javax.swing.DefaultListCellRenderer#getListCellRendererComponent
	 * 	(javax.swing.JList, java.lang.Object, int, boolean, boolean)
	 */
	public Component getListCellRendererComponent(JList list, Object value
			, int index, boolean isSelected, boolean cellHasFocus) {
        setComponentOrientation(list.getComponentOrientation());
    	if (isSelected) {
    	    setBackground(list.getSelectionBackground());
    	    setForeground(list.getSelectionForeground());
    	}
    	else {
    	    setBackground(list.getBackground());
    	    setForeground(list.getForeground());
    	}

    	if (value instanceof Icon) {
    	    setIcon((Icon)value);
    	    setText("");
    	}
    	else {
    	    setIcon(null);
    	    setText((value == null) ? "" : value.toString());
    	}

    	setEnabled(list.isEnabled());
    	setFont(list.getFont().deriveFont(index) );
    	setBorder((cellHasFocus) ? 
    			UIManager.getBorder(
    					"List.focusCellHighlightBorder") : noFocusBorder);

    	return this;
	}
}//End class ComboStyleCellRender