package misc.swing.combofont;

import java.awt.Component;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;
import javax.swing.SwingConstants;
import javax.swing.UIManager;

public class VerticalAlignmentRender extends DefaultListCellRenderer{
	private static final long serialVersionUID = 1L;
	
	public VerticalAlignmentRender() {
		super();
	}

	public Component getListCellRendererComponent(JList list, Object value
			, int index, boolean isSelected, boolean cellHasFocus) {
        setComponentOrientation(list.getComponentOrientation());
    	if (isSelected) {
    	    setBackground(list.getSelectionBackground());
    	    setForeground(list.getSelectionForeground());
    	}
    	else {
    	    setBackground(list.getBackground());
    	    setForeground(list.getForeground());
    	}
    	if (value instanceof Integer) {
    		int intValue=((Integer)value).intValue();
    	    switch (intValue) {
			case SwingConstants.TOP:
				setText("Top");
				break;
			case SwingConstants.CENTER:
				setText("Center");
				break;
			case SwingConstants.BOTTOM:
				setText("Bottom");
				break;

			default:
				setText(value.toString());
			}
    	}
    	else {
    	    setIcon(null);
    	    setText((value == null) ? "" : value.toString());
    	}

    	setEnabled(list.isEnabled());
    	//setFont(list.getFont().deriveFont(index) );
    	setBorder((cellHasFocus) ? 
    			UIManager.getBorder(
    					"List.focusCellHighlightBorder") : noFocusBorder);

    	return this;
	}
}//End class VerticalAlignmentRender
