package misc.swing.degraded;

import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JComponent;
import javax.swing.SwingConstants;
import javax.swing.plaf.basic.BasicLabelUI;

public class DegradedLabelUI extends BasicLabelUI {

	public DegradedLabelUI() {
		super();
	}

	/* (non-Javadoc)
	 * @see javax.swing.plaf.ComponentUI#update(java.awt.Graphics, javax.swing.JComponent)
	 */
	@Override
	public void update(Graphics g, JComponent c) {
		if(c instanceof DegradedLabel){
			DegradedLabel dl=(DegradedLabel) c;
			if(dl.isDegraded()){
				Graphics2D g2 = (Graphics2D) g.create();
				GradientPaint paint;
				switch (dl.getDegradedOrientation()) {
					case SwingConstants.NORTH:
						paint = new GradientPaint(0, 0, dl.getDegradedColor()
									, 0, dl.getHeight(), dl.getMainColor());
						break;
					case SwingConstants.EAST:
						paint = new GradientPaint(0, 0, dl.getMainColor()
								, dl.getWidth(), 0, dl.getDegradedColor());
						break;
					case SwingConstants.SOUTH:
						paint = new GradientPaint(0, dl.getHeight(), dl.getDegradedColor()
								, 0, 0, dl.getMainColor());
						break;
					case SwingConstants.WEST:
						paint = new GradientPaint(dl.getWidth(), 0, dl.getMainColor()
								, 0, 0, dl.getDegradedColor());
						break;
					default:
						throw new UnsupportedOperationException();
				}
				g2.setPaint(paint);
				g2.fillRect(0, 0, dl.getWidth(), dl.getHeight());
				g2.dispose();
			}else if(c.isOpaque()){
			    g.setColor(c.getBackground());
			    g.fillRect(0, 0, c.getWidth(),c.getHeight());
			}
		}else if (c.isOpaque()) {
		    g.setColor(c.getBackground());
		    g.fillRect(0, 0, c.getWidth(),c.getHeight());
		}
		paint(g, c);
	}
	

	
}
