package misc.swing.degraded;

import java.awt.Color;

import misc.xml.ColorXML;
import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Element;



public class DegradedPanelXML {
	public static final String KEY_DEGRADED_PANEL="DegradedPanel";
	public static final String KEY_DEGRADED_PANEL_OPAQUE="DegradedPanelOpaque";	
	public static final String KEY_DEGRADED_PANEL_BACKGROUND="DegradedPanelBackground";
	public static final String KEY_DEGRADED_PANEL_MAIN_COLOR="DegradedPanelMainColor";
	public static final String KEY_DEGRADED_PANEL_DEGRADED="DegradedPanelisDegraded";
	public static final String KEY_DEGRADED_PANEL_ORIENTATION="DegradedPanelOrientation";
	public static final String KEY_DEGRADED_PANEL_DEGRADED_COLOR="DegradedPanelDegradedColor";
	
	
	private DegradedPanel degradedPanel;
	
	private DegradedPanelXML(DegradedPanel degradedPanel) {
		this.degradedPanel=degradedPanel;
	}
	public static Element getConfiguration(DegradedPanel degradedPanel){
		return new DegradedPanelXML(degradedPanel).getConfiguration();
	}
	public static void setConfiguration(DegradedPanel degradedPanel, Element eConfi){
		new DegradedPanelXML(degradedPanel).setConfiguration(eConfi);
	}
	private Element getConfiguration() {
		Element ePanel=new Element(KEY_DEGRADED_PANEL);
		Attribute a=new Attribute(KEY_DEGRADED_PANEL_DEGRADED
				,Boolean.toString(degradedPanel.isDegraded()));
		ePanel.setAttribute(a);
		a=new Attribute(KEY_DEGRADED_PANEL_ORIENTATION
				,Integer.toString(degradedPanel.getDegradedOrientation()));
		ePanel.setAttribute(a);
		
		a=new Attribute(KEY_DEGRADED_PANEL_OPAQUE
				,Boolean.toString(degradedPanel.isOpaque()));
		ePanel.setAttribute(a);
		if (degradedPanel.isOpaque() && degradedPanel.isBackgroundSet()){
			Element eColor=new Element(KEY_DEGRADED_PANEL_BACKGROUND);			
			eColor.addContent(ColorXML
					.getRootElement(degradedPanel.getBackground()));
			ePanel.addContent(eColor);
		}
		Element eColor=new Element(KEY_DEGRADED_PANEL_MAIN_COLOR);
		
		eColor.addContent(ColorXML
				.getRootElement(degradedPanel.getMainColor()));
		ePanel.addContent(eColor);

		Element eDegradedColor=new Element(KEY_DEGRADED_PANEL_DEGRADED_COLOR);
		eDegradedColor.addContent(ColorXML
				.getRootElement(degradedPanel.getDegradedColor()));
		ePanel.addContent(eDegradedColor);
		
		return ePanel;
	}
	private void setConfiguration(Element eConfi) {
		Element ePanel=null;
		if(KEY_DEGRADED_PANEL.equals(eConfi.getName())){
			ePanel=eConfi;
			Attribute a=ePanel.getAttribute(KEY_DEGRADED_PANEL_DEGRADED);
			if(a!=null){
				try {
					degradedPanel.setDegraded(a.getBooleanValue());
				} catch (DataConversionException e) {
				}
			}
			
			a=ePanel.getAttribute(KEY_DEGRADED_PANEL_OPAQUE);
			if(a!=null){
				try {
					degradedPanel.setOpaque(a.getBooleanValue());
				} catch (DataConversionException e) {
				}
			}
			
			a=ePanel.getAttribute(KEY_DEGRADED_PANEL_ORIENTATION);
			if(a!=null){
				try {
					degradedPanel.setDegradedOrientation(a.getIntValue());
				} catch (DataConversionException e) {
				}
			}
			if(ePanel!=null 
					&& ePanel.getChild(KEY_DEGRADED_PANEL_BACKGROUND)!=null ){
				
				Element eColor=ePanel.getChild(KEY_DEGRADED_PANEL_BACKGROUND);
				eColor=eColor.getChild(ColorXML.KEY_COLOR);
				if(eColor!=null){
					Color c=ColorXML.build(eColor);
					degradedPanel.setBackground(c);
				}
			}else{
				degradedPanel.setBackground(null);
			}

			if(ePanel!=null 
					&& ePanel.getChild(KEY_DEGRADED_PANEL_MAIN_COLOR)!=null ){
				
				Element eColor=ePanel.getChild(KEY_DEGRADED_PANEL_MAIN_COLOR);
				eColor=eColor.getChild(ColorXML.KEY_COLOR);
				if(eColor!=null){
					Color c=ColorXML.build(eColor);
					degradedPanel.setMainColor(c);
				}
			}
			if(ePanel!=null && ePanel.getChild(KEY_DEGRADED_PANEL_DEGRADED_COLOR)!=null ){
				Element eDegradedColor=ePanel.getChild(KEY_DEGRADED_PANEL_DEGRADED_COLOR);
				eDegradedColor=eDegradedColor.getChild(ColorXML.KEY_COLOR);
				if(eDegradedColor!=null){
					Color c=ColorXML.build(eDegradedColor);
					degradedPanel.setDegradedColor(c);
				}
			}
		}
	}
}
