package es.aeat.eett.misc.swing.fontChooser;

import java.awt.Component;
import java.awt.Font;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JList;

public class StyleCellRender extends DefaultListCellRenderer {
	private static final long serialVersionUID = 1L;

	public StyleCellRender() {
		super();
	}

	@Override
	public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
		if(value instanceof Integer){
			int iValue=((Integer)value).intValue();
			Font fontRender=null;
			switch (iValue) {
			case Font.PLAIN:
				value=Messages.getString("StyleCellRender.Plain"); //$NON-NLS-1$
				fontRender=new Font(list.getFont().getName(), iValue,list.getFont().getSize());
				break;
			case Font.BOLD:
				value=Messages.getString("StyleCellRender.Bold"); //$NON-NLS-1$
				fontRender=new Font(list.getFont().getName(), iValue,list.getFont().getSize());
				break;
			case Font.ITALIC:
				value=Messages.getString("StyleCellRender.Italic"); //$NON-NLS-1$
				fontRender=new Font(list.getFont().getName(), iValue,list.getFont().getSize());
				break;
			case Font.BOLD|Font.ITALIC:
				value=Messages.getString("StyleCellRender.BoldItalic"); //$NON-NLS-1$
				fontRender=new Font(list.getFont().getName(), iValue,list.getFont().getSize());
				break;

			default:
				value=Messages.getString("StyleCellRender.Unknown"); //$NON-NLS-1$
			}
			if(fontRender!=null){
				list.setFont(fontRender);
			}
		}
		return super.getListCellRendererComponent(list, value, index, isSelected,
				cellHasFocus);
	}
}
