package misc.swing.table;



import java.awt.Color;
import java.awt.Component;
import java.awt.Font;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.table.TableCellRenderer;
import misc.swing.table.settings.Style;
import misc.swing.table.settings.StyleFactory;
import misc.swing.table.settings.Styles;



public class DefaultSpanHeaderCellRenderer extends JLabel implements TableCellRenderer{
	private static final long serialVersionUID = 1L;
	  
	  public DefaultSpanHeaderCellRenderer() {
	    setOpaque(true);
	    setBorder(UIManager.getBorder("TableHeader.cellBorder"));  
	  }

	  public Component getTableCellRendererComponent(JTable table, Object value,
	                 boolean isSelected, boolean hasFocus, int row, int column) {
	    Color foreground = null;
	    Color background = null;
	    Font font = null;
	    //System.out.println("Row: "+row+ " col:"+column);
	    SpanTableHeader header=(SpanTableHeader) table.getTableHeader();
	    Style style=getStyle(header, row, column);
		if(style!=null){
			setForeground((foreground != null) ? foreground 
					  : style.getForeground());
			setBackground((background != null) ? background 
					  : style.getBackground());
			setFont((font != null) ? font : style.getFont());
			//setHorizontalTextPosition(style.getHorizontalTextPosition());
			setHorizontalAlignment(style.getHorizontalAlignment());
		}else{
			setForeground((foreground != null) ? foreground 
					  : header.getForeground());
			setBackground((background != null) ? background 
					  : header.getBackground());
			setFont((font != null) ? font : header.getFont());
			setHorizontalAlignment(header.getHorizontalTextAlignment());
		}
//		String s=(value == null) ? "" : value.toString();
//		System.out.println(s);
	    setValue(value);        
	    return this;
	  }
	    
	  protected void setValue(Object value) {
	    setText((value == null) ? "" : value.toString());
	  }
	  protected Style getStyle(SpanTableHeader header, int row ,int column){
		  Style style=null;
		    try {
			    Span span=header.getSpanModel().getSpanAt(row,column);
			    Styles styles=header.getStyles();
			    if(styles!=null ){
			    	if(span.spanC > 1 && span.spanR > 1){
			    		style=styles.get(StyleFactory.STYLE_SPAN);
			    	}else{
			    		if(row%2==0){
			    			style=styles.get(StyleFactory.STYLE_EVEN);
			    		}else{
			    			style=styles.get(StyleFactory.STYLE_ODD);
			    		}
			    	}
			    }
			} catch (SpanException e) {
			}
			if(style!=null && style.getHorizontalAlignment()!=SwingConstants.CENTER){
				System.out.println("style: "+style.getName()+" :" +style.getHorizontalAlignment());
			}
		 return style; 
	  }

}
