package misc.swing.table;



public class Span {
	
	/**
	 * Si (spanR >0 && spanC > 0)  isCornerLeft spanR guarda el rowSpan
	 * en caso contrario guarda en numero de filas hasta a cornerLeft
	 */
	final int spanR;
	/**
	 * Si (spanR >0 && spanC > 0)  isCornerLeft spanC guarda el colSapn
	 * en caso contrario guarda en numero de columnas hasta a cornerLeft 
	 */
	final int spanC;
	
	public static final Span EMPTY_SPAN=new Span(1,1);
	
	/**
	 * 
	 */
	public Span() {
		this(1,1);
	}
	/**
	 * 
	 * @param spanC
	 * @param spanR
	 */
	public Span(int spanR, int spanC){
		super();
		this.spanR = spanR;
		this.spanC = spanC;
	}
	/**
	 * @return Returns the spanR.
	 */
	public int getSpanR() {
		return spanR;
	}


	/**
	 * @return Returns the spanC.
	 */
	public int getSpanC() {
		return spanC;
	}
	public boolean isCornerLeft(){
		return (spanC>0 && spanR>0);
	}
	public boolean isLineTop(){
		if(isCornerLeft()){
			return true;
		}
		return  spanR==0;
	}
	public boolean isLineLeft(){
		if(isCornerLeft()){
			return true;
		}
		return  spanC==0;
	}
	public boolean isVisible(){
		//return isCornerLeft();
		return (spanC>0 && spanR>0);
	}
	public String toString(){
		String s="";
		if(isCornerLeft()){
				s="  c";
		}else{
			if(isLineTop())s +='t';
			if(isLineLeft())s +='l';
		}
		switch (s.length()) {
		case 0:
			s =".."+s;
			break;
		case 1:
			s ="."+s;
			break;
		}
		s +="[";
		if(spanR>0){
			s +=" "+ spanR;
		}else{
			s += spanR;
		}
		s += ",";
		if(spanC>0){
			s +=" "+ spanC;
		}else{
			s += spanC;
		}
		s +="]";
		
		return s;
	}
}
