package misc.swing.table;



import java.util.EventObject;

import javax.swing.event.TableModelEvent;

public class SpanModelEvent extends EventObject{ //TableModelEvent{ {
	private static final long serialVersionUID = -7524809995630819924L;

	/** Identifies the addtion of new rows or columns. */
    public static final int INSERT =  TableModelEvent.INSERT;
    /** Identifies a change to existing span. */
    public static final int UPDATE =  TableModelEvent.UPDATE;
    /** Identifies the removal of rows or columns. */
    public static final int DELETE = TableModelEvent.DELETE;
    /** Identifies the header row. */
    public static final int HEADER_ROW =TableModelEvent.HEADER_ROW;
    /** Specifies all columns in a row or rows. */
    public static final int ALL_COLUMNS = TableModelEvent.ALL_COLUMNS;


    protected int   type;
    protected int	firstRow;
    protected int	lastRow;
    protected int	column;
    
	/**
	 * @param source
	 */
	public SpanModelEvent(SpanModel source) {
		this(source, 0, Integer.MAX_VALUE, ALL_COLUMNS, UPDATE);
	}
	/**
	 * @param source
	 * @param row
	 */
	public SpanModelEvent(SpanModel source, int row) {
		this(source, row, row, ALL_COLUMNS, UPDATE);
	}
	/**
	 * @param source
	 * @param firstRow
	 * @param lastRow
	 */
	public SpanModelEvent(SpanModel source, int firstRow, int lastRow) {
		this(source, firstRow, lastRow, ALL_COLUMNS, UPDATE);
	}
	/**
	 * @param source
	 * @param firstRow
	 * @param lastRow
	 * @param column
	 */
	public SpanModelEvent(SpanModel source, int firstRow, int lastRow, int column) {
		this(source, firstRow, lastRow, column, UPDATE);
	}
	/**
	 * 
	 * @param source
	 * @param firstRow
	 * @param lastRow
	 * @param column
	 * @param type
	 */
	public SpanModelEvent(SpanModel source, int firstRow, int lastRow, int column, int type) {
		super(source);
		this.firstRow = firstRow;
		this.lastRow = lastRow;
		this.column = column;
		this.type = type;
	}

	
	
	 /** Returns the first row that changed. */
    public int getFirstRow() { return firstRow; };

    /** Returns the last row that changed. */
    public int getLastRow() { return lastRow; };
    
    /**
     *  Returns the column for the event.  If the return
     *  value is ALL_COLUMNS; it means every column in the specified
     *  rows changed.
     */
    public int getColumn() { return column; }; 
    
    /**
     *  Returns the type of event - one of: INSERT, UPDATE and DELETE.
     */
    public int getType() { return type; }
}
