package misc.swing.table.settings;



import java.awt.Color;
import java.awt.Font;

import misc.xml.ColorXML;
import misc.xml.FontXML;
import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Element;


public class SettingXMl {
	public static final String KEY_SETTING="Setting";
	private static final String KEY_IS_HEADER_SETTING="isHeaderSetting";
	private static final String KEY_IS_ROW_HEADER_SETTING="isRowHeaderSetting";
	private static final String KEY_IS_DEFAULT_SETTING="isDefaultSetting";
	private static final String KEY_SHOW_HORIZONTAL_LINES="showHorizontalLines";
	private static final String KEY_SHOW_VERTICAL_LINES="showVerticalLines";
	private static final String KEY_ROW_MARGIN="rowMargin";
	private static final String KEY_COL_MARGIN="colMargin";
	private static final String KEY_HORIZONTAL_LINES_COLOR="horizontalLinesColor";
	private static final String KEY_VERTICAL_LINES_COLOR="verticalLinesColor";
	private static final String KEY_BACKGROUND="background";
	private static final String KEY_FOREGROUND="foreground";
	private static final String KEY_FONT="font";
	private static final String KEY_HORIZONTAL_TEXT_ALIGNMENT="horizontalTextAlignment";

	
	public static Setting build(Element eSetting){
		Setting setting=null;
		if(eSetting!=null && KEY_SETTING.equals(eSetting.getName())){
			Attribute aIsHeaderSetting=eSetting
				.getAttribute(KEY_IS_HEADER_SETTING);
			boolean isHeaderSetting=false;
			if(aIsHeaderSetting!=null){
				try {
					isHeaderSetting=aIsHeaderSetting.getBooleanValue();
				} catch (DataConversionException e) {
				}
			}
			Attribute aIsRowHeaderSetting=eSetting
				.getAttribute(KEY_IS_ROW_HEADER_SETTING);
			boolean isRowHeaderSetting=false;
			if(aIsRowHeaderSetting!=null){
				try {
					isRowHeaderSetting=aIsRowHeaderSetting.getBooleanValue();
				} catch (DataConversionException e) {
				}
			}
			
			setting=new Setting(isHeaderSetting,isRowHeaderSetting);
			Attribute aIsDefaultSetting=eSetting
				.getAttribute(KEY_IS_DEFAULT_SETTING);
			boolean isDefaultSetting=false;
			if(aIsDefaultSetting!=null){
				try {
					isDefaultSetting=aIsDefaultSetting.getBooleanValue();
				} catch (DataConversionException e) {
				}
			}
			if(!isDefaultSetting){
				Attribute aShowHorizontalLines=eSetting
					.getAttribute(KEY_SHOW_HORIZONTAL_LINES);
				if(aShowHorizontalLines!=null){
					try {
						setting.setShowHorizontalLines(
								aShowHorizontalLines.getBooleanValue());
					}catch (DataConversionException e) {
					}
				}
				Attribute aShowVerticalLines=eSetting
					.getAttribute(KEY_SHOW_VERTICAL_LINES);
				if(aShowVerticalLines!=null){
					try {
						setting.setShowVerticalLines(
								aShowVerticalLines.getBooleanValue());
					}catch (DataConversionException e) {
					}
				}
				
				Attribute aRowMargin=eSetting.getAttribute(KEY_ROW_MARGIN);
				if(aRowMargin!=null){
					try {
						setting.setRowMargin(
								aRowMargin.getIntValue());
					}catch (DataConversionException e) {
					}
				}
				
				Attribute aColMargin=eSetting.getAttribute(KEY_COL_MARGIN);
				if(aColMargin!=null){
					try {
						setting.setColumnMargin(
								aColMargin.getIntValue());
					}catch (DataConversionException e) {
					}
				}
				
				Attribute aTextPosition=eSetting
					.getAttribute(KEY_HORIZONTAL_TEXT_ALIGNMENT);
				if(aTextPosition!=null){
					try {
						setting.setHorizontalTextAlignment(
								aTextPosition.getIntValue());
					}catch (DataConversionException e) {
					}catch (RuntimeException e) {
					}
				}
//				Attribute aApplyStyles=eSetting.getAttribute(KEY_APPLY_STYLES);
//					if(aApplyStyles!=null){
//						try {
//							setting.setApplyStyles(
//									aApplyStyles.getBooleanValue());
//						}catch (DataConversionException e) {
//						}
//					}
			
				Element eHorLinColor=eSetting.getChild(KEY_HORIZONTAL_LINES_COLOR);
				Color c=null;
				if(eHorLinColor!=null && eHorLinColor.getChild(ColorXML.KEY_COLOR)!=null){
					c=ColorXML.build(eHorLinColor.getChild(ColorXML.KEY_COLOR));
					if(c!=null){
						setting.setHorizontalLinesColor(c);
					}
				}
				Element eVerLinColor=eSetting.getChild(KEY_VERTICAL_LINES_COLOR);
				c=null;
				if(eVerLinColor!=null && eVerLinColor.getChild(ColorXML.KEY_COLOR)!=null){
					c=ColorXML.build(eVerLinColor.getChild(ColorXML.KEY_COLOR));
					if(c!=null){
						setting.setVerticalLinesColor(c);
					}
				}
				
				Element eBackground=eSetting.getChild(KEY_BACKGROUND);
				if(eBackground!=null && eBackground.getChild(ColorXML.KEY_COLOR)!=null){
					c=ColorXML.build(eBackground.getChild(ColorXML.KEY_COLOR));
					if(c!=null){
						setting.setBackground(c);
					}
				}
				Element eForeground=eSetting.getChild(KEY_FOREGROUND);
				c=null;
				if(eForeground!=null && eForeground.getChild(ColorXML.KEY_COLOR)!=null){
					c=ColorXML.build(eForeground.getChild(ColorXML.KEY_COLOR));
					if(c!=null){
						setting.setForeground(c);
					}
				}
				Element eFont=eSetting.getChild(KEY_FONT);
				Font f=null;
				if(eFont!=null && eFont.getChild(FontXML.KEY_FONT)!=null){
					f=FontXML.build(eFont.getChild(FontXML.KEY_FONT));
					if(f!=null){
						setting.setFont(f);
					}
				}
			}
//			Attribute aStyle=eSetting.getAttribute(KEY_STYLES_FILE);
//			if(setting.isApplyStyles()&& aStyle!=null 
//					&& aStyle.getValue().trim().length()>0){
//				File fParent=Setting.getFoderParent();
//				File f=new File(fParent, aStyle.getValue().trim());
//				if(f.exists() && f.isFile() && !f.isDirectory()){
//					try {
//						Document doc=JDomUtil.read(f,StylesXML.KEY_STYLES);
//						setting.setStylesFile(f);
//						setting.setStyles(
//								StylesXML.build(doc.getRootElement()));
//					} catch (Exception e) {
//						Styles styles=null;
//						if(setting.isHeader()){
//							styles=StylesFactory.createDefaultHeaderStyles();
//						}else{
//							styles=StylesFactory.createDefaultStyles();
//						}
//						setting.setStyles(styles);
//					}
//				}
//			}
		}
		if(setting==null){
			setting=new Setting();
		}
		return setting;
	}
	public static Element getRootElement(Setting setting){
		if(setting!=null){
			Element eSetting=new Element(KEY_SETTING);
			Attribute aIsHeaderSetting=new Attribute(KEY_IS_HEADER_SETTING
					, Boolean.toString(setting.isHeader()));
			eSetting.setAttribute(aIsHeaderSetting);
			
			Attribute aIsRowHeaderSetting=new Attribute(KEY_IS_ROW_HEADER_SETTING
					, Boolean.toString(setting.isRowHeader()));
			eSetting.setAttribute(aIsRowHeaderSetting);
			
			Attribute aIsDefaultSetting=new Attribute(KEY_IS_DEFAULT_SETTING
					, Boolean.toString(setting.isDefaultSetting()));
			eSetting.setAttribute(aIsDefaultSetting);
			if(!setting.isDefaultSetting()){
					Attribute aShowHorizontalLines=
						new Attribute(KEY_SHOW_HORIZONTAL_LINES
								, Boolean.toString(setting.isShowHorizontalLines()));
					eSetting.setAttribute(aShowHorizontalLines);
					
					Attribute aShowVerticalLines=
						new Attribute(KEY_SHOW_VERTICAL_LINES
								, Boolean.toString(setting.isShowVerticalLines()));
					eSetting.setAttribute(aShowVerticalLines);
					
					Attribute aRowMargin=
						new Attribute(KEY_ROW_MARGIN
								, Integer.toString(setting.getRowMargin()));
					eSetting.setAttribute(aRowMargin);
					
					Attribute aColMargin=
						new Attribute(KEY_COL_MARGIN
								, Integer.toString(setting.getColumnMargin() ));
					eSetting.setAttribute(aColMargin);
					
					Attribute aTextPosition=
						new Attribute(KEY_HORIZONTAL_TEXT_ALIGNMENT
								,Integer.toString(setting.getHorizontalTextAlignment()));
					eSetting.setAttribute(aTextPosition);
					
//					Attribute aApplyStyles=new Attribute(KEY_APPLY_STYLES
//							, Boolean.toString(setting.isApplyStyles()));
//					eSetting.setAttribute(aApplyStyles);
					
					Element eBackground= new Element(KEY_BACKGROUND);
					eBackground.addContent(ColorXML
							.getRootElement(setting.getBackground()));
					eSetting.addContent(eBackground);
					
					Element eForeground= new Element(KEY_FOREGROUND);
					eForeground.addContent(ColorXML
							.getRootElement(setting.getForeground()));
					eSetting.addContent(eForeground);
					
					Element eHorLinColor= new Element(KEY_HORIZONTAL_LINES_COLOR);
					eHorLinColor.addContent(ColorXML
							.getRootElement(setting.getHorizontalLinesColor()));
					eSetting.addContent(eHorLinColor);
					
					Element eVerLinColor= new Element(KEY_VERTICAL_LINES_COLOR);
					eVerLinColor.addContent(ColorXML
							.getRootElement(setting.getVerticalLinesColor()));
					eSetting.addContent(eVerLinColor);
					
					Element eFont= new Element(KEY_FONT);
					eFont.addContent(FontXML
							.getRootElement(setting.getFont()));
					eSetting.addContent(eFont);
			}
//			String path=setting.getRelativePath();
//			if(path!=null){
//				Attribute aStylesFile=new Attribute(KEY_STYLES_FILE,path);
//				eSetting.setAttribute(aStylesFile);				
//			}
			return eSetting;
		}else{
			throw new IllegalArgumentException("spanTableSetting is null.");
			//return null;		
		}
	}
}
