package misc.swing.table.settings;

import java.awt.Color;

public class StyleFactory {
	public static final String STYLE_SPAN = "span";
	public static final String STYLE_EVEN = "even";
	public static final String STYLE_ODD = "odd";
	public static final String STYLE_RED = "red";
	public static final String STYLE_YELLOW = "yellow";
	public static final String STYLE_GREEN = "green";
	public static final String STYLE_ROT = "rot";
	public static final String STYLE_GELB = "gelb";
	public static final String STYLE_GRUEN = "gruen";

	public static Color darker(Color c){
		double FACTOR = 0.9;
		return new Color(Math.max((int)(c.getRed()  *FACTOR), 0), 
				 Math.max((int)(c.getGreen()*FACTOR), 0),
				 Math.max((int)(c.getBlue() *FACTOR), 0));			
	}
	public static Style createStyleEven(){
		Style style=new Style(STYLE_EVEN);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createHeaderStyleEven(){
		Style style=new Style(STYLE_EVEN, true);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createRowHeaderStyleEven(){
		Style style=new Style(STYLE_EVEN, true, true);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createStyleOdd(){
		Style style=new Style(STYLE_ODD);
		//style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createHeaderStyleOdd(){
		Style style=new Style(STYLE_ODD, true);		
		//style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createRowHeaderStyleOdd(){
		Style style=new Style(STYLE_ODD, true, true);		
		//style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createStyleSpan(){
		Style style=new Style(STYLE_SPAN);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createHeaderStyleSpan(){
		Style style=new Style(STYLE_SPAN, true);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	public static Style createRowHeaderStyleSpan(){
		Style style=new Style(STYLE_SPAN, true, true);		
		style.setBackground(darker(style.getBackground()));
		return style;
	}
	
	public static Style createStyleRed(){
		Style style=new Style(STYLE_RED);		
		style.setBackground(Color.red);
		return style;
	}
	public static Style createHeaderStyleRed(){
		Style style=new Style(STYLE_RED, true);		
		style.setBackground(Color.red);
		return style;
	}
	public static Style createRowHeaderStyleRed(){
		Style style=new Style(STYLE_RED, true, true);		
		style.setBackground(Color.red);
		return style;
	}

	public static Style createStyleYellow(){
		Style style=new Style(STYLE_YELLOW);		
		style.setBackground(Color.yellow);
		return style;
	}
	public static Style createHeaderStyleYellow(){
		Style style=new Style(STYLE_YELLOW, true);		
		style.setBackground(Color.yellow);
		return style;
	}
	public static Style createRowHeaderStyleYellow(){
		Style style=new Style(STYLE_YELLOW, true, true);		
		style.setBackground(Color.yellow);
		return style;
	}
	public static Style createStyleGreen(){
		Style style=new Style(STYLE_GREEN);		
		style.setBackground(Color.green);
		return style;
	}
	public static Style createHeaderStyleGreen(){
		Style style=new Style(STYLE_GREEN, true);		
		style.setBackground(Color.green);
		return style;
	}
	public static Style createRowHeaderStyleGreen(){
		Style style=new Style(STYLE_GREEN, true);		
		style.setBackground(Color.green);
		return style;
	}

	public static Style createStyleRot(){
		Style style=new Style(STYLE_ROT);		
		style.setBackground(Color.magenta);
		return style;
	}
	public static Style createHeaderStyleRot(){
		Style style=new Style(STYLE_ROT, true);		
		style.setBackground(Color.magenta);
		return style;
	}
	public static Style createRowHeaderStyleRot(){
		Style style=new Style(STYLE_ROT, true, true);		
		style.setBackground(Color.magenta);
		return style;
	}

	public static Style createStyleGelb(){
		Style style=new Style(STYLE_GELB);		
		style.setBackground(Color.blue);
		return style;
	}
	public static Style createHeaderStyleGelb(){
		Style style=new Style(STYLE_GELB, true);		
		style.setBackground(Color.blue);
		return style;
	}
	public static Style createRowHeaderStyleGelb(){
		Style style=new Style(STYLE_GELB, true, true);		
		style.setBackground(Color.blue);
		return style;
	}

	public static Style createStyleGruen(){
		Style style=new Style(STYLE_GRUEN);		
		style.setBackground(Color.cyan);
		return style;
	}
	public static Style createHeaderStyleGruen(){
		Style style=new Style(STYLE_GRUEN, true);		
		style.setBackground(Color.cyan);
		return style;
	}
	public static Style createRowHeaderStyleGruen(){
		Style style=new Style(STYLE_GRUEN, true, true);		
		style.setBackground(Color.cyan);
		return style;
	}

}
