package misc.swing.table.settings;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Styles implements Cloneable{
	private List<Style> list;

	public Styles() {
		super();
		list=new ArrayList<Style>();
	}

	public boolean add(Style style) {
		return list.add(style);
	}

	public void clear() {
		list.clear();
	}

	public boolean contains(Style style) {
		return list.contains(style);
	}

	public Style get(int index) {
		return list.get(index);
	}
	public Style get(String name) {
		if(name!=null){
			int size=size();
			for(int i=0; i<size; i++){
				if(name.equalsIgnoreCase(get(i).getName())){
					return get(i);
				}
			}
		}
		return null;
	}

	public boolean isEmpty() {
		return list.isEmpty();
	}

	public Iterator<Style> iterator() {
		return list.iterator();
	}

	public Style remove(int index) {
		return list.remove(index);
	}
	public Style remove(String name){
		if(name!=null){
			int size=size();
			for(int i=0; i<size; i++){
				Style style= get(i);
				if(name.equals(style.getName())){
					list.remove(i);
					return style;
				}
			}
		}
		return null;
	}

	public boolean remove(Style style) {
		return list.remove(style);
	}

	public int size() {
		return list.size();
	}
	
	public boolean equals(Object obj) {
		if(this==obj){
			return true;
		}
		if(obj instanceof Styles){
			Styles styles=(Styles)obj;
			int size=size();
			if(size==styles.size()){
				for(int i=0; i<size; i++){
					Style style=get(i);
					if( !style.equals(styles.get(style.getName()))){
						return false;
					}
				}
				return true;
			}
		}
		return false;
	}
	
	public Object clone(){
		Styles styles=new Styles();
		int size=size();
		for(int i=0; i<size; i++){
			styles.add((Style) get(i).clone());
		}
		return styles;
	}
	
}
