package misc.swing.table.settings;



import java.io.File;

import misc.util.JDomUtil;
import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Document;
import org.jdom.Element;



public class TableSettingXML {
	public static final String KEY_TABLE_SETTING="SettingTable";
	public static final String KEY_DATA_SETTING="DataSetting";
	public static final String KEY_HEADER_SETTING="HeaderSetting";
	public static final String KEY_ROW_HEADER_SETTING="RowHeaderSetting";
	private static final String KEY_STYLES_FILE="stylesFile";
	private static final String KEY_APPLY_STYLES="ApplyStyles";

	public static TableSetting build(Element eTableSetting){
		TableSetting tableSetting=new TableSetting();
		tableSetting.setTableStyles(new TableStyles());
		if(eTableSetting!=null && KEY_TABLE_SETTING.equals(eTableSetting.getName())){
			//dataSetting
			Element eDataSetting=eTableSetting.getChild(KEY_DATA_SETTING);
			Element eSetting=null;
			if(eDataSetting!=null){
				eSetting=eDataSetting.getChild(SettingXMl.KEY_SETTING);
			}
			if(eSetting!=null){
				try {
					Setting setting=SettingXMl.build(eSetting);
					tableSetting.setDataSetting(setting);
				} catch (RuntimeException e) {
				}
				eSetting=null;
			}
			//header
			Element eHeaderSetting=eTableSetting.getChild(KEY_HEADER_SETTING);
			if(eHeaderSetting!=null){
				eSetting=eHeaderSetting.getChild(SettingXMl.KEY_SETTING);
			}
			if(eSetting!=null){
				try {
					Setting setting=SettingXMl.build(eSetting);
					tableSetting.setHeaderSetting(setting);
				} catch (RuntimeException e) {
				}
				eSetting=null;
			}
			Element  eRowHeaderSetting=eTableSetting.getChild(KEY_ROW_HEADER_SETTING);
			if(eRowHeaderSetting!=null){
				eSetting=eRowHeaderSetting.getChild(SettingXMl.KEY_SETTING);
			}
			if(eSetting!=null){
				try {
					Setting setting=SettingXMl.build(eSetting);
					tableSetting.setRowHeaderSetting(setting);
				} catch (RuntimeException e) {
				}
			}
			Attribute aApplyStyles=eTableSetting.getAttribute(KEY_APPLY_STYLES);
			if(aApplyStyles!=null){
				try {
					tableSetting.setApplyStyles(
							aApplyStyles.getBooleanValue());
				}catch (DataConversionException e) {
				}
			}
			Attribute aStylesFile=eTableSetting.getAttribute(KEY_STYLES_FILE);
			if(tableSetting.isApplyStyles()&& aStylesFile!=null 
					&& aStylesFile.getValue().trim().length()>0){
				File fParent=TableSetting.getFoderParent();
				File f=new File(fParent, aStylesFile.getValue().trim());
				if(f.exists() && f.isFile() && !f.isDirectory()){
					try {
						Document doc=JDomUtil.read(f,TableStylesXML.TABLE_STYLES);
						tableSetting.setStylesFile(f);
						tableSetting.setTableStyles(
								TableStylesXML.build(doc.getRootElement()));
					} catch (Exception e) {
						tableSetting.setTableStyles(new TableStyles());
					}
				}
			}else if(tableSetting.isApplyStyles()){
				tableSetting.setTableStyles(new TableStyles());
			}
		}
		return tableSetting;
	}
	public static Element getRootElement(TableSetting tableSetting){
		if(tableSetting!=null){
			Element eTableSetting=new Element(KEY_TABLE_SETTING);
			String path=tableSetting.getRelativePath();
			//if(tableSetting.isApplyStyles() && path!=null){
			if( path!=null){
				Attribute aStylesFile=new Attribute(KEY_STYLES_FILE,path);
				if(aStylesFile!=null){
					eTableSetting.setAttribute(aStylesFile);
					return eTableSetting;
				}
			}
			Element eDataSetting=new Element(KEY_DATA_SETTING);
			eDataSetting.addContent(SettingXMl.getRootElement(
					tableSetting.getDataSetting()));
			eTableSetting.addContent(eDataSetting);
			
			Element eHeaderSetting=new Element(KEY_HEADER_SETTING);
			eHeaderSetting.addContent(SettingXMl.getRootElement(
					tableSetting.getHeaderSetting()));
			eTableSetting.addContent(eHeaderSetting);
			
			Element eRowHeaderSetting=new Element(KEY_ROW_HEADER_SETTING);
			eRowHeaderSetting.addContent(SettingXMl.getRootElement(
					tableSetting.getRowHeaderSetting()));
			eTableSetting.addContent(eRowHeaderSetting);
			
			
			Attribute aApplyStyles=new Attribute(KEY_APPLY_STYLES
					, Boolean.toString(tableSetting.isApplyStyles()));
			eTableSetting.setAttribute(aApplyStyles);
			
			return eTableSetting;
		}else{
			//throw new IllegalArgumentException("spanTableSetting is null.");
			return null;
		}
	}
	
}
