package misc.swing.table.settings;



public class TableStyles implements Cloneable{
	
	private Styles headerStyles;
	private Styles rowHeaderStyles;
	private Styles dataStyles;

	/**
	 * 
	 * @param headerStyles
	 * @param dataStyles
	 * @param rowHeaderStyles
	 */
	public TableStyles(Styles headerStyles, Styles dataStyles, Styles rowHeaderStyles) {
		initStyles(headerStyles, dataStyles, rowHeaderStyles);
	}
	/**
	 * @param headerStyles
	 * @param dataStyles
	 */
	public TableStyles(Styles headerStyles, Styles dataStyles) {
		this(headerStyles, dataStyles, null);
	}
	public TableStyles(){
		this(null,null, null);
	}
	private void initStyles(Styles headerStyles
			, Styles dataStyles, Styles rowHeaderStyles){
		if(headerStyles!=null){
			this.headerStyles = headerStyles;
		}else{
			this.headerStyles=StylesFactory.createDefaultHeaderStyles();
		}
		if(dataStyles!=null){
			this.dataStyles = dataStyles;
		}else{
			this.dataStyles=StylesFactory.createDefaultStyles();
		}
		if(rowHeaderStyles!=null){
			this.rowHeaderStyles = rowHeaderStyles;
		}else{
			this.rowHeaderStyles=StylesFactory.createDefaultRowHeaderStyles();
		}
	}
	/**
	 * @return Returns the headerStyles.
	 */
	public Styles getHeaderStyles() {
		return headerStyles;
	}
	/**
	 * @param headerStyles The headerStyles to set.
	 */
	public void setHeaderStyles(Styles headerStyles) {
		if(headerStyles==null){
			throw new IllegalArgumentException("headerStyles is null");
		}else{
			this.headerStyles = headerStyles;
		}
	}
	
	/**
	 * @return Returns the rowHeaderStyles.
	 */
	public Styles getRowHeaderStyles() {
		return rowHeaderStyles;
	}
	/**
	 * @param rowHeaderStyles The rowHeaderStyles to set.
	 */
	public void setRowHeaderStyles(Styles rowHeaderStyles) {
		this.rowHeaderStyles = rowHeaderStyles;
	}
	/**
	 * @return Returns the dataStyles.
	 */
	public Styles getDataStyles() {
		return dataStyles;
	}
	/**
	 * 
	 * @param stylesTable
	 */
	public void setDataStyles(Styles stylesTable) {
		if(stylesTable==null){
			throw new IllegalArgumentException("dataStyles is null");
		}else{
			this.dataStyles = stylesTable;			
		}
	}
	public Object clone(){
		return new TableStyles(
				(Styles)headerStyles.clone()
				, (Styles)dataStyles.clone()
				, (Styles)rowHeaderStyles.clone()
				);
	}
	
}
