package misc.swing.table.settings;



import java.io.File;

import misc.util.JDomUtil;
import org.jdom.Document;
import org.jdom.Element;



public class TableStylesXML {
	public static final String TABLE_STYLES="TableStyles";
	private static final String DATA_STYLE="DataStyle";
	private static final String HEADER_STYLES="HeaderStyles";
	private static final String ROW_HEADER_STYLES="RowHeaderStyles";
	
	public static TableStyles build(Element eTableStyles){
		TableStyles tableStyles=new TableStyles();
		if(eTableStyles!=null && TABLE_STYLES.equals(eTableStyles.getName())){
			Element eTableStyle=eTableStyles.getChild(DATA_STYLE);
			if(eTableStyle!=null){
				eTableStyle=eTableStyle.getChild(StylesXML.KEY_STYLES);
				Styles styles=StylesXML.build(eTableStyle);	
				if(styles!=null){
					int size=styles.size();
					for(int i=0; i<size; i++){
						Style style=styles.get(i);
						tableStyles.getDataStyles().remove(style.getName());
						tableStyles.getDataStyles().add(style);
					}
				}
			}
			//header
			Element eHeaderStyle=eTableStyles.getChild(HEADER_STYLES);
			if(eHeaderStyle!=null){
				eHeaderStyle=eHeaderStyle.getChild(StylesXML.KEY_STYLES);
				Styles styles=StylesXML.build(eHeaderStyle);			
				if(styles!=null){
					int size=styles.size();
					for(int i=0; i<size; i++){
						Style style=styles.get(i);
						tableStyles.getHeaderStyles().remove(style.getName());
						tableStyles.getHeaderStyles().add(style);
					}
				}
			}
			//RowHeaderStyles
			Element eRowHeaderStyle=eTableStyles.getChild(ROW_HEADER_STYLES);
			if(eRowHeaderStyle!=null){
				eRowHeaderStyle=eRowHeaderStyle.getChild(StylesXML.KEY_STYLES);
				Styles styles=StylesXML.build(eRowHeaderStyle);			
				if(styles!=null){
					int size=styles.size();
					for(int i=0; i<size; i++){
						Style style=styles.get(i);
						tableStyles.getRowHeaderStyles().remove(style.getName());
						tableStyles.getRowHeaderStyles().add(style);
					}
				}
			}
		}
		return tableStyles;
	}
	public static TableStyles build(File f){
		TableStyles tableStyles=new TableStyles();
		try {
			Document doc=JDomUtil.read(f,TABLE_STYLES);
			tableStyles=build(doc.getRootElement());
		} catch (Exception e) {
		}
		return tableStyles;
	}
	public static Element getRootElement(TableStyles tableStyles){
		if(tableStyles!=null){
			Element eTableStyles=new Element(TABLE_STYLES);
			Element eTableStyle=new Element(DATA_STYLE);
			Element eHeaderStyle=new Element(HEADER_STYLES);
			Element eRowHeaderStyle=new Element(ROW_HEADER_STYLES);
			
			eTableStyle.addContent(StylesXML.getRootElement
					(tableStyles.getDataStyles()));
			
			eHeaderStyle.addContent(StylesXML.getRootElement
					(tableStyles.getHeaderStyles()));
			
			eRowHeaderStyle.addContent(StylesXML.getRootElement
					(tableStyles.getRowHeaderStyles()));
			
			eTableStyles.addContent(eTableStyle);
			eTableStyles.addContent(eHeaderStyle);
			eTableStyles.addContent(eRowHeaderStyle);
			return eTableStyles;
		}
		return null;
	}
}
