package misc.util;

/*
 * Created on 03-jun-2005
 *
 * JDomUtil.java
 *
 */


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;


/**
 * @author f00992
 * <p>
 * en:
 * JDom utilities
 * </p>
 * 
 * <p>
 * es:
 * Utilidades para JDom. 
 * </p>
 */
public class JDomUtil {
    private static final String NEW_LINE=System.getProperty("line.separator");
	private static final String ISO_8859_1="ISO-8859-1";


    private JDomUtil() {
    }
	public static Document read(String nameFile, String nameElementRoot) throws Exception {

	    SAXBuilder builder = new SAXBuilder();
	    try {
	        Document doc = builder.build(nameFile);
	        if(nameElementRoot!=null){
	            Element root = doc.getRootElement();
	            if (! nameElementRoot.equals(root.getName()))
	                throw new Exception(nameFile + NEW_LINE+"The root element is no valid."  );
	        }
	        return doc;  //Fichero valido
	    }
	    catch (JDOMException e) {  //  fichero NO valido.
	        throw new Exception(nameFile + "is no valid.",e );
	    }
	    catch (IOException e) { // Error de entrada: No se pudo abrir el fichero.
	        throw new Exception( "unable open: "+ NEW_LINE+ nameFile, e );
	    }
	}
	public static Document read (File file, String nameElementRoot) throws Exception {
	    SAXBuilder builder = new SAXBuilder();
	    try {
	        Document doc = builder.build(file);
	        if(nameElementRoot!=null){
	            Element root = doc.getRootElement();
	            if (! nameElementRoot.equals(root.getName()))
	                throw new Exception(file.getAbsolutePath() + NEW_LINE+ "El elemento raiz no es valido."  );
	        }
	        return doc;  //Fichero valido
	    }
	    catch (JDOMException e) {  //  fichero NO valido.
	    	throw new Exception(file.getAbsolutePath() +  NEW_LINE+ "is no valid.",e );
	    }
	    catch (IOException e) { // Error de entrada: No se pudo abrir el fichero.
	    	throw new Exception( "unable open: "+ NEW_LINE+ file.getAbsolutePath() , e );
	    }
	}
	public static Document read (String nameFile) throws Exception {

	    SAXBuilder builder = new SAXBuilder();
	    try {
	        Document doc = builder.build(nameFile);
	        return doc;  //Fichero valido
	    }
	    catch (JDOMException e) {  //  fichero NO valido.
	        throw new Exception(nameFile + "is no valid.",e );
	    }
	    catch (IOException e) { // Error de entrada: No se pudo abrir el fichero.
	        throw new Exception( "unable open: "+ nameFile , e );
	    }
	}
	public static Document read (File file) throws Exception {

	    SAXBuilder builder = new SAXBuilder();
	    try {
	        Document doc = builder.build(file);
	        return doc;  //Fichero valido
	    }
	    catch (JDOMException e) {  //  fichero NO valido.
	    	//e.printStackTrace();
	        throw new Exception(file.getAbsolutePath() + " is no valid.",e );
	    }
	    catch (IOException e) { // Error de entrada: No se pudo abrir el fichero.
	        throw new Exception( " unable open: "+ file.getAbsolutePath() , e );
	    }
	}

	public static void write(Document doc, String nameFile) throws IOException{
		PrintWriter writer=null;
		try{
			Format format=Format.getPrettyFormat();
			format.setEncoding(ISO_8859_1);
			XMLOutputter outputter = new XMLOutputter();
			outputter.setFormat(format);
			writer = new PrintWriter(new FileWriter(nameFile));
			outputter.output(doc, writer);
		}finally{
			if(writer!=null)	writer.close();
		}
	}
	public static void write(Document document, File file) throws IOException{
		PrintWriter writer=null;
		try{
	        Format format=Format.getPrettyFormat();
	        format.setEncoding(ISO_8859_1);
	        XMLOutputter outp = new XMLOutputter(format);
	        writer= new PrintWriter(new FileWriter(file));
	        outp.output(document, writer);
		}finally{
			if(writer!=null)
				writer.close();
		}
    }
	public static String getString(Document document) throws IOException{
		PrintWriter writer=null;
		try{
			Format format=Format.getPrettyFormat();
			XMLOutputter outp = new XMLOutputter(format);
			StringWriter sw=new StringWriter();
			writer= new PrintWriter(sw);
			outp.output(document, writer);

			return sw.toString();
		}finally{
			if(writer!=null)
				writer.close();
		}
	}

}
