package misc.xml;




import java.awt.Color;

import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Element;

public class ColorXML {
	public static final String KEY_COLOR="Color";
	static final String KEY_RED="red";
	static final String KEY_GREEN="green";
	static final String KEY_BLUE="blue";
	static final String KEY_ALPHA="Alpha";
	
	ColorXML() {
		super();
	}
	
	public static Color build(Element eColor){
		Color color=null;
    	if(eColor!=null && KEY_COLOR.equals(eColor.getName())){
        	int r, g, b;
        	int alpha=255;
        	Attribute a= eColor.getAttribute(KEY_RED);
        	try {
    			r=a.getIntValue();
    		} catch (DataConversionException e) {
    			r=0;
    		}
    		a= eColor.getAttribute(KEY_GREEN);
        	try {
    			g=a.getIntValue();
    		} catch (DataConversionException e) {
    			g=0;
    		}
    		a= eColor.getAttribute(KEY_BLUE);
        	try {
    			b=a.getIntValue();
    		} catch (DataConversionException e) {
    			b=0;
    		}
    		a= eColor.getAttribute(KEY_ALPHA);
    		if(a!=null){
	        	try {
	        		alpha=a.getIntValue();
	    		} catch (DataConversionException e) {
	    		}
    		}
        	return new Color(r,g,b, alpha);
    	}
    	return color;
	}
	public static Element getRootElement(Color color){
		Element eRoot=null;
		if(color!=null){
	    	eRoot= new Element(KEY_COLOR);
	    	Attribute aRed=new Attribute(KEY_RED
	    			, Integer.toString(color.getRed()));
	    	eRoot.setAttribute(aRed);
	    	Attribute aGreen=new Attribute(KEY_GREEN
	    			, Integer.toString(color.getGreen()));
	    	eRoot.setAttribute(aGreen);
	    	Attribute aBlue=new Attribute(KEY_BLUE
	    			, Integer.toString(color.getBlue()));
	    	eRoot.setAttribute(aBlue);
	    	Attribute aAlpha=new Attribute(KEY_ALPHA
	    			, Integer.toString(color.getAlpha()));
	    	eRoot.setAttribute(aAlpha);
		}
    	return eRoot;
	}
//	public Document getDocument(Campo campo){
//		return new Document(getRootElement(campo));
//	}
	
}
