package misc.xml;



import java.awt.Font;

import org.jdom.Attribute;
import org.jdom.DataConversionException;
import org.jdom.Element;

public class FontXML {
	public static final String KEY_FONT="Font";
	static final String KEY_FONT_NAME="FontName";
	static final String KEY_FONT_SIZE="FontSize";
	static final String KEY_FONT_IS_BOLD="isBold";
	static final String KEY_FONT_IS_ITALIC="isItalic";
	
	FontXML() {
		super();
	}
	
	public static Font build(Element eFont){
    	Font font=null;
    	if(eFont!=null && KEY_FONT.equals(eFont.getName())){
	    	Attribute a= eFont.getAttribute(KEY_FONT_NAME);
	    	String fontName=a.getValue();
	    	a=eFont.getAttribute(KEY_FONT_SIZE);
	    	int size=12;
	    	try {
				size=a.getIntValue();
			} catch (DataConversionException e) {
			}
			boolean bold=false;
			boolean italic=false;
			a=eFont.getAttribute(KEY_FONT_IS_BOLD);
			try {
				bold=a.getBooleanValue();
			} catch (DataConversionException e1) {
			}
			a=eFont.getAttribute(KEY_FONT_IS_ITALIC);
			try {
				italic=a.getBooleanValue();
			} catch (DataConversionException e2) {
			}
			int style=(bold)? Font.BOLD:Font.PLAIN;
			if(italic)
				style=style|Font.ITALIC;
			font= new Font(fontName,style, size);
    	}
    	return font;
	}
	public static Element getRootElement(Font font){
		if(font!=null){
	    	Element eRoot= new Element(KEY_FONT);
	    	Attribute aFontName=new Attribute(KEY_FONT_NAME, font.getName());
	    	eRoot.setAttribute(aFontName);
	    	Attribute aFontSize=new Attribute(KEY_FONT_SIZE
	    			, Integer.toString(font.getSize()));
	    	eRoot.setAttribute(aFontSize);
	    	Attribute aisBold=new Attribute(KEY_FONT_IS_BOLD
	    			, Boolean.toString(font.isBold()));
	    	eRoot.setAttribute(aisBold);
	    	Attribute aisItalic=new Attribute(KEY_FONT_IS_ITALIC
	    			, Boolean.toString(font.isItalic()));
	    	eRoot.setAttribute(aisItalic);
	    	return eRoot;
		}
		return null;
	}
//	public Document getDocument(Campo campo){
//		return new Document(getRootElement(campo));
//	}
	
}
